// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include <string.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#define MAXTILES 4096

static char *pic;
static long artversion;
static long numtiles;
static long localtilestart;
static long localtileend;
static short tilesizx[MAXTILES];
static short tilesizy[MAXTILES];
static long picanm[MAXTILES];
static long waloff[MAXTILES];

static long tilesperfile;

main()
{
	char filename[20];
	long i, j, k;

	printf("Converting art version 0 to version 1...\n");
	printf("How many tiles do you want per TILES###.ART file?\n");
	printf("My suggestions are 64, 128, 256, or 512.\n");
	printf("(they don't have to be powers of 2 - no slowdown)\n");
	scanf("%ld",&tilesperfile);
	printf("You chose %ld tiles per file\n",tilesperfile);

	loadpics("tiles.art");

	artversion = 1L;

	k = 0;
	for(i=0;i<numtiles;i+=tilesperfile)
	{
		j = i+tilesperfile-1;
		if (j >= MAXTILES)
			j = MAXTILES-1;
		strcpy(filename,"tiles000.art");
		filename[7] = (k%10)+48;
		filename[6] = ((k/10)%10)+48;
		filename[5] = ((k/100)%10)+48;
		savepics(filename,i,j);
		k++;
	}
}


loadpics(char filename[20])
{
	long totpicsiz, offscount, siz;
	short int fil, i, j;

	if ((fil = open(filename,O_BINARY|O_RDONLY,S_IREAD)) == -1)
		return(-1);
	read(fil,&artversion,4);
	if (artversion != 0L) return(-1);
	read(fil,&numtiles,4);
	read(fil,&tilesizx[0],numtiles<<1);
	read(fil,&tilesizy[0],numtiles<<1);
	read(fil,&picanm[0],numtiles<<2);

	for(i=numtiles;i<MAXTILES;i++)
	{
		tilesizx[i] = 0;
		tilesizy[i] = 0;
		picanm[i] = 0L;
	}

	totpicsiz = 0L;
	for(i=0;i<numtiles;i++)
		totpicsiz += (long)(tilesizx[i]*tilesizy[i]);

	pic = (char *)malloc(totpicsiz);
	offscount = 0L;
	for(i=0;i<MAXTILES;i++)
	{
		waloff[i] = offscount+FP_OFF(pic);
		siz = tilesizx[i]*tilesizy[i];
		if (siz > 0)
		{
			read(fil,&pic[offscount],siz);
			offscount += siz;
		}
	}
	close(fil);
	return(0);
}

savepics(char filename[20], long localtilestart, long localtileend)
{
	long templong, offscount, siz;
	short int fil, i;

	if (localtilestart > localtileend)
		return(0);

	numtiles = 4095L;
	while ((tilesizx[numtiles] < 2) && (tilesizy[numtiles] < 2) && (numtiles > 0))
		numtiles--;
	numtiles++;

	if (localtilestart >= MAXTILES)
		return(0);
	if (localtileend >= MAXTILES)
		localtileend = MAXTILES-1;

	if ((fil = open(filename,O_BINARY|O_CREAT|O_TRUNC|O_WRONLY,S_IWRITE))==-1)
		return(-1);
	write(fil,&artversion,4);
	write(fil,&numtiles,4);
	write(fil,&localtilestart,4);
	write(fil,&localtileend,4);
	write(fil,&tilesizx[localtilestart],(localtileend-localtilestart+1)<<1);
	write(fil,&tilesizy[localtilestart],(localtileend-localtilestart+1)<<1);
	write(fil,&picanm[localtilestart],(localtileend-localtilestart+1)<<2);

	offscount = 0L;
	for(i=0;i<localtilestart;i++)
		offscount += tilesizx[i]*tilesizy[i];
	for(i=localtilestart;i<=localtileend;i++)
	{
		siz = tilesizx[i]*tilesizy[i];
		if (siz > 0)
		{
			if (write(fil,&pic[offscount],siz) < siz)
				printf("SAVE UNSUCCESSFUL!\n");
			offscount += siz;
		}
	}
	close(fil);
	return(0);
}
