// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#define ENGINE
#include <string.h>
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>
#include <i86.h>
#include "build.h"
#include "pragmas.h"

#define MAXCLIPNUM 512
#define MAXTILEFILES 256
#define MAXYSAVES (MAXXDIM*MAXSPRITES)>>6
#define MAXWALLSB 4096
#define MAXCLIPDIST 1024

static char moustat = 0;

long chainplace, chainsiz, chainnumpages = 0;  //Vidoption 0 only
char vesapageshift, curpag, tsengdriver = 0;   //Vidoption 1 only
long page;                                     //Vidoption 2-4 only

static long ooption0, stereopage, stereofps = 0;
static long stereowidth, stereopixelwidth;
static long curbrightness = 0;

	//Textured Map variables
static char globalpolytype;
static short doti[MAXYDIM*16], *dotp[MAXYDIM];

static unsigned char tempbuf[MAXWALLS];

long artversion, mapversion;
char *pic = NULL;
char picsiz[MAXTILES], tilefilenum[MAXTILES];
long walsiz[MAXTILES], tilefileoffs[MAXTILES];

long artsize = 0, cachesize = 0;
//static long cachelistplc, cachelistend, cacheplc;
//static long cachelist[MAXTILES], cachelistoffs[MAXTILES];

static short radarang[321], radarang2[MAXXDIM];
static long tantable[1024], sqrtable[2048];
static char britable[16][64];
char textfont[1024], smalltextfont[1024];

static long xb1[MAXWALLSB], yb1[MAXWALLSB], xb2[MAXWALLSB], yb2[MAXWALLSB];
static long rx1[MAXWALLSB], ry1[MAXWALLSB], rx2[MAXWALLSB], ry2[MAXWALLSB];
static short p2[MAXWALLSB], thesector[MAXWALLSB], thewall[MAXWALLSB];

static short bunchfirst[MAXWALLSB], bunchlast[MAXWALLSB];

static short smost[MAXYSAVES], smostcnt;
static short smoststart[MAXWALLSB], smostwall[MAXWALLSB], smostwallcnt;

static short maskwall[MAXWALLSB], maskwallcnt;
static long spritex[MAXSPRITES], spritey[MAXSPRITES];

static short umost[MAXXDIM], dmost[MAXXDIM];
static short uplc[MAXXDIM], dplc[MAXXDIM];
static short uwall[MAXXDIM], dwall[MAXXDIM];
static long swplc[MAXXDIM], lplc[MAXXDIM];
static long swall[MAXXDIM], lwall[MAXXDIM+1];
static long xdimen = -1, halfxdimen, xdimenscale, xdimscale, xdimenoffs;
static long wx1, wy1, wx2, wy2, ydimen, viewoffset;

static long rxi[8], ryi[8], rzi[8], rxi2[8], ryi2[8], rzi2[8];
static long xsi[8], ysi[8], horizlookup[MAXYDIM<<1], horizlookup2[MAXYDIM<<1];

static long globalposx, globalposy, globalposz, globalhoriz;
static short globalang, globalcursectnum;
static long globalpal, cosglobalang, singlobalang;
static char *globalpalwritten;
static long globaluclip, globaldclip, globalvisibility;

long asm1, asm2, asm3, asm4;
char globalxshift, globalyshift;
long globalxpanning, globalypanning, globalshade;
short globalpicnum, globalshiftval;
long globalzd, globalbufplc, globalyscale, globalorientation;
long globalx1, globaly1, globalx2, globaly2, globalzx;

static short sectorborder[256], sectorbordercnt;
static char *screen = NULL, tablesloaded = 0;
long frameplace, pageoffset, ydim16, qsetmode = 0;
long startposx, startposy, startposz;
short startang, startsectnum;
short pointhighlight, linehighlight, highlightcnt;
static long lastx[MAXYDIM+2];
char palette[768], paletteloaded;
char *transluc = NULL, translucloaded = 0;
static long rdist[128], gdist[128], bdist[128];

static short clipnum, hitwalls[4];
static long clipx1[MAXCLIPNUM], clipy1[MAXCLIPNUM];
static long clipx2[MAXCLIPNUM], clipy2[MAXCLIPNUM];
static short clipsectorlist[MAXCLIPNUM], clipsectnum;
static short clipobjectval[MAXCLIPNUM];

short numscans, numhits, numbunches;
static short posfil, capturecount = 0, hitcnt;

static char pcxheader[128] =
{
	0xa,0x5,0x1,0x8,0x0,0x0,0x0,0x0,0x3f,0x1,0xc7,0x0,
	0x40,0x1,0xc8,0x0,0x0,0x0,0x0,0x8,0x8,0x8,0x10,0x10,
	0x10,0x18,0x18,0x18,0x20,0x20,0x20,0x28,0x28,0x28,0x30,0x30,
	0x30,0x38,0x38,0x38,0x40,0x40,0x40,0x48,0x48,0x48,0x50,0x50,
	0x50,0x58,0x58,0x58,0x60,0x60,0x60,0x68,0x68,0x68,0x70,0x70,
	0x70,0x78,0x78,0x78,0x0,0x1,0x40,0x1,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
};
static char vgapal16[48] =
{
	00,00,00,00,00,42,00,42,00,00,42,42,42,00,00,42,00,42,42,21,00,42,42,42,
	21,21,21,21,21,63,21,63,21,21,63,63,63,21,21,63,21,63,63,63,21,63,63,63,
};

short editstatus = 0;
short searchit;
long searchx, searchy;                          //search input
short searchsector, searchwall, searchstat;     //search output

static char artfilename[20];
static long localtilestart[MAXTILEFILES], localtileend[MAXTILEFILES];
static long numtilefiles, artfil = -1, artfilnum, artfilplc;

static long totalclocklock;

volatile unsigned char readch, oldreadch, extended, keytemp;

void (__interrupt __far *oldkeyhandler)();
void __interrupt __far keyhandler(void);

extern long setbytesperline(long);
#pragma aux setbytesperline parm [eax];
extern long sethlinesizes(long,long,long);
#pragma aux sethlinesizes parm [eax][ebx][ecx];
extern long setpalookupaddress(char *);
#pragma aux setpalookupaddress parm [eax];
extern long hlineasm64(long,long,long,long,long,long);
#pragma aux hlineasm64 parm [eax][ebx][ecx][edx][esi][edi];
extern long setvlinebpl(long);
#pragma aux setvlinebpl parm [eax];
extern long fixtransluscence(long);
#pragma aux fixtransluscence parm [eax];
extern long vlineasm1(long,long,long,long,long,long);
#pragma aux vlineasm1 parm [eax][ebx][ecx][edx][esi][edi];
extern long tvlineasm1(long,long,long,long,long,long);
#pragma aux tvlineasm1 parm [eax][ebx][ecx][edx][esi][edi];
extern long setuptvlineasm2(long,long,long);
#pragma aux setuptvlineasm2 parm [eax][ebx][ecx];
extern long tvlineasm2(long,long,long,long,long,long);
#pragma aux tvlineasm2 parm [eax][ebx][ecx][edx][esi][edi];
extern long mvlineasm1(long,long,long,long,long,long);
#pragma aux mvlineasm1 parm [eax][ebx][ecx][edx][esi][edi];
extern long vlineasm4(long,long,long,long,long,long);
#pragma aux vlineasm4 parm [eax][ebx][ecx][edx][esi][edi];
extern long mvlineasm4(long,long,long,long,long,long);
#pragma aux mvlineasm4 parm [eax][ebx][ecx][edx][esi][edi];
extern void setupspritevline(long,long,long,long,long,long);
#pragma aux setupspritevline parm [eax][ebx][ecx][edx][esi][edi];
extern void spritevline(long,long,long,long,long,long);
#pragma aux spritevline parm [eax][ebx][ecx][edx][esi][edi];
extern void tsetupspritevline(long,long,long,long,long,long);
#pragma aux tsetupspritevline parm [eax][ebx][ecx][edx][esi][edi];
extern void tspritevline(long,long,long,long,long,long);
#pragma aux tspritevline parm [eax][ebx][ecx][edx][esi][edi];
extern long mhline(long,long,long,long,long,long);
#pragma aux mhline parm [eax][ebx][ecx][edx][esi][edi];
extern long mhlineskipmodify(long,long,long,long,long,long);
#pragma aux mhlineskipmodify parm [eax][ebx][ecx][edx][esi][edi];
extern long msethlineshift(long,long);
#pragma aux msethlineshift parm [eax][ebx];
extern long thline(long,long,long,long,long,long);
#pragma aux thline parm [eax][ebx][ecx][edx][esi][edi];
extern long thlineskipmodify(long,long,long,long,long,long);
#pragma aux thlineskipmodify parm [eax][ebx][ecx][edx][esi][edi];
extern long tsethlineshift(long,long);
#pragma aux tsethlineshift parm [eax][ebx];

#pragma aux readkey =\
	"in al, 0x60",\
	"mov ah, al",\
	"in al, 0x61",\
	"or al, 0x80",\
	"out 0x61, al",\
	"and al, 0x7f",\
	"out 0x61, al",\
	"mov al, ah",\
	modify [eax]\

// 11,12 is 2,1-10
// 13,14 is 4,2-10
// 15,16 is 6,3-10
#pragma aux ksqrtasm =\
	"or eax, eax",\
	"jz endksqrtasm",\
	"jns skipnegate",\
	"neg eax",\
	"skipnegate: bsr ecx, eax",\
	"cmp ecx, 11",\
	"jge over2048",\
	"mov eax, dword ptr sqrtable[eax*4]",\
	"shr eax, 10",\
	"jmp endksqrtasm",\
	"over2048:",\
	"sub cl, 9",\
	"and cl, 0xfe",\
	"shr eax, cl",\
	"mov eax, dword ptr sqrtable[eax*4]",\
	"shr cl, 1",\
	"shl eax, cl",\
	"shr eax, 10",\
	"endksqrtasm:",\
	parm [eax]\
	modify [eax ebx ecx edx]\

#pragma aux vesasetmode =\
	"mov ax, 0x4f02",\
	"int 0x10",\
	"and eax, 0x0000ffff",\
	parm [ebx]\
	modify [eax ebx]\

#pragma aux vesasetpage =\
	"mov cl, vesapageshift",\
	"shl dx, cl",\
	"cmp dl, curpag",\
	"je skipsetpage",\
	"mov curpag, dl",\
	"mov ax, 0x4f05",\
	"xor bx, bx",\
	"int 0x10",\
	"skipsetpage:",\
	parm [edx]\
	modify [eax ebx ecx]\

#pragma aux vesasetpan =\
	"mov eax, 0x00004f07",\
	"xor ebx, ebx",\
	"int 0x10",\
	parm [ecx][edx]\
	modify [eax ebx]\

#pragma aux setgotpic =\
	"mov ecx, eax",\
	"shr eax, 3",\
	"mov ebx, 0x01010101",\
	"rol ebx, cl",\
	"or byte ptr gotpic[eax], bl",\
	parm [eax]\
	modify [ebx ecx]\

void __interrupt __far keyhandler()
{
	koutp(0x20,0x20);
	oldreadch = readch; readch = readkey();
	if ((readch|1) == 0xe1) { extended = 128; return; }
	if (oldreadch != readch)
	{
		if ((readch&128) == 0)
		{
			keytemp = readch+extended;
			if (keystatus[keytemp] == 0)
			{
				keystatus[keytemp] = 1;
				keyfifo[keyfifoend] = keytemp;
				keyfifo[(keyfifoend+1)&(KEYFIFOSIZ-1)] = 1;
				keyfifoend = ((keyfifoend+2)&(KEYFIFOSIZ-1));
			}
		}
		else
		{
			keytemp = (readch&127)+extended;
			keystatus[keytemp] = 0;
			keyfifo[keyfifoend] = keytemp;
			keyfifo[(keyfifoend+1)&(KEYFIFOSIZ-1)] = 0;
			keyfifoend = ((keyfifoend+2)&(KEYFIFOSIZ-1));
		}
	}
	extended = 0;
}

drawrooms(long daposx, long daposy, long daposz,
			 short daang, long dahoriz, short dacursectnum)
{
	long i, j, z, closest;

	globalposx = daposx; globalposy = daposy; globalposz = daposz;
	globalang = (daang&2047);

	globalhoriz = mulscale16(dahoriz-100,xdimenscale)+(ydimen>>1);
	globaluclip = mulscale16(0-globalhoriz,xdimscale);
	globaldclip = mulscale16(ydimen-globalhoriz,xdimscale);

	globalvisibility = mulscale16(visibility,xdimenscale);

	globalcursectnum = dacursectnum;
	totalclocklock = totalclock;

	cosglobalang = sintable[(globalang+512)&2047];
	singlobalang = sintable[globalang&2047];

	if (stereofps != 0)
	{
		if ((keystatus[0x2a]|keystatus[0x36]) > 0)
		{
			if (keystatus[0x1a] > 0) stereopixelwidth--;   //Shift [
			if (keystatus[0x1b] > 0) stereopixelwidth++;   //Shift ]
		}
		else
		{
			if (keystatus[0x1a] > 0) stereowidth -= 512;   //[
			if (keystatus[0x1b] > 0) stereowidth += 512;   //]
		}

		if (stereopage == 0)
		{
			globalposx += mulscale24(singlobalang,stereowidth);
			globalposy -= mulscale24(cosglobalang,stereowidth);
			if (ooption0 == 6)
				frameplace = FP_OFF(screen);
		}
		else
		{
			globalposx -= mulscale24(singlobalang,stereowidth);
			globalposy += mulscale24(cosglobalang,stereowidth);
			if (ooption0 == 6)
				frameplace = FP_OFF(screen)+65536;
		}
	}

	if (chainnumpages > 0) koutp(0x3c4,2);

	clearbuf((long)(&gotsector[0]),(long)((numsectors+31)>>5),0L);
	clearbuf((long)(&swall[0]),(long)xdimen,0x7fffffff);

	copybufbyte((long)(&startumost[windowx1]),(long)(&umost[0]),xdimen<<1);
	for(i=xdimen-1;i>=0;i--) umost[i] -= windowy1;
	copybufbyte((long)(&startdmost[windowx1]),(long)(&dmost[0]),xdimen<<1);
	for(i=xdimen-1;i>=0;i--) dmost[i] -= windowy1;

	updatesector(globalposx,globalposy,&globalcursectnum);

	numhits = xdimen; numscans = 0; numbunches = 0;
	maskwallcnt = 0; smostwallcnt = 0; smostcnt = 0; spritesortcnt = 0;

	scansector(globalcursectnum);

	while ((numbunches > 0) && (numhits > 0))
	{
		clearbuf((long)(&tempbuf[0]),(long)((numbunches+3)>>2),0L);
		tempbuf[0] = 1;

		closest = 0;              //Almost works, but not quite :(
		for(i=1;i<numbunches;i++)
		{
			j = bunchfront(i,closest);
			if (j >= 0)
			{
				tempbuf[i] = 1;
				if (j == 0) tempbuf[closest] = 1, closest = i;
			}
		}

		for(i=0;i<numbunches;i++)   //Double-check (I wanna' get rid of this!)
			if (tempbuf[i] == 0)
			{
				j = bunchfront(i,closest);
				if (j >= 0)
				{
					tempbuf[i] = 1;
					if (j == 0) tempbuf[closest] = 1, closest = i, i = 0;
				}
			}

		drawalls((short)closest);

		if (automapping == 1)
		{
			z = bunchfirst[closest];
			do
			{
				i = thewall[z];
				show2dwall[i>>3] |= (1<<(i&7));

				z = p2[z];
			}
			while (z != -1);
		}

		numbunches--;
		bunchfirst[closest] = bunchfirst[numbunches];
		bunchlast[closest] = bunchlast[numbunches];
	}
}

scansector (short sectnum)
{
	short z, zz, startwall, endwall, numscansbefore, scanfirst, bunchfrst;
	long i, xs, ys, xp, yp;
	struct spritetype *spr;

	if (sectnum < 0) return;

	if (automapping == 1) show2dsector[sectnum>>3] |= (1<<(sectnum&7));

	sectorborder[0] = sectnum, sectorbordercnt = 1;
	while (sectorbordercnt > 0)
	{
		sectnum = sectorborder[--sectorbordercnt];

		for(z=headspritesect[sectnum];z>=0;z=nextspritesect[z])
		{
			spr = &sprite[z];
			if ((spr->cstat&0x8000) == 0)
			{
				xs = spr->x - globalposx;
				ys = spr->y - globalposy;
				yp = ((xs*cosglobalang+ys*singlobalang)>>6);
				if ((yp > (4<<8)) || ((spr->cstat&48) > 0))
					if ((spr->xrepeat > 0) && (spr->yrepeat > 0))
					{
						xp = ((ys*cosglobalang-xs*singlobalang)>>6);

						if (yp > (4<<8))
							spritex[spritesortcnt] = (xdimen<<7)+scale(xp,xdimen<<7,yp);
						spritey[spritesortcnt] = yp;
						spritepicnum[spritesortcnt] = spr->picnum;
						thesprite[spritesortcnt] = z;
						spritesortcnt++;
					}
			}
		}

		gotsector[sectnum>>3] |= (1<<(sectnum&7));

		bunchfrst = numbunches;
		numscansbefore = numscans;

		startwall = sector[sectnum].wallptr;
		endwall = startwall + sector[sectnum].wallnum;
		scanfirst = numscans;
		for(z=startwall;z<endwall;z++)
		{
			if (addboxlinum(sectnum, z) > 0) p2[numscans-1] = numscans;
			if ((wall[z].point2 < z) && (scanfirst < numscans))
				p2[numscans-1] = scanfirst, scanfirst = numscans;
		}

		for(z=numscansbefore;z<numscans;z++)
			if ((wall[thewall[z]].point2 != thewall[p2[z]]) || (xb2[z] >= xb1[p2[z]]))
				bunchfirst[numbunches++] = p2[z], p2[z] = -1;

		for(z=bunchfrst;z<numbunches;z++)
		{
			zz = bunchfirst[z]; while (p2[zz] >= 0) zz = p2[zz];
			bunchlast[z] = zz;
		}
	}
}

wallfront (long l1, long l2)
{
	long x11, y11, x21, y21, x12, y12, x22, y22, dx, dy, t0, t1, t2;
	struct walltype *wal;

	wal = &wall[thewall[l1]]; x11 = wal->x; y11 = wal->y;
	wal = &wall[wal->point2]; x21 = wal->x; y21 = wal->y;
	wal = &wall[thewall[l2]]; x12 = wal->x; y12 = wal->y;
	wal = &wall[wal->point2]; x22 = wal->x; y22 = wal->y;

	dx = x21-x11; dy = y21-y11;
	t1 = doublemulscale2(x12-x11,dy,-dx,y12-y11); //p1(l2) vs. l1
	t2 = doublemulscale2(x22-x11,dy,-dx,y22-y11); //p2(l2) vs. l1
	if (t1 == 0) { t1 = t2; if (t1 == 0) return(-1); }
	if (t2 == 0) t2 = t1;
	if ((t1^t2) >= 0)
	{
		t0 = doublemulscale2(globalposx-x11,dy,-dx,globalposy-y11); //pos vs. l1
		return((t0^t1) >= 0);
	}

	dx = x22-x12; dy = y22-y12;
	t1 = doublemulscale2(x11-x12,dy,-dx,y11-y12); //p1(l1) vs. l2
	t2 = doublemulscale2(x21-x12,dy,-dx,y21-y12); //p2(l1) vs. l2
	if (t1 == 0) { t1 = t2; if (t1 == 0) return(-1); }
	if (t2 == 0) t2 = t1;
	if ((t1^t2) >= 0)
	{
		t0 = doublemulscale2(globalposx-x12,dy,-dx,globalposy-y12); //pos vs. l2
		return((t0^t1) < 0);
	}
	return(-2);
}

spritewallfront (long s, long w)
{
	long x1, y1;
	struct walltype *wal;

	wal = &wall[w]; x1 = wal->x; y1 = wal->y;
	wal = &wall[wal->point2];
	return ((wal->x-x1)*(sprite[s].y-y1) >= (sprite[s].x-x1)*(wal->y-y1));
}

bunchfront (long b1, long b2)
{
	long x1b1, x2b1, x1b2, x2b2, y1, y2, they, b1f, b2f, z;

	b1f = bunchfirst[b1]; x1b1 = xb1[b1f]; x2b2 = xb2[bunchlast[b2]]+1;
	if (x1b1 >= x2b2) return(-1);
	b2f = bunchfirst[b2]; x1b2 = xb1[b2f]; x2b1 = xb2[bunchlast[b1]]+1;
	if (x1b2 >= x2b1) return(-1);

	if (x1b1 >= x1b2)
	{
		z = b2f; while (xb2[z] < x1b1) z = p2[z];
		return(wallfront(b1f,z));
	}
	z = b1f; while (xb2[z] < x1b2) z = p2[z];
	return(wallfront(z,b2f));
}

drawalls (short bunch)
{
	char cstat1, cstat2, andwstat1, andwstat2, redtouchflag;
	short z, wallnum, sectnum, nextsectnum;
	long i, j, k, l, m, n, top, topinc, bot, botinc, x, y, xend;
	long templong, z1, z2, hplc, hplc2, hinc, daplc, llin, rlin, scalej;
	struct sectortype *sec, *nextsec;
	struct walltype *wal;

	z = bunchfirst[bunch];
	sectnum = thesector[z]; sec = &sector[sectnum];
	z1 = sec->ceilingz;
	z2 = sec->floorz;
	cstat1 = sec->ceilingstat;
	cstat2 = sec->floorstat;

	andwstat1 = 0xff; andwstat2 = 0xff;

	for(;z>=0;z=p2[z])
	{
		wallnum = thewall[z]; wal = &wall[wallnum];
		nextsectnum = wal->nextsector; nextsec = &sector[nextsectnum];

		if (z == bunchfirst[bunch])
			hplc = (65536*2048)/yb1[z];
		else
			hplc = hplc2;
		hplc2 = (65536*2048)/yb2[z];
		hinc = (hplc2-hplc)/(xb2[z]-xb1[z]+1);

		if (xdimen != 320)
		{
			hplc = mulscale16(hplc,xdimenscale);
			hinc = mulscale16(hinc,xdimenscale);
		}

		if ((cstat2&2) > 0)  //Groudraw
		{
			daplc = hplc;
			for(x=xb1[z];x<=xb2[z];x++)
			{
				grouvline(x,swall[x],daplc,sectnum);
				daplc += hinc;
			}
		}

		if ((nextsectnum == -1) || (nextsec->ceilingz > z1) || (nextsec->floorz < z2) || ((wal->cstat&32) > 0))
		{
			i = xb1[z]-halfxdimen;
			topinc = -ry1[z]*wal->xrepeat;
			top = (mulscale2(rx1[z],xdimen)-mulscale1(i,ry1[z]))*wal->xrepeat;
			botinc = ((ry2[z]-ry1[z])>>1);
			bot = mulscale3(rx1[z]-rx2[z],xdimen)+mulscale1(i,botinc);

			i = xb1[z]; j = xb2[z]+1;
			for(x=i;x<=j;x+=2)
			{
				if (bot != 0) lwall[x] = divscale8(top,bot);
				top += topinc, bot += botinc;
			}
			k = lwall[i];
			for(x=i+1;x<j;x+=2)
				{ l = lwall[x+1]; lwall[x] = ((k+l)>>1); k = l; }

			if (lwall[xb1[z]] < 0) lwall[xb1[z]] = 0;
			if (wal->xrepeat > 0)
			{
				k = ((long)wal->xrepeat<<9);
				if (lwall[xb2[z]] >= k) lwall[xb2[z]] = k-1;
			}

			if ((wal->cstat&8) > 0)
			{
				j = ((long)wal->xrepeat<<9)-1;
				for(x=xb1[z];x<=xb2[z];x++) lwall[x] = j-lwall[x];
			}
		}

		andwstat1 &= wallmost(uplc,(long)z,z1-globalposz);
		andwstat2 &= wallmost(dplc,(long)z,z2-globalposz);

		qinterpolate((long)(&swall[xb1[z]]),xb2[z]-xb1[z],hplc,hinc);

		if (searchit != 2) continue;
		if ((searchx < xb1[z]) || (searchx > xb2[z])) continue;
		if (searchy <= uplc[searchx])
		{
			searchsector = sectnum;
			searchwall = wallnum;
			searchstat = 1;  //ceiling
			searchit = 1;
			continue;
		}
		if (searchy >= dplc[searchx])
		{
			searchsector = sectnum;
			searchwall = wallnum;
			searchstat = 2;  //floor
			searchit = 1;
			continue;
		}
		if (nextsectnum == -1)
		{
			searchsector = sectnum;
			searchwall = wallnum;
			searchstat = 0;  //wall
			searchit = 1;
			continue;
		}
		if (nextsec->ceilingz > z1)
		{
			y = globalhoriz + mulscale24(swall[searchx],nextsec->ceilingz-globalposz);
			if (searchy <= y)
			{
				searchsector = sectnum;
				searchwall = wallnum;
				searchstat = 0;  //wall
				searchit = 1;
				continue;
			}
		}
		if (nextsec->floorz < z2)
		{
			y = globalhoriz + mulscale24(swall[searchx],nextsec->floorz-globalposz);
			if (searchy >= y)
			{
				searchsector = sectnum;
				searchwall = wallnum;
				if ((wal->cstat&2) > 0) searchwall = wal->nextwall;
				searchstat = 0;  //wall
				searchit = 1;
				continue;
			}
		}
		if ((wal->cstat&32) > 0)
		{
			searchsector = sectnum;
			searchwall = wallnum;
			searchstat = 4;  //1-way wall
			searchit = 1;
			continue;
		}
	}

	if ((andwstat1&3) != 3)      //draw ceilings
	{
		if ((cstat1&3) == 0)
		{
			ceilscan(xb1[bunchfirst[bunch]],xb2[bunchlast[bunch]],sectnum);
		}
		else if ((cstat1&1) > 0)  //Parallaxing SKY
		{
			globalpal = sec->ceilingpal;
			globalorientation = 0L;
			globalpicnum = sec->ceilingpicnum;
			if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
			globalshade = (long)sec->ceilingshade;
			globalxpanning = (long)sec->ceilingxpanning;
			globalypanning = (long)sec->ceilingypanning;
			if ((picanm[globalpicnum]&192) != 0)
				globalpicnum += animateoffs(globalpicnum,sectnum);
			globalshiftval = (picsiz[globalpicnum]>>4);
			if ((1<<globalshiftval) != tilesizy[globalpicnum]) globalshiftval++;
			globalshiftval = 32-globalshiftval;
			globalzd = (((tilesizy[globalpicnum]>>1)+parallaxyoffs)<<globalshiftval)+(globalypanning<<24);
			globalyscale = (8<<(globalshiftval-19));

			k = 11 - (picsiz[globalpicnum]&15) - pskybits;

			x = -1;

			for(z=bunchfirst[bunch];z>=0;z=p2[z])
			{
				wallnum = thewall[z]; nextsectnum = wall[wallnum].nextsector;

				if ((nextsectnum == -1) || ((sector[nextsectnum].ceilingstat&1) == 0) || ((wall[wallnum].cstat&32) > 0))
				{
					if (x == -1) x = xb1[z];

					switch(parallaxtype)
					{
						case 0:
							for(j=xb1[z];j<=xb2[z];j++)
							{
								scalej = j;
								uwall[j] = umost[j];
								dwall[j] = uplc[j];
								swplc[j] = xdimenscale;
								lplc[j] = (((((((scalej-halfxdimen)<<9)/xdimen)+globalang)&2047)>>k)<<6);
							}
							break;
						case 1:
							for(j=xb1[z];j<=xb2[z];j++)
							{
								uwall[j] = umost[j];
								dwall[j] = uplc[j];
								swplc[j] = xdimenscale;
								lplc[j] = ((((radarang2[j]+globalang)&2047)>>k)<<6);
							}
							break;
						case 2:
							for(j=xb1[z];j<=xb2[z];j++)
							{
								uwall[j] = umost[j];
								dwall[j] = uplc[j];
								swplc[j] = 16384*65536 / sintable[(radarang2[j]+2560)&2047] + 1;
								if (xdimen != 320)
									swplc[j] = mulscale16(swplc[j],xdimenscale);
								lplc[j] = ((((radarang2[j]+globalang)&2047)>>k)<<6);
							}
							break;
					}
				}
				else if (x >= 0)
				{
					l = globalpicnum; m = (picsiz[globalpicnum]&15)+6;
					globalpicnum = l+pskyoff[lplc[x]>>m];

					if (((lplc[x]^lplc[xb1[z]-1])>>m) == 0)
					{
						wallscan(x,xb1[z]-1,uwall,dwall,swplc,lplc);
					}
					else
					{
						j = x;
						while (x < xb1[z])
						{
							n = l+pskyoff[lplc[x]>>m];
							if (n != globalpicnum)
							{
								wallscan(j,x-1,uwall,dwall,swplc,lplc);
								j = x;
								globalpicnum = n;
							}
							x++;
						}
						if (j < x)
							wallscan(j,x-1,uwall,dwall,swplc,lplc);
					}

					globalpicnum = l;
					x = -1;
				}
			}

			if (x >= 0)
			{
				l = globalpicnum; m = (picsiz[globalpicnum]&15)+6;
				globalpicnum = l+pskyoff[lplc[x]>>m];

				if (((lplc[x]^lplc[xb2[bunchlast[bunch]]])>>m) == 0)
				{
					wallscan(x,xb2[bunchlast[bunch]],uwall,dwall,swplc,lplc);
				}
				else
				{
					j = x;
					while (x <= xb2[bunchlast[bunch]])
					{
						n = l+pskyoff[lplc[x]>>m];
						if (n != globalpicnum)
						{
							wallscan(j,x-1,uwall,dwall,swplc,lplc);
							j = x;
							globalpicnum = n;
						}
						x++;
					}
					if (j <= x)
						wallscan(j,x,uwall,dwall,swplc,lplc);
				}

				globalpicnum = l;
			}
		}
	}

	if ((andwstat2&0xc) != 0xc)   //draw floors
	{
		if ((cstat2&3) == 0)
		{
			florscan(xb1[bunchfirst[bunch]],xb2[bunchlast[bunch]],sectnum);
		}
		else if ((cstat2&1) > 0)  //Parallaxing floor SKY
		{
			globalpal = sec->floorpal;
			globalorientation = 0L;
			globalpicnum = sec->floorpicnum;
			if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
			globalshade = (long)sec->floorshade;
			globalxpanning = (long)sec->floorxpanning;
			globalypanning = (long)sec->floorypanning;
			if ((picanm[globalpicnum]&192) != 0)
				globalpicnum += animateoffs(globalpicnum,sectnum);
			globalshiftval = (picsiz[globalpicnum]>>4);
			if ((1<<globalshiftval) != tilesizy[globalpicnum]) globalshiftval++;
			globalshiftval = 32-globalshiftval;
			globalzd = (((tilesizy[globalpicnum]>>1)+parallaxyoffs)<<globalshiftval)+(globalypanning<<24);
			globalyscale = (8<<(globalshiftval-19));

			k = 11 - (picsiz[globalpicnum]&15) - pskybits;

			x = -1;

			for(z=bunchfirst[bunch];z>=0;z=p2[z])
			{
				wallnum = thewall[z]; nextsectnum = wall[wallnum].nextsector;

				if ((nextsectnum == -1) || ((sector[nextsectnum].floorstat&1) == 0) || ((wall[wallnum].cstat&32) > 0))
				{
					if (x == -1) x = xb1[z];

					switch(parallaxtype)
					{
						case 0:
							for(j=xb1[z];j<=xb2[z];j++)
							{
								scalej = j;
								uwall[j] = dplc[j];
								dwall[j] = dmost[j];
								swplc[j] = xdimenscale;
								lplc[j] = (((((((scalej-halfxdimen)<<9)/xdimen)+globalang)&2047)>>k)<<6);
							}
							break;
						case 1:
							for(j=xb1[z];j<=xb2[z];j++)
							{
								uwall[j] = dplc[j];
								dwall[j] = dmost[j];
								swplc[j] = xdimenscale;
								lplc[j] = ((((radarang2[j]+globalang)&2047)>>k)<<6);
							}
							break;
						case 2:
							for(j=xb1[z];j<=xb2[z];j++)
							{
								uwall[j] = dplc[j];
								dwall[j] = dmost[j];
								swplc[j] = 16384*65536 / sintable[(radarang2[j]+2560)&2047] + 1;
								if (xdimen != 320)
									swplc[j] = mulscale16(swplc[j],xdimenscale);
								lplc[j] = ((((radarang2[j]+globalang)&2047)>>k)<<6);
							}
							break;
					}
				}
				else if (x >= 0)
				{
					l = globalpicnum; m = (picsiz[globalpicnum]&15)+6;
					globalpicnum = l+pskyoff[lplc[x]>>m];

					if (((lplc[x]^lplc[xb1[z]-1])>>m) == 0)
					{
						wallscan(x,xb1[z]-1,uwall,dwall,swplc,lplc);
					}
					else
					{
						j = x;
						while (x < xb1[z])
						{
							n = l+pskyoff[lplc[x]>>m];
							if (n != globalpicnum)
							{
								wallscan(j,x-1,uwall,dwall,swplc,lplc);
								j = x;
								globalpicnum = n;
							}
							x++;
						}
						if (j < x)
							wallscan(j,x-1,uwall,dwall,swplc,lplc);
					}

					globalpicnum = l;
					x = -1;
				}
			}

			if (x >= 0)
			{
				l = globalpicnum; m = (picsiz[globalpicnum]&15)+6;
				globalpicnum = l+pskyoff[lplc[x]>>m];

				if (((lplc[x]^lplc[xb2[bunchlast[bunch]]])>>m) == 0)
				{
					wallscan(x,xb2[bunchlast[bunch]],uwall,dwall,swplc,lplc);
				}
				else
				{
					j = x;
					while (x <= xb2[bunchlast[bunch]])
					{
						n = l+pskyoff[lplc[x]>>m];
						if (n != globalpicnum)
						{
							wallscan(j,x-1,uwall,dwall,swplc,lplc);
							j = x;
							globalpicnum = n;
						}
						x++;
					}
					if (j <= x)
						wallscan(j,x,uwall,dwall,swplc,lplc);
				}

				globalpicnum = l;
			}
		}
	}

	  //DRAW WALLS SECTION!
	for(z=bunchfirst[bunch];z>=0;z=p2[z])
	{
		wallnum = thewall[z]; wal = &wall[wallnum];
		nextsectnum = wal->nextsector; nextsec = &sector[nextsectnum];

		if (nextsectnum < 0)
		{
			globalorientation = (long)wal->cstat;
			globalpicnum = wal->picnum;
			if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
			globalxpanning = (long)wal->xpanning;
			globalypanning = (long)wal->ypanning;
			if ((picanm[globalpicnum]&192) != 0)
				globalpicnum += animateoffs(globalpicnum,wallnum+16384);
			globalshade = (long)wal->shade;
			globalpal = (long)wal->pal;
			globalshiftval = (picsiz[globalpicnum]>>4);
			if ((1<<globalshiftval) != tilesizy[globalpicnum]) globalshiftval++;
			globalshiftval = 32-globalshiftval;
			globalyscale = (wal->yrepeat<<(globalshiftval-19));
			if ((globalorientation&4) == 0)
				globalzd = (((globalposz-sec->ceilingz)*globalyscale)<<8);
			else
				globalzd = (((globalposz-sec->floorz)*globalyscale)<<8);
			globalzd += (globalypanning<<24);

			wallscan(xb1[z],xb2[z],uplc,dplc,swall,lwall);

			xend = xb2[z];
			for(x=xb1[z];x<=xend;x++)
				if (umost[x] <= dmost[x])
				{
					umost[x] = 1;
					dmost[x] = 0;
					numhits--;
				}
			smostwall[smostwallcnt++] = z;
		}
		else
		{
			if ((redtouchflag = (nextsec->ceilingz == nextsec->floorz)) != 0)
				smostwall[smostwallcnt++] = z;

			if ((wal->cstat&16) > 0) maskwall[maskwallcnt++] = z;

			if (((cstat1&1) == 0) || ((nextsec->ceilingstat&1) == 0))
			{
				if (nextsec->ceilingz <= sec->ceilingz)
				{
					xend = xb2[z];
					for(x=xb1[z];x<=xend;x++)
						if (umost[x] <= dmost[x])
							if (uplc[x] > umost[x])
							{
								umost[x] = uplc[x];
								if (umost[x] > dmost[x]) numhits--;
							}

					if ((nextsec->ceilingz < sec->ceilingz) && (redtouchflag == 0))
					{
						i = xb2[z]-xb1[z]+1;
						if (smostcnt+i < MAXYSAVES)
						{
							smoststart[smostwallcnt] = smostcnt;
							smostwall[smostwallcnt++] = z+16384;   //16384 for umost
							copybufbyte((long)&umost[xb1[z]],(long)&smost[smostcnt],i<<1);
							smostcnt += i;
						}
					}
				}
				else
				{
					if (sec->floorz < nextsec->ceilingz)
						templong = (sec->floorz-globalposz);
					else
						templong = (nextsec->ceilingz-globalposz);
					//ddplc = (globalhoriz<<16)+mulscale8(swall[xb1[z]],templong);
					//if (xb2[z] > xb1[z])
					//   ddinc = mulscale8((swall[xb2[z]]-swall[xb1[z]])/(xb2[z]-xb1[z]),templong);
					//qinterpolatedown16((long)(&dwall[xb1[z]]),xb2[z]-xb1[z],ddplc,ddinc);

					wallmost(dwall,(long)z,templong);

					globalorientation = (long)wal->cstat;
					globalpicnum = wal->picnum;
					if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
					globalxpanning = (long)wal->xpanning;
					globalypanning = (long)wal->ypanning;
					globalshiftval = (picsiz[globalpicnum]>>4);
					if ((1<<globalshiftval) != tilesizy[globalpicnum]) globalshiftval++;
					globalshiftval = 32-globalshiftval;
					if ((picanm[globalpicnum]&192) != 0)
						globalpicnum += animateoffs(globalpicnum,wallnum+16384);
					globalshade = (long)wal->shade;
					globalpal = (long)wal->pal;
					globalyscale = (wal->yrepeat<<(globalshiftval-19));
					if ((globalorientation&4) == 0)
						globalzd = (((globalposz-nextsec->ceilingz)*globalyscale)<<8);
					else
						globalzd = (((globalposz-sec->ceilingz)*globalyscale)<<8);
					globalzd += (globalypanning<<24);

					wallscan(xb1[z],xb2[z],uplc,dwall,swall,lwall);

					xend = xb2[z];
					for(x=xb1[z];x<=xend;x++)
						if (umost[x] <= dmost[x])
							if (dwall[x] > umost[x])
							{
								umost[x] = dwall[x];
								if (umost[x] > dmost[x]) numhits--;
							}

					if ((globalposz < nextsec->ceilingz) && (redtouchflag == 0))
					{
						i = xend-xb1[z]+1;
						if (smostcnt+i < MAXYSAVES)
						{
							smoststart[smostwallcnt] = smostcnt;
							smostwall[smostwallcnt++] = z+16384;   //16384 for umost
							copybufbyte((long)&umost[xb1[z]],(long)&smost[smostcnt],i<<1);
							smostcnt += i;
						}
					}
				}
			}
			if (((cstat2&1) == 0) || ((nextsec->floorstat&1) == 0))
			{
				if (nextsec->floorz >= sec->floorz)
				{
					xend = xb2[z];
					for(x=xb1[z];x<=xend;x++)
						if (umost[x] <= dmost[x])
							if (dplc[x] < dmost[x])
							{
								dmost[x] = dplc[x];
								if (umost[x] > dmost[x]) numhits--;
							}

					if ((nextsec->floorz > sec->floorz) && (redtouchflag == 0))
					{
						i = xend-xb1[z]+1;
						if (smostcnt+i < MAXYSAVES)
						{
							smoststart[smostwallcnt] = smostcnt;
							smostwall[smostwallcnt++] = z+32768;   //32768 for dmost
							copybufbyte((long)&dmost[xb1[z]],(long)&smost[smostcnt],i<<1);
							smostcnt += i;
						}
					}
				}
				else
				{
					if (sec->ceilingz > nextsec->floorz)
						templong = (sec->ceilingz-globalposz);
					else
						templong = (nextsec->floorz-globalposz);

					wallmost(uwall,(long)z,templong);

					if ((wal->cstat&2) > 0)
					{
						wallnum = wal->nextwall; wal = &wall[wallnum];
						globalorientation = (long)wal->cstat;
						globalpicnum = wal->picnum;
						if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
						globalxpanning = (long)wal->xpanning;
						globalypanning = (long)wal->ypanning;
						if ((picanm[globalpicnum]&192) != 0)
							globalpicnum += animateoffs(globalpicnum,wallnum+16384);
						globalshade = (long)wal->shade;
						globalpal = (long)wal->pal;
						wallnum = thewall[z]; wal = &wall[wallnum];
					}
					else
					{
						globalorientation = (long)wal->cstat;
						globalpicnum = wal->picnum;
						if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
						globalxpanning = (long)wal->xpanning;
						globalypanning = (long)wal->ypanning;
						if ((picanm[globalpicnum]&192) != 0)
							globalpicnum += animateoffs(globalpicnum,wallnum+16384);
						globalshade = (long)wal->shade;
						globalpal = (long)wal->pal;
					}
					globalshiftval = (picsiz[globalpicnum]>>4);
					if ((1<<globalshiftval) != tilesizy[globalpicnum]) globalshiftval++;
					globalshiftval = 32-globalshiftval;
					globalyscale = (wal->yrepeat<<(globalshiftval-19));
					if ((globalorientation&4) == 0)
						globalzd = (((globalposz-nextsec->floorz)*globalyscale)<<8);
					else
						globalzd = (((globalposz-sec->ceilingz)*globalyscale)<<8);
					globalzd += (globalypanning<<24);

					wallscan(xb1[z],xb2[z],uwall,dplc,swall,lwall);

					xend = xb2[z];
					for(x=xb1[z];x<=xend;x++)
						if (umost[x] <= dmost[x])
							if (uwall[x] < dmost[x])
							{
								dmost[x] = uwall[x];
								if (umost[x] > dmost[x]) numhits--;
							}

					if ((globalposz > nextsec->floorz) && (redtouchflag == 0))
					{
						i = xend-xb1[z]+1;
						if (smostcnt+i < MAXYSAVES)
						{
							smoststart[smostwallcnt] = smostcnt;
							smostwall[smostwallcnt++] = z+32768;   //32768 for dmost
							copybufbyte((long)&dmost[xb1[z]],(long)&smost[smostcnt],i<<1);
							smostcnt += i;
						}
					}
				}
			}

			if ((wal->cstat&32) > 0)   //1-way wall
			{
				globalorientation = (long)wal->cstat;
				globalpicnum = wal->overpicnum;
				if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
				globalxpanning = (long)wal->xpanning;
				globalypanning = (long)wal->ypanning;
				if ((picanm[globalpicnum]&192) != 0)
					globalpicnum += animateoffs(globalpicnum,wallnum+16384);
				globalshade = (long)wal->shade;
				globalpal = (long)wal->pal;
				globalshiftval = (picsiz[globalpicnum]>>4);
				if ((1<<globalshiftval) != tilesizy[globalpicnum]) globalshiftval++;
				globalshiftval = 32-globalshiftval;
				globalyscale = (wal->yrepeat<<(globalshiftval-19));
				if ((globalorientation&4) == 0)
					globalzd = (((globalposz-nextsec->ceilingz)*globalyscale)<<8);
				else
					globalzd = (((globalposz-sec->ceilingz)*globalyscale)<<8);
				globalzd += (globalypanning<<24);

				wallscan(xb1[z],xb2[z],uplc,dplc,swall,lwall);

				xend = xb2[z];
				for(x=xb1[z];x<=xend;x++)
					if (umost[x] <= dmost[x])
					{
						umost[x] = 1;
						dmost[x] = 0;
						numhits--;
					}
				smostwall[smostwallcnt++] = z;
			}
		}
		if (numhits < 0) return;

		if ((gotsector[nextsectnum>>3]&(1<<(nextsectnum&7))) == 0)
			if ((nextsectnum != -1) && ((wal->cstat&32) == 0))
			{
				xend = xb2[z];
				for(x=xb1[z];x<=xend;x++)
					if (umost[x] < dmost[x])
					{
						scansector(nextsectnum);
						break;
					}
			}
	}
}

addboxlinum(short sectore, short walle)
{
	short nextsectnum;
	long x1, y1, x2, y2, xp1, yp1, xp2, yp2, xc, yc, templong, templong1;
	struct walltype *wal, *wal2;

	wal = &wall[walle];
	x1 = wal->x-globalposx; y1 = wal->y-globalposy;
	wal2 = &wall[wal->point2];
	x2 = wal2->x-globalposx; y2 = wal2->y-globalposy;

	nextsectnum = wal->nextsector;
	if ((nextsectnum >= 0) && ((wal->cstat&32) == 0))
		if ((gotsector[nextsectnum>>3]&(1<<(nextsectnum&7))) == 0)
		{
			templong = x1*y2-x2*y1;
			if (klabs(templong) < 262144)
				if (mulscale5(templong,templong) <= (x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
					sectorborder[sectorbordercnt++] = nextsectnum;
		}

	yp1 = doublemulscale14(x1,cosglobalang,y1,singlobalang);
	yp2 = doublemulscale14(x2,cosglobalang,y2,singlobalang);
	if ((yp1 <= 0) && (yp2 <= 0)) return(0);
	xp1 = doublemulscale14(y1,cosglobalang,-x1,singlobalang);
	xp2 = doublemulscale14(y2,cosglobalang,-x2,singlobalang);
	if (mulscale2(xp1,yp2) > mulscale2(xp2,yp1)) return(0);    //If wall's NOT facing you

	if (xp1 >= -yp1)
	{
		if (xp1 > yp1) return(0);
		if (yp1 == 0) return(0);
		xb1[numscans] = halfxdimen + scale(xp1,halfxdimen,yp1);
		if (xp1 >= 0) xb1[numscans]++;   //Fix for SIGNED divide
		if (xb1[numscans] >= xdimen) xb1[numscans] = xdimen-1;
		yb1[numscans] = yp1;
	}
	else
	{
		if (xp2 < -yp2) return(0);
		xb1[numscans] = 0;
		templong1 = yp1-yp2+xp1-xp2;
		if (templong1 == 0) return(0);
		yb1[numscans] = yp1 + scale(yp2-yp1,xp1+yp1,templong1);
	}
	if (yb1[numscans] <= 0) return(0);

	if (xp2 <= yp2)
	{
		if (xp2 < -yp2) return(0);
		if (yp2 == 0) return(0);
		xb2[numscans] = halfxdimen + scale(xp2,halfxdimen,yp2) - 1;
		if (xp2 >= 0) xb2[numscans]++;   //Fix for SIGNED divide
		if (xb2[numscans] >= xdimen) xb2[numscans] = xdimen-1;
		yb2[numscans] = yp2;
	}
	else
	{
		if (xp1 > yp1) return(0);
		xb2[numscans] = xdimen-1;
		templong1 = xp2-xp1+yp1-yp2;
		if (templong1 == 0) return(0);
		yb2[numscans] = yp1 + scale(yp2-yp1,yp1-xp1,templong1);
	}
	if ((yb2[numscans] <= 0) || (xb1[numscans] > xb2[numscans])) return(0);

		//Made it all the way!
	thesector[numscans] = sectore; thewall[numscans] = walle;
	rx1[numscans] = xp1; ry1[numscans] = yp1;
	rx2[numscans] = xp2; ry2[numscans] = yp2;
	numscans++;
	return(1);
}

ceilscan (long x1, long x2, short sectnum)
{
	long i, j, ox, oy, x, y1, y2, twall, bwall;

	if (palookup[sector[sectnum].ceilingpal] != globalpalwritten)
	{
		globalpalwritten = palookup[sector[sectnum].ceilingpal];
		setpalookupaddress(globalpalwritten);
	}

	globalzd = sector[sectnum].ceilingz-globalposz;
	if (globalzd > 0) return;
	globalpicnum = sector[sectnum].ceilingpicnum;
	if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
	if ((picanm[globalpicnum]&192) != 0)
		globalpicnum += animateoffs((short)globalpicnum,sectnum);
	setgotpic(globalpicnum);
	if ((tilesizx[globalpicnum] <= 0) || (tilesizy[globalpicnum] <= 0)) return;
	if (waloff[globalpicnum] == 0) loadtile(globalpicnum);
	globalbufplc = waloff[globalpicnum];
	globalshade = (long)sector[sectnum].ceilingshade;
	globalorientation = (long)sector[sectnum].ceilingstat;


	if ((globalorientation&64) == 0)
	{
		globalx1 = singlobalang; globalx2 = singlobalang;
		globaly1 = cosglobalang; globaly2 = cosglobalang;
		globalxpanning = (globalposx<<20);
		globalypanning = -(globalposy<<20);
	}
	else
	{
		j = sector[sectnum].wallptr;
		ox = wall[wall[j].point2].x - wall[j].x;
		oy = wall[wall[j].point2].y - wall[j].y;
		i = ksqrtasm(ox*ox+oy*oy); if (i == 0) i = 1024; else i = 1048576/i;
		globalx1 = mulscale10(doublemulscale10(ox,singlobalang,-oy,cosglobalang),i);
		globaly1 = mulscale10(doublemulscale10(ox,cosglobalang,oy,singlobalang),i);
		globalx2 = -globalx1;
		globaly2 = -globaly1;

		ox = ((wall[j].x-globalposx)<<6); oy = ((wall[j].y-globalposy)<<6);
		i = doublemulscale14(oy,cosglobalang,-ox,singlobalang);
		j = doublemulscale14(ox,cosglobalang,oy,singlobalang);
		ox = i; oy = j;
		globalxpanning = globalx1*ox - globaly1*oy;
		globalypanning = globaly2*ox + globalx2*oy;
	}
	if ((globalorientation&8) == 0)
	{
		globalxshift = (8-(picsiz[globalpicnum]&15));
		globalyshift = (8-(picsiz[globalpicnum]>>4));
	}
	else if (picsiz[globalpicnum] == 0x66)
		{ globalxshift = 3; globalyshift = 3; }
	else
		{ globalxshift = 2; globalyshift = 2; }

	if ((globalorientation&0x4) > 0)
	{
		i = globalxpanning; globalxpanning = globalypanning; globalypanning = i;
		i = globalx2; globalx2 = -globaly1; globaly1 = -i;
		i = globalx1; globalx1 = globaly2; globaly2 = i;
	}
	if ((globalorientation&0x10) > 0) globalx1 = -globalx1, globaly1 = -globaly1, globalxpanning = -globalxpanning;
	if ((globalorientation&0x20) > 0) globalx2 = -globalx2, globaly2 = -globaly2, globalypanning = -globalypanning;
	globalx1 <<= globalxshift; globaly1 <<= globalxshift;
	globalx2 <<= globalyshift;  globaly2 <<= globalyshift;
	globalxpanning <<= globalxshift; globalypanning <<= globalyshift;
	globalxpanning += (((long)sector[sectnum].ceilingxpanning)<<24);
	globalypanning += (((long)sector[sectnum].ceilingypanning)<<24);
	globaly1 = (-globalx1-globaly1)*halfxdimen;
	globalx2 = (globalx2-globaly2)*halfxdimen;


	sethlinesizes(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4,globalbufplc);

	y1 = umost[x1]-1; y2 = y1;
	for(x=x1;x<=x2;x++)
	{
		twall = umost[x]-1;
		bwall = min(uplc[x],dmost[x]);
		if (twall < bwall-1)
		{
			if (twall >= y2)
			{
				while (y1 < y2-1) { y1++; hline(lastx[y1],x-1,y1,sectnum); }
				y1 = twall;
			}
			else
			{
				while (y1 < twall) { y1++; hline(lastx[y1],x-1,y1,sectnum); }
				while (y1 > twall) { lastx[y1] = x; y1--; }
			}

			while (y2 > bwall) { y2--; hline(lastx[y2],x-1,y2,sectnum); }
			while (y2 < bwall) { lastx[y2] = x; y2++; }
		}
		else
		{
			while (y1 < y2-1) { y1++; hline(lastx[y1],x-1,y1,sectnum); }
			y1 = umost[x+1]-1;
			y2 = y1;
		}
	}
	while (y1 < y2-1) { y1++; hline(lastx[y1],x2,y1,sectnum); }
	faketimerhandler();
}

florscan (long x1, long x2, short sectnum)
{
	long i, j, ox, oy, x, y1, y2, twall, bwall;

	if (palookup[sector[sectnum].floorpal] != globalpalwritten)
	{
		globalpalwritten = palookup[sector[sectnum].floorpal];
		setpalookupaddress(globalpalwritten);
	}

	globalzd = globalposz-sector[sectnum].floorz;
	if (globalzd > 0) return;
	globalpicnum = sector[sectnum].floorpicnum;
	if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
	setgotpic(globalpicnum);
	if ((tilesizx[globalpicnum] <= 0) || (tilesizy[globalpicnum] <= 0))
		return;
	if ((picanm[globalpicnum]&192) != 0)
		globalpicnum += animateoffs((short)globalpicnum,sectnum);
	if (waloff[globalpicnum] == 0) loadtile(globalpicnum);
	globalbufplc = waloff[globalpicnum];
	globalshade = (long)sector[sectnum].floorshade;
	globalorientation = (long)sector[sectnum].floorstat;


	if ((globalorientation&64) == 0)
	{
		globalx1 = singlobalang; globalx2 = singlobalang;
		globaly1 = cosglobalang; globaly2 = cosglobalang;
		globalxpanning = (globalposx<<20);
		globalypanning = -(globalposy<<20);
	}
	else
	{
		j = sector[sectnum].wallptr;
		ox = wall[wall[j].point2].x - wall[j].x;
		oy = wall[wall[j].point2].y - wall[j].y;
		i = ksqrtasm(ox*ox+oy*oy); if (i == 0) i = 1024; else i = 1048576/i;
		globalx1 = mulscale10(doublemulscale10(ox,singlobalang,-oy,cosglobalang),i);
		globaly1 = mulscale10(doublemulscale10(ox,cosglobalang,oy,singlobalang),i);
		globalx2 = -globalx1;
		globaly2 = -globaly1;

		ox = ((wall[j].x-globalposx)<<6); oy = ((wall[j].y-globalposy)<<6);
		i = doublemulscale14(oy,cosglobalang,-ox,singlobalang);
		j = doublemulscale14(ox,cosglobalang,oy,singlobalang);
		ox = i; oy = j;
		globalxpanning = globalx1*ox - globaly1*oy;
		globalypanning = globaly2*ox + globalx2*oy;
	}
	if ((globalorientation&8) == 0)
	{
		globalxshift = (8-(picsiz[globalpicnum]&15));
		globalyshift = (8-(picsiz[globalpicnum]>>4));
	}
	else if (picsiz[globalpicnum] == 0x66)
		{ globalxshift = 3; globalyshift = 3; }
	else
		{ globalxshift = 2; globalyshift = 2; }

	if ((globalorientation&0x4) > 0)
	{
		i = globalxpanning; globalxpanning = globalypanning; globalypanning = i;
		i = globalx2; globalx2 = -globaly1; globaly1 = -i;
		i = globalx1; globalx1 = globaly2; globaly2 = i;
	}
	if ((globalorientation&0x10) > 0) globalx1 = -globalx1, globaly1 = -globaly1, globalxpanning = -globalxpanning;
	if ((globalorientation&0x20) > 0) globalx2 = -globalx2, globaly2 = -globaly2, globalypanning = -globalypanning;
	globalx1 <<= globalxshift; globaly1 <<= globalxshift;
	globalx2 <<= globalyshift;  globaly2 <<= globalyshift;
	globalxpanning <<= globalxshift; globalypanning <<= globalyshift;
	globalxpanning += (((long)sector[sectnum].floorxpanning)<<24);
	globalypanning += (((long)sector[sectnum].floorypanning)<<24);
	globaly1 = (-globalx1-globaly1)*halfxdimen;
	globalx2 = (globalx2-globaly2)*halfxdimen;


	sethlinesizes(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4,globalbufplc);

	y1 = max(dplc[x1],umost[x1])-1; y2 = y1;
	for(x=x1;x<=x2;x++)
	{
		twall = max(dplc[x],umost[x])-1;
		bwall = dmost[x];
		if (twall < bwall-1)
		{
			if (twall >= y2)
			{
				while (y1 < y2-1) { y1++; hline(lastx[y1],x-1,y1,sectnum); }
				y1 = twall;
			}
			else
			{
				while (y1 < twall) { y1++; hline(lastx[y1],x-1,y1,sectnum); }
				while (y1 > twall) { lastx[y1] = x; y1--; }
			}
			while (y2 > bwall) { y2--; hline(lastx[y2],x-1,y2,sectnum); }
			while (y2 < bwall) { lastx[y2] = x; y2++; }
		}
		else
		{
			while (y1 < y2-1) { y1++; hline(lastx[y1],x-1,y1,sectnum); }
			y1 = max(dplc[x+1],umost[x+1])-1; y2 = y1;
		}
	}
	while (y1 < y2-1) { y1++; hline(lastx[y1],x2,y1,sectnum); }
	faketimerhandler();
}

wallscan(long x1, long x2, short *uwal, short *dwal, long *swal, long *lwal)
{
	char startplane, plane;
	long i, x, xinc, xinc3, startx, xnice, ynice, fpalookup;

	long y1v, y2v;                           //vline1
	long vplc, vinc, bufplc, palookupoffs;

	long y1ve[4], y2ve[4], shade, bad;       //vline4
	long vplce[4], vince[4], palookupoffse[4], bufplce[4];
	long u1, u4, d4, d1, dax, z, oldp, p, linum;

	long tsizx, tsizy;

	tsizx = tilesizx[globalpicnum];
	tsizy = tilesizy[globalpicnum];
	setgotpic(globalpicnum);
	if ((tsizx <= 0) || (tsizy <= 0)) return;
	if ((uwal[x1] > ydimen) && (uwal[x2] > ydimen)) return;
	if ((dwal[x1] < 0) && (dwal[x2] < 0)) return;

	if (waloff[globalpicnum] == 0) loadtile(globalpicnum);

	if ((globalorientation&256) > 0)
		globalyscale = -globalyscale, globalzd = -globalzd;

	if (x1 < 0) x1 = 0;
	if (x2 >= xdimen) x2 = xdimen-1;

	if (chainnumpages >= 2)
	{
		xinc = 4; xinc3 = 12;
		plane = (1<<((x1+viewoffset)&3));
		startplane = plane;
		if ((x2-x1) < 4) startplane = (1<<((x2+1+viewoffset)&3));
		koutp(0x3c5,plane);
	}
	else
	{
		xinc = 1; xinc3 = 3;
	}
	startx = x1;

	xnice = ((1<<(picsiz[globalpicnum]&15)) == tsizx);
	ynice = ((1<<(picsiz[globalpicnum]>>4)) == tsizy);
	fpalookup = FP_OFF(palookup[globalpal]);

	do
	{
		x = startx;
		while ((umost[x] > dmost[x]) && (x <= x2)) x += xinc;
		while (x <= x2-xinc3)
		{
			bad = 0;                                      //VLINE4

			dax = x;
			for(z=0;z<4;z++)
			{
				y1v = uwal[dax]; if (umost[dax] > y1v) y1v = umost[dax];
				y2v = dwal[dax]; if (dmost[dax] < y2v) y2v = dmost[dax];
				if ((y2v <= y1v) || (swal[dax] <= 4L))
					{ bad += (1<<z); dax += xinc; continue; }
				y2v--;

				vinc = divscale32(1L,swal[dax]);
				palookupoffse[z] = vinc;

				linum = (lwal[dax]>>6) + globalxpanning;
				if (xnice == 0) linum %= tsizx; else linum &= (tsizx-1);
				if (ynice == 0) linum *= tsizy; else linum <<= (picsiz[globalpicnum]>>4);
				bufplce[z] = waloff[globalpicnum]+linum;

				vinc *= globalyscale;
				vplce[z] = globalzd + optimul(vinc,y1v-globalhoriz+1);

				vince[z] = vinc; y1ve[z] = y1v; y2ve[z] = y2v;

				dax += xinc;
			}
			if (bad != 15)
			{
				shade = mulscale24(palookupoffse[0],globalvisibility)+globalshade;
				if (shade < 0) shade = 0;
				if (shade >= numpalookups) shade = numpalookups-1;
				palookupoffse[0] = fpalookup+(shade<<8);

				shade = mulscale24(palookupoffse[3],globalvisibility)+globalshade;
				if (shade < 0) shade = 0;
				if (shade >= numpalookups) shade = numpalookups-1;
				palookupoffse[3] = fpalookup+(shade<<8);

				if ((palookupoffse[0] == palookupoffse[3]) && ((bad&0x9) == 0))
				{
					palookupoffse[1] = palookupoffse[0];
					palookupoffse[2] = palookupoffse[0];
				}
				else
				{
					shade = mulscale24(palookupoffse[1],globalvisibility)+globalshade;
					if (shade < 0) shade = 0;
					if (shade >= numpalookups) shade = numpalookups-1;
					palookupoffse[1] = fpalookup+(shade<<8);

					shade = mulscale24(palookupoffse[2],globalvisibility)+globalshade;
					if (shade < 0) shade = 0;
					if (shade >= numpalookups) shade = numpalookups-1;
					palookupoffse[2] = fpalookup+(shade<<8);
				}

				u1 = ydimen; u4 = 0; d4 = u1; d1 = u4;
				for(z=0;z<4;z++)
				{
					if (y1ve[z] < u1) u1 = y1ve[z];
					if (y1ve[z] > u4) u4 = y1ve[z];
					if (y2ve[z] < d4) d4 = y2ve[z];
					if (y2ve[z] > d1) d1 = y2ve[z];
				}

				if ((bad > 0) || (u4 >= d4))
				{
					for(z=0;z<4;z++)
						if ((bad&(1<<z)) == 0)
						{
							if (chainnumpages >= 2)
								p = ylookup[y1ve[z]]+((x+viewoffset)>>2)+z+chainplace;
							else
								p = ylookup[y1ve[z]]+x+z+frameplace+viewoffset;
							vlineasm1(vince[z],palookupoffse[z],((y2ve[z]-y1ve[z])<<8)+globalshiftval,vplce[z],bufplce[z],p);
						}
				}
				else
				{
						//Draw 1 pixel at a time for top
					if (chainnumpages >= 2)
					{
						i = ((x+viewoffset)>>2)+chainplace;
						for(z=0;z<4;z++,i++)
							vplce[z] = vlineasm1(vince[z],palookupoffse[z],((u4-y1ve[z])<<8)+globalshiftval,vplce[z],bufplce[z],ylookup[y1ve[z]]+i);
					}
					else
					{
						i = x+frameplace+viewoffset;
						for(z=0;z<4;z++,i++)
							vplce[z] = vlineasm1(vince[z],palookupoffse[z],((u4-y1ve[z])<<8)+globalshiftval,vplce[z],bufplce[z],ylookup[y1ve[z]]+i);
					}

					//Draw 4 pixels at a time
					if (d4 > u4)
					{
						if (chainnumpages >= 2)
							p = ylookup[u4+1]+((x+viewoffset)>>2)+chainplace;
						else
							p = ylookup[u4+1]+x+frameplace+viewoffset;
						p = vlineasm4((long)(&vplce[0]),(long)(&vince[0]),((d4-u4-1)<<8)+globalshiftval,(long)(&bufplce[0]),(long)(&palookupoffse[0]),p);
					}

						//Draw 1 pixel at a time for bottom
					oldp = p;
					for(z=0;z<4;z++)
						if (y2ve[z] > d4)
							vlineasm1(vince[z],palookupoffse[z],((y2ve[z]-d4-1)<<8)+globalshiftval,vplce[z],bufplce[z],oldp+z);
				}
			}

			x += (xinc<<2);
		}
		while (x <= x2)
		{
			if (swal[x] > 4L)               //VLINE1
			{
				y1v = uwal[x]; if (y1v < umost[x]) y1v = umost[x];
				y2v = dwal[x]; if (y2v > dmost[x]) y2v = dmost[x];
				if (y2v > y1v)
				{
					y2v--;
					vinc = divscale32(1L,swal[x]);

					shade = mulscale24(vinc,globalvisibility)+globalshade;
					if (shade < 0) shade = 0;
					if (shade >= numpalookups) shade = numpalookups-1;
					palookupoffs = fpalookup+(shade<<8);

					vinc *= globalyscale;

					linum = (lwal[x]>>6) + globalxpanning;
					if (xnice == 0) linum %= tilesizx[globalpicnum]; else linum &= (tilesizx[globalpicnum]-1);
					if (ynice == 0) linum *= tilesizy[globalpicnum]; else linum <<= (picsiz[globalpicnum]>>4);
					bufplc = waloff[globalpicnum]+linum;

					vplc = globalzd + optimul(vinc,y1v-globalhoriz+1);

					if (chainnumpages >= 2)
						p = ylookup[y1v]+((x+viewoffset)>>2)+chainplace;
					else
						p = ylookup[y1v]+x+frameplace+viewoffset;
					vlineasm1(vinc,palookupoffs,((y2v-y1v)<<8)+globalshiftval,vplc,bufplc,p);
				}
			}

			x += xinc;
		}

		if (chainnumpages >= 2)
		{
			plane <<= 1; if (plane == 16) plane = 1;
			koutp(0x3c5,plane);
			startx++;
		}
	}
	while ((xinc == 4) && (plane != startplane));
	faketimerhandler();
}

maskwallscan(long x1, long x2, short *uwal, short *dwal, long *swal, long *lwal)
{
	char startplane, plane;
	long x, xinc, xinc3, startx, xnice, ynice, fpalookup;

	long y1v, y2v;                           //vline1
	long vplc, vinc, bufplc, palookupoffs;

	long y1ve[4], y2ve[4], shade, bad;       //vline4
	long vplce[4], vince[4], palookupoffse[4], bufplce[4];
	long u1, u4, d4, d1, dax, z, oldp, p, linum;

	setgotpic(globalpicnum);
	if ((tilesizx[globalpicnum] <= 0) || (tilesizy[globalpicnum] <= 0))
		return;
	if ((uwal[x1] > ydimen) && (uwal[x2] > ydimen)) return;
	if ((dwal[x1] < 0) && (dwal[x2] < 0)) return;

	if (waloff[globalpicnum] == 0) loadtile(globalpicnum);

	if ((globalorientation&256) > 0)
		globalyscale = -globalyscale, globalzd = -globalzd;

	if (x1 < 0) x1 = 0;
	if (x2 >= xdimen) x2 = xdimen-1;

	if (chainnumpages >= 2)
	{
		xinc = 4; xinc3 = 12;
		plane = (1<<((x1+viewoffset)&3));
		startplane = plane;
		if ((x2-x1) < 4) startplane = (1<<((x2+1+viewoffset)&3));
		koutp(0x3c5,plane);
	}
	else
	{
		xinc = 1; xinc3 = 3;
	}
	startx = x1;

	xnice = ((1<<(picsiz[globalpicnum]&15)) == tilesizx[globalpicnum]);
	ynice = ((1<<(picsiz[globalpicnum]>>4)) == tilesizy[globalpicnum]);
	fpalookup = FP_OFF(palookup[globalpal]);

	do
	{
		x = startx;
		while ((startumost[x+windowx1]-windowy1 > dmost[x]) && (x <= x2)) x += xinc;
		while (x <= x2-xinc3)
		{
			bad = 0;                               //MVLINE4

			dax = x;
			for(z=0;z<4;z++)
			{
				y1ve[z] = max(uwal[dax],startumost[dax+windowx1]-windowy1);
				y2ve[z] = min(dwal[dax],startdmost[dax+windowx1]-windowy1);
				y2ve[z]--;

				if ((y2ve[z] < y1ve[z]) || (swal[dax] <= 4L))
				{
					bad += (1<<z);

					dax += xinc;
					continue;
				}

				vince[z] = divscale32(1L,swal[dax]);
				palookupoffse[z] = vince[z];

				vince[z] *= globalyscale;

				linum = (lwal[dax]>>6) + globalxpanning;
				if (xnice == 0)
					linum %= tilesizx[globalpicnum];
				else
					linum &= (tilesizx[globalpicnum]-1);
				if (ynice == 0)
					linum *= tilesizy[globalpicnum];
				else
					linum <<= (picsiz[globalpicnum]>>4);
				bufplce[z] = waloff[globalpicnum]+linum;

				vplce[z] = globalzd + vince[z]*(y1ve[z]-globalhoriz+1);

				dax += xinc;
			}
			if (bad != 15)
			{
				shade = mulscale24(palookupoffse[0],globalvisibility)+globalshade;
				if (shade < 0) shade = 0;
				if (shade >= numpalookups) shade = numpalookups-1;
				palookupoffse[0] = fpalookup+(shade<<8);

				shade = mulscale24(palookupoffse[3],globalvisibility)+globalshade;
				if (shade < 0) shade = 0;
				if (shade >= numpalookups) shade = numpalookups-1;
				palookupoffse[3] = fpalookup+(shade<<8);

				if ((palookupoffse[0] == palookupoffse[3]) && ((bad&0x9) == 0))
				{
					palookupoffse[1] = palookupoffse[0];
					palookupoffse[2] = palookupoffse[0];
				}
				else
				{
					shade = mulscale24(palookupoffse[1],globalvisibility)+globalshade;
					if (shade < 0) shade = 0;
					if (shade >= numpalookups) shade = numpalookups-1;
					palookupoffse[1] = fpalookup+(shade<<8);

					shade = mulscale24(palookupoffse[2],globalvisibility)+globalshade;
					if (shade < 0) shade = 0;
					if (shade >= numpalookups) shade = numpalookups-1;
					palookupoffse[2] = fpalookup+(shade<<8);
				}

				u1 = ydimen; u4 = 0; d4 = u1; d1 = u4;
				for(z=0;z<4;z++)
				{
					if (y1ve[z] < u1) u1 = y1ve[z];
					if (y1ve[z] > u4) u4 = y1ve[z];
					if (y2ve[z] < d4) d4 = y2ve[z];
					if (y2ve[z] > d1) d1 = y2ve[z];
				}

				if ((bad > 0) || (u4 >= d4))
				{
					for(z=0;z<4;z++)
					if ((bad&(1<<z)) == 0)
					{
						if (chainnumpages >= 2)
							p = ylookup[y1ve[z]]+((x+viewoffset)>>2)+z+chainplace;
						else
							p = ylookup[y1ve[z]]+x+z+frameplace+viewoffset;
						mvlineasm1(vince[z],palookupoffse[z],(((long)(y2ve[z]-y1ve[z]))<<8)+globalshiftval,vplce[z],bufplce[z],p);
					}
				}
				else
				{
						//Draw 1 pixel at a time for top
					for(z=0;z<4;z++)
					{
						if (chainnumpages >= 2)
							p = ylookup[y1ve[z]]+((x+viewoffset)>>2)+z+chainplace;
						else
							p = ylookup[y1ve[z]]+x+z+frameplace+viewoffset;
						vplce[z] = mvlineasm1(vince[z],palookupoffse[z],(((long)(u4-y1ve[z]))<<8)+globalshiftval,vplce[z],bufplce[z],p);
					}

					//Draw 4 pixels at a time
					if (d4 > u4)
					{
						if (chainnumpages >= 2)
							p = ylookup[u4+1]+((x+viewoffset)>>2)+chainplace;
						else
							p = ylookup[u4+1]+x+frameplace+viewoffset;
						p = mvlineasm4((long)(&vplce[0]),(long)(&vince[0]),((d4-u4-1)<<8)+globalshiftval,(long)(&bufplce[0]),(long)(&palookupoffse[0]),p);
					}

						//Draw 1 pixel at a time for bottom
					oldp = p;
					for(z=0;z<4;z++)
						if (y2ve[z] > d4)
							mvlineasm1(vince[z],palookupoffse[z],(((long)(y2ve[z]-d4-1))<<8)+globalshiftval,vplce[z],bufplce[z],oldp+z);
				}
			}

			x += (xinc<<2);
		}
		while (x <= x2)
		{
			if (swal[x] > 4L)               //MVLINE1
			{
				y1v = max(uwal[x],startumost[x+windowx1]-windowy1);
				y2v = min(dwal[x],startdmost[x+windowx1]-windowy1);
				y2v--;

				if (y2v >= y1v)
				{
					vinc = divscale32(1L,swal[x]);

					shade = mulscale24(vinc,globalvisibility)+globalshade;
					if (shade < 0) shade = 0;
					if (shade >= numpalookups) shade = numpalookups-1;
					palookupoffs = FP_OFF(palookup[globalpal]) + (shade<<8);

					vinc *= globalyscale;

					linum = (lwal[x]>>6) + globalxpanning;
					if (xnice == 0)
						linum %= tilesizx[globalpicnum];
					else
						linum &= (tilesizx[globalpicnum]-1);
					if (ynice == 0)
					  linum *= tilesizy[globalpicnum];
					else
						linum <<= (picsiz[globalpicnum]>>4);
					bufplc = waloff[globalpicnum]+linum;

					vplc = globalzd + vinc*(y1v-globalhoriz+1);

					if (chainnumpages >= 2)
						p = ylookup[y1v]+((x+viewoffset)>>2)+chainplace;
					else
						p = ylookup[y1v]+x+frameplace+viewoffset;
					mvlineasm1(vinc,palookupoffs,(((long)(y2v-y1v))<<8)+globalshiftval,vplc,bufplc,p);
				}
			}

			x += xinc;
		}

		if (chainnumpages >= 2)
		{
			plane <<= 1; if (plane == 16) plane = 1;
			koutp(0x3c5,plane);
			startx++;
		}
	}
	while ((xinc == 4) && (plane != startplane));
	faketimerhandler();
}

transmaskwallscan(long x1, long x2)
{
	char startplane, plane;
	long x, startx;

	if (translucloaded == 0)
	{
		maskwallscan(x1,x2,uwall,dwall,swall,lwall);
		return;
	}

	setgotpic(globalpicnum);
	if ((tilesizx[globalpicnum] <= 0) || (tilesizy[globalpicnum] <= 0)) return;

	if (waloff[globalpicnum] == 0) loadtile(globalpicnum);

	if ((globalorientation&256) > 0)
		globalyscale = -globalyscale, globalzd = -globalzd;

	if (chainnumpages >= 2)
	{
		plane = ((x1+viewoffset)&3);
		startplane = plane;
		if ((x2-x1) < 4) startplane = ((x2+1+viewoffset)&3);
		startx = x1;
		do
		{
			koutp(0x3c5,1<<plane);
			koutpw(0x3ce,4+((((short)plane)&3)<<8));

			x = startx;
			while ((startumost[x+windowx1] > startdmost[x+windowx1]) && (x <= x2)) x += 4;
			while (x <= x2-4) transmaskvline2(x), x += 8;
			while (x <= x2) transmaskvline(x), x += 4;

			plane = ((plane+1)&3);
			startx++;
		}
		while (plane != startplane);
	}
	else
	{
		x = x1;
		while ((startumost[x+windowx1] > startdmost[x+windowx1]) && (x <= x2)) x++;
		while (x <= x2-1) transmaskvline2(x), x += 2;
		while (x <= x2) transmaskvline(x), x++;
	}
	faketimerhandler();
}

loadboard(char *filename, long *daposx, long *daposy, long *daposz,
			 short *daang, short *dacursectnum)
{
	short int fil, i, numsprites;

	if ((fil = open(filename,O_BINARY|O_RDWR,S_IREAD)) == -1)
	{
		mapversion = 6L;
		return(-1);
	}

	read(fil,&mapversion,4);
	if (mapversion != 6L) return(-1);

	initspritelists();

	clearbuf((long)(&show2dsector[0]),(long)((MAXSECTORS+3)>>5),0L);
	clearbuf((long)(&show2dsprite[0]),(long)((MAXSPRITES+3)>>5),0L);
	clearbuf((long)(&show2dwall[0]),(long)((MAXWALLS+3)>>5),0L);

	read(fil,daposx,4);
	read(fil,daposy,4);
	read(fil,daposz,4);
	read(fil,daang,2);
	read(fil,dacursectnum,2);

	read(fil,&numsectors,2);
	read(fil,&sector[0],sizeof(struct sectortype)*numsectors);

	read(fil,&numwalls,2);
	read(fil,&wall[0],sizeof(struct walltype)*numwalls);

	read(fil,&numsprites,2);
	read(fil,&sprite[0],sizeof(struct spritetype)*numsprites);

	for(i=0;i<numsprites;i++)
		insertsprite(sprite[i].sectnum,sprite[i].statnum);

		//Must be after loading sectors, etc!
	updatesector(*daposx,*daposy,dacursectnum);

	close(fil);
	return(0);
}

saveboard(char *filename, long *daposx, long *daposy, long *daposz,
			 short *daang, short *dacursectnum)
{
	short int fil, i, j, numsprites;

	if ((fil = open(filename,O_BINARY|O_TRUNC|O_CREAT|O_WRONLY,S_IWRITE)) == -1)
		return(-1);
	write(fil,&mapversion,4);

	write(fil,daposx,4);
	write(fil,daposy,4);
	write(fil,daposz,4);
	write(fil,daang,2);
	write(fil,dacursectnum,2);

	write(fil,&numsectors,2);
	write(fil,&sector[0],sizeof(struct sectortype)*numsectors);

	write(fil,&numwalls,2);
	write(fil,&wall[0],sizeof(struct walltype)*numwalls);

	numsprites = 0;
	for(j=0;j<MAXSTATUS;j++)
	{
		i = headspritestat[j];
		while (i != -1)
		{
			numsprites++;
			i = nextspritestat[i];
		}
	}
	write(fil,&numsprites,2);

	for(j=0;j<MAXSTATUS;j++)
	{
		i = headspritestat[j];
		while (i != -1)
		{
			write(fil,&sprite[i],sizeof(struct spritetype));
			i = nextspritestat[i];
		}
	}

	close(fil);
	return(0);
}

loadtables()
{
	long i, fil;

	if (tablesloaded == 0)
	{
		for(i=0;i<2048;i++) sqrtable[i] = calcksqrt(i<<20);
		if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
		{
			read(fil,&sintable[0],4096);
			read(fil,&tantable[0],4096);
			read(fil,&radarang[0],640);
			radarang[320] = 16384;
			read(fil,&textfont[0],1024);
			read(fil,&smalltextfont[0],1024);
			read(fil,&britable[0],1024);
			close(fil);
		}
		tablesloaded = 1;
	}
}

loadpalette()
{
	long i, j, fil;

	if (paletteloaded == 0)
	{
		if ((fil = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
		{
			numpalookups = ((filelength(fil)-768)>>7);
			if ((numpalookups&1) > 0)
			{   //Transluscent palette found in palette.dat
				numpalookups = ((numpalookups-255)>>1);

				if (translucloaded == 0)
				{
						//Allocate transluscent buffer
					if ((transluc = (char *)malloc(65536L)) != NULL)
					{
						fixtransluscence(FP_OFF(transluc));
						translucloaded = 1;
					}
					else if (cachesize >= 262144)
					{
						cachesize -= 65536L;
						initcache(FP_OFF(pic),cachesize);
						transluc = (char *)(FP_OFF(pic)+cachesize);
						fixtransluscence(FP_OFF(pic)+cachesize);
						translucloaded = 1;
					}
				}
			}
			else
			{    //No transluscent palette in palette.dat
				numpalookups >>= 1;
			}
			read(fil,&palette[0],768);

				//Allocate palookup buffer
			if ((palookup[0] = (char *)malloc(numpalookups<<8)) == NULL)
			{
				cachesize -= (numpalookups<<8);
				initcache(FP_OFF(pic),cachesize);
				palookup[0] = (char *)(FP_OFF(pic)+cachesize);
			}

			globalpal = 0;
			globalpalwritten = palookup[globalpal];
			setpalookupaddress(globalpalwritten);

			read(fil,palookup[globalpal],(numpalookups<<8));
			if (translucloaded == 1)
			{
				for(i=0;i<255;i++)
				{
					read(fil,&transluc[(i<<8)+i+1],255-i);
					for(j=i+1;j<256;j++)
						transluc[(j<<8)+i] = transluc[(i<<8)+j];
				}
				for(i=0;i<256;i++)
					transluc[(i<<8)+i] = i;
			}
			close(fil);
		}
		paletteloaded = 1;
	}
}

setgamemode()
{
	long i;

	if (qsetmode == 200) return;

	if ((ooption0 == 5) || (ooption0 == 6))
	{
		setvmode(0x13);
		if (ooption0 == 5) stereoinit();
		stereopage = 0;
	}
	else
	{
		if (vidoption == 0)
		{
			setvmode(0x13);
			if (setxmode(xdim,ydim) < 0)
			{
				setvmode(0x3);
				printf("%ld * %ld chained mode not supported\n",xdim,ydim);
				exit(0);
			}
			chainplace = 0xa0000;
			koutp(0x3c4,2);
		}
		if (vidoption == 1)
		{
			i = -1;
			if ((xdim == 320) && (ydim == 200)) setvmode(0x13); i = 1;
			if ((xdim == 640) && (ydim == 400)) i = setvesamode(0x100);
			if ((xdim == 640) && (ydim == 480)) i = setvesamode(0x101);
			if ((xdim == 800) && (ydim == 600)) i = setvesamode(0x103);
			if ((xdim == 1024) && (ydim == 768)) i = setvesamode(0x105);
			if ((xdim == 1280) && (ydim == 1024)) i = setvesamode(0x107);
			if ((xdim == 1600) && (ydim == 1200)) i = setvesamode(0x120);
			if (i < 0)
			{
				setvmode(0x3);
				printf("%ld * %ld Vesa mode not supported\n",xdim,ydim);
				exit(0);
			}
		}
		if (vidoption == 2)
		{
			setvmode(0x13);
		}
		if (vidoption == 3)
		{
			setvmode(0x13);
			koutpw(0x3ce,0x050f);
			koutpw(0x3d4,0x8529);
			koutpw(0x3c4,0x4806);
			koutpw(0x3d4,0x002f);   //set mod = 256k
		}
		if (vidoption == 4)
		{
			setvmode(0x13);
			koutpw(0x3d4,0x4838);           //S3 Extensions enable #1
			koutpw(0x3d4,0xa539);           //S3 Extensions enable #2
			koutp(0x3d4,0x31); koutp(0x3d5,kinp(0x3d5)|9);   //Init for start address
		}
	}
	clearallviews(0L);
	setbrightness((char)curbrightness);

	qsetmode = 200;
}

hline (long xl, long xr, long yp, short sectnum)
{
	long x, y, ox, oy, r, p, shade;

	if (xl > xr) return;
	r = mulscale10(globalzd,horizlookup2[yp-globalhoriz+MAXYDIM]);
	x = mulscale8(globalx1*xl + globaly1,r) + globalxpanning;
	y = mulscale8(globaly2*xl + globalx2,r) + globalypanning;
	asm1 = mulscale8(globalx1,r);
	asm2 = mulscale8(globaly2,r);

	shade = mulscale26(klabs(r),globalvisibility)+globalshade;
	if (shade < 0) shade = 0;
	if (shade >= numpalookups) shade = numpalookups-1;

	if (chainnumpages >= 2)
	{
		ox = asm1; asm1 <<= 2;
		oy = asm2; asm2 <<= 2;
		r = min(xr+1,xl+4); p = ylookup[yp]+chainplace;
		if (xl < r)   //First one
		{
			koutp(0x3c5,1<<((xl+viewoffset)&3));
			hlineasm64(((xr-xl)>>2)+1,0L,shade,y,x,p+((xl+viewoffset)>>2));
			x += ox; y += oy; xl++;
		}
		while (xl < r)
		{
			koutp(0x3c5,1<<((xl+viewoffset)&3));
			hlineasm64(((xr-xl)>>2)+1,-1L,shade,y,x,p+((xl+viewoffset)>>2));
			x += ox; y += oy; xl++;
		}
		return;
	}
	p = ylookup[yp]+xl+frameplace+viewoffset;
	hlineasm64(xr-xl+1,0L,shade,y,x,p);
}

transmaskvline (long x)
{
	short y1v, y2v;
	long vplc, vinc, p, bufplc, palookupoffs, linum, shade;

	if ((x < 0) || (x >= xdimen) || (swall[x] <= 4L)) return;

	y1v = max(uwall[x],startumost[x+windowx1]-windowy1);
	y2v = min(dwall[x],startdmost[x+windowx1]-windowy1);
	y2v--;

	if (y2v < y1v) return;

	vinc = divscale32(1L,swall[x]);

	shade = mulscale24(vinc,globalvisibility)+globalshade;
	if (shade < 0) shade = 0;
	if (shade >= numpalookups) shade = numpalookups-1;
	palookupoffs = FP_OFF(palookup[globalpal]) + (shade<<8);

	vinc *= globalyscale;
	vplc = globalzd + vinc*(y1v-globalhoriz+1);

	linum = (lwall[x]>>6) + globalxpanning;
	linum = (linum%tilesizx[globalpicnum])*tilesizy[globalpicnum];

	bufplc = waloff[globalpicnum]+linum;

	if (chainnumpages >= 2)
		p = ylookup[y1v]+((x+viewoffset)>>2)+chainplace;
	else
		p = ylookup[y1v]+x+frameplace+viewoffset;

	if (translucloaded == 0)
		mvlineasm1(vinc,palookupoffs,(((long)(y2v-y1v))<<8)+globalshiftval,vplc,bufplc,p);
	else
		tvlineasm1(vinc,palookupoffs,(((long)(y2v-y1v))<<8)+globalshiftval,vplc,bufplc,p);
}

transmaskvline2 (long x)
{
	short y1ve[2], y2ve[2];
	long vplce[2], vince[2], p, bufplce[2], palookupoffse[2], linum, shade;
	long cnt, y1, y2, xinc;

	if ((x < 0) || (x >= xdimen) || (swall[x] <= 4L) || (swall[x+1] <= 4L)) return;
	if (x == xdimen-1) { transmaskvline(x); return; }

	if (chainnumpages >= 2) xinc = 4; else xinc = 1;

	y1ve[0] = max(uwall[x],startumost[x+windowx1]-windowy1);
	y2ve[0] = min(dwall[x],startdmost[x+windowx1]-windowy1)-1;
	if (y2ve[0] < y1ve[0]) { transmaskvline(x+xinc); return; }
	y1ve[1] = max(uwall[x+xinc],startumost[x+windowx1+xinc]-windowy1);
	y2ve[1] = min(dwall[x+xinc],startdmost[x+windowx1+xinc]-windowy1)-1;
	if (y2ve[1] < y1ve[1]) { transmaskvline(x); return; }

	vince[0] = divscale32(1L,swall[x]);
	vince[1] = divscale32(1L,swall[x+xinc]);

	shade = mulscale24(vince[0],globalvisibility)+globalshade;
	if (shade < 0) shade = 0;
	if (shade >= numpalookups) shade = numpalookups-1;
	palookupoffse[0] = FP_OFF(palookup[globalpal]) + (shade<<8);

	shade = mulscale24(vince[1],globalvisibility)+globalshade;
	if (shade < 0) shade = 0;
	if (shade >= numpalookups) shade = numpalookups-1;
	palookupoffse[1] = FP_OFF(palookup[globalpal]) + (shade<<8);

	setuptvlineasm2(globalshiftval,palookupoffse[0],palookupoffse[1]);

	vince[0] *= globalyscale;
	vince[1] *= globalyscale;
	vplce[0] = globalzd + vince[0]*(y1ve[0]-globalhoriz+1);
	vplce[1] = globalzd + vince[1]*(y1ve[1]-globalhoriz+1);

	linum = (lwall[x]>>6) + globalxpanning;
	linum = (linum%tilesizx[globalpicnum])*tilesizy[globalpicnum];
	bufplce[0] = waloff[globalpicnum]+linum;

	linum = (lwall[x+xinc]>>6) + globalxpanning;
	linum = (linum%tilesizx[globalpicnum])*tilesizy[globalpicnum];
	bufplce[1] = waloff[globalpicnum]+linum;

	y1 = max(y1ve[0],y1ve[1]);
	y2 = min(y2ve[0],y2ve[1]);

	if (y1ve[0] != y1ve[1])
	{
		if (y1ve[0] < y1)
		{
			if (chainnumpages >= 2)
				p = ylookup[y1ve[0]]+((x+viewoffset)>>2)+chainplace;
			else
				p = ylookup[y1ve[0]]+x+frameplace+viewoffset;
			vplce[0] = tvlineasm1(vince[0],palookupoffse[0],((y1-y1ve[0]-1)<<8)+globalshiftval,vplce[0],bufplce[0],p);
		}
		else
		{
			if (chainnumpages >= 2)
				p = ylookup[y1ve[1]]+((x+viewoffset)>>2)+chainplace;
			else
				p = ylookup[y1ve[1]]+x+frameplace+viewoffset;
			vplce[1] = tvlineasm1(vince[1],palookupoffse[1],((y1-y1ve[1]-1)<<8)+globalshiftval,vplce[1],bufplce[1],p+1);
		}
	}

	if (y2 > y1)
	{
		if (chainnumpages >= 2)
			p = ylookup[y1]+((x+viewoffset)>>2)+chainplace;
		else
			p = ylookup[y1]+x+frameplace+viewoffset;
		asm1 = vince[1];
		asm2 = p + ylookup[y2-y1]+1;
		tvlineasm2(vplce[1],vince[0],bufplce[0],bufplce[1],vplce[0],p);
		vplce[0] = asm1; vplce[1] = asm2;
	}

	if (y2ve[0] != y2ve[1])
	{
		if (chainnumpages >= 2)
			p = ylookup[y2+1]+((x+viewoffset)>>2)+chainplace;
		else
			p = ylookup[y2+1]+x+frameplace+viewoffset;

		if (y2ve[0] > y2ve[1])
			tvlineasm1(vince[0],palookupoffse[0],((y2ve[0]-y2-1)<<8)+globalshiftval,vplce[0],bufplce[0],p);
		else
			tvlineasm1(vince[1],palookupoffse[1],((y2ve[1]-y2-1)<<8)+globalshiftval,vplce[1],bufplce[1],p+1);
	}
	faketimerhandler();
}

initengine(char davidoption, long daxdim, long daydim)
{
	long i, j;

	vidoption = davidoption; xdim = daxdim; ydim = daydim;

	loadtables();

	setview(0L,0L,xdim-1,ydim-1);

	pskyoff[0] = 0; pskybits = 0;

	parallaxtype = 2; parallaxyoffs = 0L;

	paletteloaded = 0;
	j = 0;
	for(i=0;i<=64;i++)
	{
		j = (i-64)*(i-64);
		rdist[i] = j*30;
		gdist[i] = j*59;
		bdist[i] = j*11;
	}
	for(i=65;i<128;i++)
	{
		rdist[i] = rdist[128-i];
		gdist[i] = gdist[128-i];
		bdist[i] = bdist[128-i];
	}

	searchx = halfxdimen; searchy = (ydimen>>1); searchit = 0; searchstat = -1;
	scaredfallz = (64<<8);

	horizlookup2[MAXYDIM-1] = (1<<28) / (320>>1);
	for(i=(MAXYDIM<<1)-1;i>=0;i--)
		if (i != (MAXYDIM-1))
		{
			horizlookup[i] = (1<<28) / (i-(MAXYDIM-1));
			horizlookup2[i] = (1<<28) / (320*klabs(i-(MAXYDIM-1)));
		}

	for(i=0;i<MAXPALOOKUPS;i++) palookup[i] = NULL;

	clearbuf((long)(&waloff[0]),(long)MAXTILES,0L);

	clearbuf((long)(&show2dsector[0]),(long)((MAXSECTORS+3)>>5),0L);
	clearbuf((long)(&show2dsprite[0]),(long)((MAXSPRITES+3)>>5),0L);
	clearbuf((long)(&show2dwall[0]),(long)((MAXWALLS+3)>>5),0L);
	automapping = 0;

	pointhighlight = -1;
	linehighlight = -1;
	highlightcnt = 0;

	for(i=0;i<=MAXYDIM+1;i++) lastx[i] = -1L;

	keyfifoplc = 0; keyfifoend = 0;
	oldkeyhandler = _dos_getvect(0x9);
	_disable(); _dos_setvect(0x9, keyhandler); _enable();

	resettiming();
	visibility = 512;
	clearbuf((long)(&keystatus[0]),64L,0L);

	switch(vidoption)
	{
		case 0:
			chainplace = 0xa0000;
			chainsiz = ((((xdim*ydim)>>2)+255)&0xffffff00);
			chainnumpages = 65536/chainsiz;

			if (chainnumpages == 1)
			{
				screen = (char *)malloc(xdim*ydim);
				frameplace = FP_OFF(screen);
			}
			if (chainnumpages >= 2)
				setvlinebpl(xdim>>2);
			else
				setvlinebpl(xdim);
			break;
		case 1:
			screen = (char *)malloc(xdim*ydim);
			frameplace = FP_OFF(screen);
			setvlinebpl(xdim);
			break;
		case 2:
			frameplace = 0xa0000;
			page = 0; koutp(0x3cd,page+(page<<4));
			break;
		case 3:
			frameplace = 0xa0000;
			page = 0; koutpw(0x3ce,0x9+(page<<12));
			break;
		case 4:
			frameplace = 0xa0000;
			page = 0; koutpw(0x3d4,0x35+(page<<8));
			break;
		case 5:
			screen = (char *)malloc(65536);
			frameplace = FP_OFF(screen);
			ooption0 = vidoption; vidoption = 1;
			stereofps = 1;
			stereowidth = 32768;
			stereopixelwidth = 32;
			break;
		case 6:
			screen = (char *)malloc(131072);
			frameplace = FP_OFF(screen);
			ooption0 = vidoption; vidoption = 1;
			stereofps = 1;
			stereowidth = 32768;
			stereopixelwidth = 32;
			break;
	}

	loadpalette();

	//videocard = getcard();

	if (chainnumpages >= 2)
	{
		j = 0;
		for(i=0;i<=ydim;i++) ylookup[i] = j, j += (xdim>>2);
	}
	else
	{
		j = 0;
		for(i=0;i<=ydim;i++) ylookup[i] = j, j += xdim;
	}
}

uninitengine()
{
	char *ptr;
	long i;

	_dos_setvect(0x9, oldkeyhandler);
	ptr = (char *)0x417;              //Turn off shift key status
	*ptr &= ~0x0f;                    //so the other keyboard handler
	ptr++;                            //doesn't think they're still stuck
	*ptr &= ~0x03;                    //down when you entered the engine

	koutp(0x43,54); koutp(0x40,255); koutp(0x40,255);

	if (artfil != -1) close(artfil);

	if (transluc != NULL)
	{
		free(transluc);         //Free buffers
		transluc = NULL;
	}
	if (pic != NULL)
	{
		free(pic);
		pic = NULL;
	}
	if (screen != NULL)
	{
		free(screen);
		screen = NULL;
	}
	for(i=0;i<MAXPALOOKUPS;i++)
		if (palookup[i] != NULL)
		{
			free(palookup[i]);
			palookup[i] = NULL;
		}
}

nextpage()
{
	long totbytes, i, j, k;

	switch(qsetmode)
	{
		case 200:
			if (stereofps != 0)
			{
				if (ooption0 == 5)
				{
					stereoblit(stereopage,&screen[0]);
					stereopage ^= 1;
				}
				else
				{
					if (stereopage == 0)
						redblueblit((&screen[0])+stereopixelwidth,&screen[65536]);
					stereopage ^= 1;
				}
			}
			else
			{
				switch(vidoption)
				{
					case 0:
						if (chainnumpages >= 2)
						{
							koutpw(0x3d4,0xc+(chainplace&0xff00));
							chainplace += chainsiz;
							if (chainplace+chainsiz >= 0xb0000) chainplace = 0xa0000;
							if (chainnumpages == 2)
							{
								limitrate();
								faketimerhandler();
							}
						}
						else
						{
							koutp(0x3c4,2); j = frameplace; k = 0xa0000;
							for(i=0;i<ydim;i+=2)
							{
								koutp(0x3c5,1); chainblit(j,k,xdim>>3);
								koutp(0x3c5,2); chainblit(j+1,k,xdim>>3);
								koutp(0x3c5,4); chainblit(j+2,k,xdim>>3);
								koutp(0x3c5,8); chainblit(j+3,k,xdim>>3);
								j += (xdim<<1); k += (xdim>>1);
								faketimerhandler();
							}
						}
						break;
					case 1:
						totbytes = (xdim*ydim);
						for(i=0;i<totbytes;i+=65536)
						{
							faketimerhandler();
							if ((xdim > 320) || (ydim > 200)) vesasetpage(i>>16);
							if (i+65536 <= totbytes)
								copybuf(frameplace+i,0xa0000,16384);
							else
								copybuf(frameplace+i,0xa0000,(totbytes-i)>>2);
						}
						break;
					case 2:
						koutpw(0x3d4,0xc+(page<<14));
						page = ((page+1)&3);
						koutp(0x3cd,page+(page<<4));
						break;
					case 3:
						koutpw(0x3d4,0xc+(page<<14));
						page = ((page+1)&3);
						koutpw(0x3ce,0x9+(page<<12));
						break;
					case 4:
						koutpw(0x3d4,0xc+(page<<14));
						page = ((page+1)&3);
						koutpw(0x3d4,0x35+(page<<8));
						break;
				}
			}
			break;

		case 350:
			koutpw(0x3d4,0xc+((pageoffset>>11)<<8));
			limitrate();
			pageoffset = 225280-pageoffset; //225280 is 352(multiple of 16)*640
			break;

		case 480:
			koutpw(0x3d4,0xc+((pageoffset>>11)<<8));
			limitrate();
			pageoffset = 399360-pageoffset;
			break;
	}
	faketimerhandler();

	numframes++;
}

loadtile (short tilenume)
{
	char *ptr;
	long i;

	if (walsiz[tilenume] <= 0) return;

	i = tilefilenum[tilenume];
	if (i != artfilnum)
	{
		if (artfil != -1) close(artfil);
		artfilnum = i;
		artfilplc = 0L;

		artfilename[7] = (i%10)+48;
		artfilename[6] = ((i/10)%10)+48;
		artfilename[5] = ((i/100)%10)+48;
		artfil = open(artfilename,O_BINARY|O_RDONLY,S_IREAD);
		faketimerhandler();
	}

	if (waloff[tilenume] == 0)
		allocache((long)&waloff[tilenume],walsiz[tilenume]);

	if (artfilplc != tilefileoffs[tilenume])
	{
		lseek(artfil,tilefileoffs[tilenume],SEEK_SET);
		faketimerhandler();
	}
	ptr = (char *)waloff[tilenume];
	read(artfil,ptr,walsiz[tilenume]);
	faketimerhandler();
	artfilplc = tilefileoffs[tilenume]+walsiz[tilenume];
}

allocatepermanenttile(short tilenume, long xsiz, long ysiz)
{
	long i, j, x, y, totsiz;

	if ((xsiz <= 0) || (ysiz <= 0) || ((tilenume & ~(MAXTILES-1)) != 0))
		return(-1);

	totsiz = xsiz*ysiz;
	if (cachesize-totsiz < 262144) return(-1);

	cachesize -= totsiz;
	waloff[tilenume] = FP_OFF(pic)+cachesize;
	tilesizx[tilenume] = xsiz;
	tilesizy[tilenume] = ysiz;
	walsiz[tilenume] = totsiz;
	picanm[tilenume] = 0;

	j = 15; while ((j > 0) && ((1<<j) > xsiz)) j--;
	picsiz[tilenume] = ((char)j);
	j = 15; while ((j > 0) && ((1<<j) > ysiz)) j--;
	picsiz[tilenume] += ((char)(j<<4));

	initcache(FP_OFF(pic),cachesize);
	return(waloff[tilenume]);
}

loadpics(char *filename)
{
	long offscount, siz;
	short int fil, i, j, k;

	for(i=0;i<MAXTILES;i++) walsiz[i] = 0;

	strcpy(artfilename,filename);

	for(i=0;i<MAXTILES;i++)
	{
		tilesizx[i] = 0;
		tilesizy[i] = 0;
		picanm[i] = 0L;
	}

	artsize = 0L;

	numtilefiles = 0;
	do
	{
		k = numtilefiles;

		artfilename[7] = (k%10)+48;
		artfilename[6] = ((k/10)%10)+48;
		artfilename[5] = ((k/100)%10)+48;
		if ((fil = open(artfilename,O_BINARY|O_RDONLY,S_IREAD)) != -1)
		{
			read(fil,&artversion,4);
			if (artversion != 1) return(-1);
			read(fil,&numtiles,4);
			read(fil,&localtilestart[k],4);
			read(fil,&localtileend[k],4);
			read(fil,&tilesizx[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<1);
			read(fil,&tilesizy[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<1);
			read(fil,&picanm[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<2);

			offscount = 4+4+4+4+((localtileend[k]-localtilestart[k]+1)<<3);
			for(i=localtilestart[k];i<=localtileend[k];i++)
			{
				tilefilenum[i] = k;
				tilefileoffs[i] = offscount;
				walsiz[i] = (long)(tilesizx[i]*tilesizy[i]);
				offscount += walsiz[i];
				artsize += walsiz[i];
			}
			close(fil);

			numtilefiles++;
		}
	}
	while (k != numtilefiles);

	clearbuf((long)(&gotpic[0]),(long)(MAXTILES>>5),0L);

	cachesize = artsize;
	while ((pic = (char *)malloc(cachesize)) == NULL)
	{
		cachesize -= 65536L;
		if (cachesize < 65536) return(-1);
	}
	initcache(FP_OFF(pic),cachesize);

	for(i=0;i<MAXTILES;i++)
	{
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizx[i])) j--;
		picsiz[i] = ((char)j);
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizy[i])) j--;
		picsiz[i] += ((char)(j<<4));
	}

	artfil = -1;
	artfilnum = -1;
	artfilplc = 0L;

	return(0);
}

showengineinfo()
{
	long templong;

	if (totalclock != 0)
	{
		templong = (numframes*12000L)/totalclock;
		printf("%d.%1d%1d frames per second\n",(short)(templong/100),(short)((templong/10)%10),(short)(templong%10));
	}
}

resettiming()
{
	numframes = 0L;
	totalclock = 0L;
	totalclocklock = 0L;
}

clipinsidebox(long x, long y, short wallnum, long walldist)
{
	long x1, y1, x2, y2, r;
	struct walltype *wal;

	r = (walldist<<1);
	wal = &wall[wallnum];     x1 = wal->x+walldist-x; y1 = wal->y+walldist-y;
	wal = &wall[wal->point2]; x2 = wal->x+walldist-x; y2 = wal->y+walldist-y;

	if ((x1 < 0) && (x2 < 0)) return(0);
	if ((y1 < 0) && (y2 < 0)) return(0);
	if ((x1 >= r) && (x2 >= r)) return(0);
	if ((y1 >= r) && (y2 >= r)) return(0);

	x2 -= x1; y2 -= y1;
	if (x2*(walldist-y1) >= y2*(walldist-x1))  //Front
	{
		if (x2 > 0) x2 *= (0-y1); else x2 *= (r-y1);
		if (y2 > 0) y2 *= (r-x1); else y2 *= (0-x1);
		return(x2 < y2);
	}
	if (x2 > 0) x2 *= (r-y1); else x2 *= (0-y1);
	if (y2 > 0) y2 *= (0-x1); else y2 *= (r-x1);
	return(x2 >= y2);
}

clipinsideboxline(long x, long y, long x1, long y1, long x2, long y2, long walldist)
{
	long r;

	r = (walldist<<1);

	x1 += walldist-x; x2 += walldist-x;
	if ((x1 < 0) && (x2 < 0)) return(0);
	if ((x1 >= r) && (x2 >= r)) return(0);

	y1 += walldist-y; y2 += walldist-y;
	if ((y1 < 0) && (y2 < 0)) return(0);
	if ((y1 >= r) && (y2 >= r)) return(0);

	x2 -= x1; y2 -= y1;
	if (x2*(walldist-y1) >= y2*(walldist-x1))  //Front
	{
		if (x2 > 0) x2 *= (0-y1); else x2 *= (r-y1);
		if (y2 > 0) y2 *= (r-x1); else y2 *= (0-x1);
		return(x2 < y2);
	}
	if (x2 > 0) x2 *= (r-y1); else x2 *= (0-y1);
	if (y2 > 0) y2 *= (0-x1); else y2 *= (r-x1);
	return(x2 >= y2);
}

readpixel16(long p)
{
	long mask, dat;

	mask = (1<<(p&7^7));

	if ((qsetmode == 480) && (ydim16 <= 336) && (p >= 640*336))
		p -= 640*336;
	else
		p += pageoffset;

	p >>= 3;

	koutp(0x3ce,0x4);
	koutp(0x3cf,0); dat = ((readpixel(p+0xa0000)&mask)>0);
	koutp(0x3cf,1); dat += (((readpixel(p+0xa0000)&mask)>0)<<1);
	koutp(0x3cf,2); dat += (((readpixel(p+0xa0000)&mask)>0)<<2);
	koutp(0x3cf,3); dat += (((readpixel(p+0xa0000)&mask)>0)<<3);
	return(dat);
}

screencapture(char *filename)
{
	char *ptr;
	long fil, i, bufplc, p, col, ncol, leng, numbytes, xres, inverseit;

	inverseit = (keystatus[0x2a]|keystatus[0x36]);

	filename[4] = ((capturecount/1000)%10)+48;
	filename[5] = ((capturecount/100)%10)+48;
	filename[6] = ((capturecount/10)%10)+48;
	filename[7] = (capturecount%10)+48;
	if ((fil=open(filename,O_BINARY|O_CREAT|O_TRUNC|O_WRONLY,S_IWRITE))==-1)
		return(-1);

	if (qsetmode == 200)
	{
		pcxheader[8] = ((xdim-1)&255); pcxheader[9] = (((xdim-1)>>8)&255);
		pcxheader[10] = ((ydim-1)&255); pcxheader[11] = (((ydim-1)>>8)&255);
		pcxheader[12] = (xdim&255); pcxheader[13] = ((xdim>>8)&255);
		pcxheader[14] = (ydim&255); pcxheader[15] = ((ydim>>8)&255);
		pcxheader[66] = (xdim&255); pcxheader[67] = ((xdim>>8)&255);
	}
	else
	{
		pcxheader[8] = ((640-1)&255); pcxheader[9] = (((640-1)>>8)&255);
		pcxheader[10] = ((qsetmode-1)&255); pcxheader[11] = (((qsetmode-1)>>8)&255);
		pcxheader[12] = (640&255); pcxheader[13] = ((640>>8)&255);
		pcxheader[14] = (qsetmode&255); pcxheader[15] = ((qsetmode>>8)&255);
		pcxheader[66] = (640&255); pcxheader[67] = ((640>>8)&255);
	}

	write(fil,&pcxheader[0],128);

	if (qsetmode == 200)
	{
		if (chainnumpages >= 2)
			ptr = (char *)chainplace;
		else
			ptr = (char *)frameplace;

		numbytes = xdim*ydim;
		xres = xdim;
	}
	else
	{
		numbytes = mul640(qsetmode);
		xres = 640;
	}

	bufplc = 0; p = 0;
	while (p < numbytes)
	{
		koutp(97,kinp(97)|3);

		if (qsetmode == 200)
		{
			if (chainnumpages >= 2)
				{ koutpw(0x3ce,((p&3)<<8)+4); col = *ptr; p++; if ((p&3) == 0) ptr++; }
			else
				{ col = *ptr; p++; ptr++; }
		}
		else
		{
			col = readpixel16(p);
			p++;
			if ((inverseit == 1) && (((col&7) == 0) || ((col&7) == 7))) col ^= 15;
		}

		leng = 1;

		if (qsetmode == 200)
		{
			if (chainnumpages >= 2)
				{ koutpw(0x3ce,((p&3)<<8)+4); ncol = *ptr; }
			else
				ncol = *ptr;
		}
		else
		{
			ncol = readpixel16(p);
			if ((inverseit == 1) && (((ncol&7) == 0) || ((ncol&7) == 7))) ncol ^= 15;
		}

		while ((ncol == col) && (p < numbytes) && (leng < 63) && ((p%xres) != 0))
		{
			leng++;

			if (qsetmode == 200)
			{
				if (chainnumpages >= 2)
					{ p++; if ((p&3) == 0) ptr++; koutpw(0x3ce,((p&3)<<8)+4); ncol = *ptr; }
				else
					{ p++; ptr++; ncol = *ptr; }
			}
			else
			{
				p++;
				ncol = readpixel16(p);
				if ((inverseit == 1) && (((ncol&7) == 0) || ((ncol&7) == 7))) ncol ^= 15;
			}
		}

		koutp(97,kinp(97)&252);

		if ((leng > 1) || (col >= 0xc0))
		{
			tempbuf[bufplc++] = (leng|0xc0);
			if (bufplc == 4096) { bufplc = 0; if (write(fil,&tempbuf[0],4096) < 4096) { close(fil); return(-1); } }
		}
		tempbuf[bufplc++] = col;
		if (bufplc == 4096) { bufplc = 0; if (write(fil,&tempbuf[0],4096) < 4096) { close(fil); return(-1); } }
	}

	tempbuf[bufplc++] = 0xc;
	if (bufplc == 4096) { bufplc = 0; if (write(fil,&tempbuf[0],4096) < 4096) { close(fil); return(-1); } }

	if (qsetmode == 200)
	{
		koutp(0x3c7,0);
		for(i=0;i<768;i++)
		{
			tempbuf[bufplc++] = (kinp(0x3c9)<<2);
			if (bufplc == 4096) { bufplc = 0; if (write(fil,&tempbuf[0],4096) < 4096) { close(fil); return(-1); } }
		}
	}
	else
	{
		for(i=0;i<768;i++)
		{
			if (i < 48)
				tempbuf[bufplc++] = (vgapal16[i]<<2);
			else
				tempbuf[bufplc++] = 0;
			if (bufplc == 4096) { bufplc = 0; if (write(fil,&tempbuf[0],4096) < 4096) { close(fil); return(-1); } }
		}

	}

	if (bufplc > 0)
		if (write(fil,&tempbuf[0],bufplc) < bufplc) { close(fil); return(-1); }

	close(fil);
	capturecount++;
	return(0);
}

inside(long x, long y, short sectnum)
{
	long i, x1, y1, x2, y2;
	char cnt;
	struct walltype *wal;

	if ((sectnum < 0) || (sectnum >= numsectors)) return(-1);
	cnt = 0;

	wal = &wall[sector[sectnum].wallptr];
	for(i=sector[sectnum].wallnum;i>0;i--)
	{
		y1 = wal->y-y; y2 = wall[wal->point2].y-y;
		if ((y1^y2) < 0)
		{
			x1 = wal->x-x; x2 = wall[wal->point2].x-x;

			if ((x1^x2) < 0)
				cnt ^= (x1*y2<x2*y1)^(y1<y2);
			else if (x1 >= 0)
				cnt ^= 1;
		}
		wal++;
	}
	return(cnt);
}

getangle(long xvect, long yvect)
{
	if ((xvect|yvect) == 0) return(0);
	if (xvect == 0) return(512+((yvect<0)<<10));
	if (yvect == 0) return(((xvect<0)<<10));
	if (xvect == yvect) return(256+((xvect<0)<<10));
	if (xvect == -yvect) return(768+((xvect>0)<<10));
	if (klabs(xvect) > klabs(yvect))
		return((((radarang[((yvect*(320>>1))/xvect)+(320>>1)]>>6)+((xvect<0)<<10))+2048)&2047);
	return((((radarang[(320>>1)-((xvect*(320>>1))/yvect)]>>6)+512+((yvect<0)<<10))+2048)&2047);
}

ksqrt(long num)
{
	return(ksqrtasm(num));
}

calcksqrt(long num)
{
	long root, temp;

	if (num < 0)
		return(-1);
	root = 128;
	do
	{
		temp = root;
		root = ((root+(num/root))>>1);
	}
	while (klabs(temp-root) > 1);
	return(root);
}

copytilepiece(long tilenume1, long sx1, long sy1, long xsiz, long ysiz,
				  long tilenume2, long sx2, long sy2)
{
	char *ptr1, *ptr2, dat;
	long xsiz1, ysiz1, xsiz2, ysiz2, i, j, x1, y1, x2, y2;

	xsiz1 = tilesizx[tilenume1]; ysiz1 = tilesizy[tilenume1];
	xsiz2 = tilesizx[tilenume2]; ysiz2 = tilesizy[tilenume2];
	if ((xsiz1 > 0) && (ysiz1 > 0) && (xsiz2 > 0) && (ysiz2 > 0))
	{
		if (waloff[tilenume1] == 0) loadtile(tilenume1);
		if (waloff[tilenume2] == 0) loadtile(tilenume2);

		x1 = sx1;
		for(i=0;i<xsiz;i++)
		{
			y1 = sy1;
			for(j=0;j<ysiz;j++)
			{
				x2 = sx2+i;
				y2 = sy2+j;
				if ((x2 >= 0) && (y2 >= 0) && (x2 < xsiz2) && (y2 < ysiz2))
				{
					ptr1 = (char *)(waloff[tilenume1] + x1*ysiz1 + y1);
					ptr2 = (char *)(waloff[tilenume2] + x2*ysiz2 + y2);
					dat = *ptr1;
					if (dat != 255)
						*ptr2 = *ptr1;
				}

				y1++; if (y1 >= ysiz1) y1 = 0;
			}
			x1++; if (x1 >= xsiz1) x1 = 0;
		}
	}
}

printext(long x, long y, char buffer[42], short tilenum, char invisiblecol)
{
	long p, startp, bufplc;
	char *ptr, ch, plane;
	unsigned char dat;
	short i, dax, day, theyinc;
	long dapage, danumpages, dachainplace;

	if (waloff[tilenum] == 0) loadtile(tilenum);
	setgotpic(tilenum);
	bufplc = waloff[tilenum];

	danumpages = 1;
	if (chainnumpages >= 2) danumpages = chainnumpages, dachainplace = 0xa0000;
	if (vidoption >= 2) danumpages = 4;

	for (dapage=0;dapage<danumpages;dapage++)
	{
		if (chainnumpages >= 2)
		{
			startp = ylookup[y]+(x>>2)+dachainplace;
			plane = (x&3);
			theyinc = ylookup[1];
		}
		else
		{
			startp = ylookup[y] + x+frameplace;
			theyinc = xdim;
			if (vidoption == 2) koutp(0x3cd,dapage+(dapage<<4));
			if (vidoption == 3) koutpw(0x3ce,0x9+(dapage<<12));
			if (vidoption == 4) koutpw(0x3d4,0x35+(dapage<<8));
		}

		i = 0;
		while (buffer[i] != 0)
		{
			ch = buffer[i];
			ptr = (char *)(bufplc+(((long)ch&15)<<9)+(((long)ch>>4)<<3));
			for(dax=0;dax<8;dax++)
			{
				p = startp;
				if (chainnumpages >= 2) koutpw(0x3c4,2+(256<<(plane&3)));

				if (invisiblecol == 255)
				{
					for(day=0;day<8;day++)
					{
						dat = *ptr;
						if (dat != 255) drawpixel(p,(long)dat);
						p += theyinc;
						ptr++;
					}
				}
				else
				{
					for(day=0;day<8;day++)
					{
						dat = *ptr;
						if (dat == 255) dat = invisiblecol;
						drawpixel(p,dat);
						p += theyinc;
						ptr++;
					}
				}
				if (chainnumpages >= 2)
				{
					plane++;
					if ((plane&3) == 0) startp++;
				}
				else
					startp++;

				ptr += (64-8);
			}
			i++;
		}
		if (chainnumpages >= 2) dachainplace += chainsiz;
	}

	if (vidoption == 2) koutp(0x3cd,page+(page<<4));
	if (vidoption == 3) koutpw(0x3ce,0x9+(page<<12));
	if (vidoption == 4) koutpw(0x3d4,0x35+(page<<8));
}

drawmasks()
{
	char tempchar;
	short tempshort;
	long i, j, k, gap, temp, templong;

	if (chainnumpages > 0) koutp(0x3c4,2);

	gap = (spritesortcnt>>1);  //Sort sprite list
	do
	{
		for(i=0;i<spritesortcnt-gap;i++)
		{
			temp = i;
			while ((spritey[temp] > spritey[temp+gap]) && (temp >= 0))
			{
				templong = spritex[temp]; spritex[temp] = spritex[temp+gap]; spritex[temp+gap] = templong;
				templong = spritey[temp]; spritey[temp] = spritey[temp+gap]; spritey[temp+gap] = templong;
				tempshort = spritepicnum[temp]; spritepicnum[temp] = spritepicnum[temp+gap]; spritepicnum[temp+gap] = tempshort;
				tempshort = thesprite[temp]; thesprite[temp] = thesprite[temp+gap]; thesprite[temp+gap] = tempshort;
				temp -= gap;
			}
		}
		gap >>= 1;
	}
	while (gap > 0);

	while ((spritesortcnt > 0) && (maskwallcnt > 0))  //While BOTH > 0
	{
		j = maskwall[maskwallcnt-1];
		if (spritewallfront((long)thesprite[spritesortcnt-1],(long)thewall[j]) == 0)
		{
			spritesortcnt--;
			drawsprite(spritex[spritesortcnt],spritey[spritesortcnt],spritepicnum[spritesortcnt],thesprite[spritesortcnt]);
		}
		else
		{
				//Check to see if any sprites behind the masked wall...
			k = -1;
			gap = 0;
			for(i=spritesortcnt-2;i>=0;i--)
				if ((xb1[j] <= (spritex[i]>>8)) && ((spritex[i]>>8) <= xb2[j]))
					if (spritewallfront((long)thesprite[i],(long)thewall[j]) == 0)
					{
						drawsprite(spritex[i],spritey[i],spritepicnum[i],thesprite[i]);
						thesprite[i] = -1;
						k = i;
						gap++;
					}
			if (k >= 0)       //remove holes in sprite list
			{
				for(i=k;i<spritesortcnt;i++)
					if (thesprite[i] >= 0)
					{
						if (i > k)
						{
							spritex[k] = spritex[i];
							spritey[k] = spritey[i];
							spritepicnum[k] = spritepicnum[i];
							thesprite[k] = thesprite[i];
						}
						k++;
					}
				spritesortcnt -= gap;
			}

				//finally safe to draw the masked wall
			maskwallcnt--;
			drawmaskwall(maskwallcnt);
		}
	}
	while (spritesortcnt > 0)                //Finish them off
	{
		spritesortcnt--;
		drawsprite(spritex[spritesortcnt],spritey[spritesortcnt],spritepicnum[spritesortcnt],thesprite[spritesortcnt]);
	}
	while (maskwallcnt > 0)                  //Finish them off
	{
		maskwallcnt--;
		drawmaskwall(maskwallcnt);
	}
}

drawmaskwall(short damaskwallcnt)
{
	long i, j, k, x, z, wallnum, sectnum, nextwallnum, nextsectnum;
	long z1, z2, llin, rlin, top, topinc, bot, botinc;
	long hplc, hinc, dax, lx, rx;

	z = maskwall[damaskwallcnt];
	wallnum = thewall[z];
	sectnum = thesector[z];
	nextwallnum = wall[wallnum].nextwall;
	nextsectnum = wall[wallnum].nextsector;
	z1 = sector[nextsectnum].ceilingz;
	if (sector[sectnum].ceilingz > z1) z1 = sector[sectnum].ceilingz;
	z2 = sector[nextsectnum].floorz;
	if (sector[sectnum].floorz < z2) z2 = sector[sectnum].floorz;
	if (z1 >= z2) return;

	topinc = -ry1[z] * wall[wallnum].xrepeat;
	top = (mulscale2(rx1[z],xdimen) - mulscale1(xb1[z]-halfxdimen,ry1[z])) * wall[wallnum].xrepeat;
	botinc = ((ry2[z]-ry1[z])>>1);
	bot = mulscale3(rx1[z]-rx2[z],xdimen) + mulscale1(xb1[z]-halfxdimen,botinc);

	for(x=xb1[z];x<=xb2[z]+1;x+=2)
	{
		if (bot != 0) lwall[x] = divscale8(top,bot);
		top += topinc, bot += botinc;
	}
	for(x=xb1[z]+1;x<=xb2[z];x+=2)
	  lwall[x] = ((lwall[x-1]+lwall[x+1])>>1);
	if (lwall[xb1[z]] < 0) lwall[xb1[z]] = 0;
	if (wall[wallnum].xrepeat > 0)
	{
		if (lwall[xb2[z]] >= ((long)wall[wallnum].xrepeat<<9))
			lwall[xb2[z]] = ((long)wall[wallnum].xrepeat<<9)-1;
	}

	if ((wall[wallnum].cstat&8) > 0)
	{
		j = ((long)wall[wallnum].xrepeat<<9)-1;
		for(x=xb1[z];x<=xb2[z];x++)
			lwall[x] = j-lwall[x];
	}

	if (xdimen == 320)
	{
		hplc = (65536*2048)/yb1[z];
		hinc = (65536*2048)/yb2[z];
	}
	else
	{
		hplc = divscale11(xdimenscale,yb1[z]);
		hinc = divscale11(xdimenscale,yb2[z]);
	}
	hinc = (hinc-hplc)/(xb2[z]-xb1[z]+1);

	wallmost(uwall,z,z1-globalposz);
	wallmost(dwall,z,z2-globalposz);
	qinterpolate((long)(&swall[xb1[z]]),xb2[z]-xb1[z],hplc,hinc);

	globalorientation = (long)wall[wallnum].cstat;
	globalpicnum = wall[wallnum].overpicnum;
	if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
	globalxpanning = (long)wall[wallnum].xpanning;
	globalypanning = (long)wall[wallnum].ypanning;
	if ((picanm[globalpicnum]&192) != 0)
		globalpicnum += animateoffs(globalpicnum,(short)wallnum+16384);
	globalshade = (long)wall[wallnum].shade;
	globalpal = (long)wall[wallnum].pal;
	globalshiftval = (picsiz[globalpicnum]>>4);
	if ((1<<globalshiftval) != tilesizy[globalpicnum]) globalshiftval++;
	globalshiftval = 32-globalshiftval;
	globalyscale = (wall[wallnum].yrepeat<<(globalshiftval-19));
	if ((globalorientation&4) == 0)
		globalzd = (((globalposz-z1)*globalyscale)<<8);
	else
		globalzd = (((globalposz-z2)*globalyscale)<<8);
	globalzd += (globalypanning<<24);

	for(i=0;i<smostwallcnt;i++)
	{
		j = (smostwall[i]&16383);
		lx = xb1[j];
		rx = xb2[j];

		if ((lx <= xb2[z]) && (rx >= xb1[z]))
			if (wallfront(j,z) == 0)
			{
				if (lx < xb1[z]) lx = xb1[z];
				if (rx > xb2[z]) rx = xb2[z];

				switch(smostwall[i]&0xc000)
				{
					case 0:
						k = ((rx-lx+1)<<1);
						clearbufbyte((long)&uwall[lx],k,0x00010001);
						clearbufbyte((long)&dwall[lx],k,0x00000000);
						break;
					case 16384:
						k = smoststart[i] - xb1[j];
						for(x=lx;x<=rx;x++)
							if (smost[k+x] > uwall[x]) uwall[x] = smost[k+x];
						break;
					case 32768:
						k = smoststart[i] - xb1[j];
						for(x=lx;x<=rx;x++)
							if (smost[k+x] < dwall[x]) dwall[x] = smost[k+x];
						break;
				}
			}
	}

	if (searchit >= 1)
		if ((searchx >= xb1[z]) && (searchx <= xb2[z]))
			if ((searchy >= uwall[searchx]) && (searchy <= dwall[searchx]))
			{
				searchsector = sectnum;
				searchwall = wallnum;
				searchstat = 4;  //maskwall
				searchit = 1;
			}

	if ((globalorientation&128) == 0)
		maskwallscan(xb1[z],xb2[z],uwall,dwall,swall,lwall);
	else
		transmaskwallscan(xb1[z],xb2[z]);
}

drawsprite (long xb, long yp, short tilenum, short spritenum)
{
	char cstat, seesprite, swapped, palnum;
	signed short shade;
	long um, dm, startum, startdm, das, sectnum;
	long siz, xsiz, ysiz, xoff, yoff, xspan, yspan, templong;
	long x1, y1, x2, y2, lx, rx, dalx2, darx2, i, j, k, x, linum, linuminc;
	long yplc, yinc, p, tileoffs, bufplc, palookupoffs;
	long z, z1, z2, xp1, yp1, xp2, yp2;        //Mask-type wall variables...
	long xs, ys, xpos, ypos, xv, yv, top, topinc, bot, botinc, hplc, hinc;
	long templong1;

	long cosang, sinang, dax, day;
	long npoints, npoints2, zz, t, zsgn, zzsgn;
	long lpoint, lmax, rpoint, rmax, dax1, dax2, y;
	struct spritetype *spr;
	struct sectortype *sec;

	if ((picanm[tilenum]&192) != 0)
		tilenum += animateoffs(tilenum,spritenum+32768);
	if ((tilesizx[tilenum] <= 0) || (tilesizy[tilenum] <= 0) || (spritenum < 0))
		return;

	spr = &sprite[spritenum];

	sectnum = spr->sectnum; sec = &sector[sectnum];
	cstat = spr->cstat;
	palnum = spr->pal;
	if (((cstat&2) > 0) && (translucloaded == 0)) cstat &= ~2;

	xoff = (long)((signed char)((picanm[tilenum]>>8)&255))+((long)spr->xoffset);
	yoff = (long)((signed char)((picanm[tilenum]>>16)&255))+((long)spr->yoffset);

	if (((cstat&48) == 0) || ((cstat&48) == 48))
	{
		if (yp <= (4<<8)) return;

		siz = divscale32(8L,yp);
		if (xdimen != 320) siz = mulscale16(siz,xdimenscale);

		xspan = tilesizx[tilenum];
		yspan = tilesizy[tilenum];
		xsiz = mulscale14(siz,spr->xrepeat*xspan);
		ysiz = mulscale14(siz,spr->yrepeat*yspan);

		if (((tilesizx[tilenum]>>11) >= xsiz) || (yspan >= (ysiz>>1)))
			return;  //Watch out for divscale overflow

		x1 = xb-(xsiz>>1);
		if (xspan&1) x1 += mulscale15(siz,spr->xrepeat);  //Odd xspans
		templong = mulscale14(siz,spr->xrepeat*xoff);
		if ((cstat&4) == 0)
			x1 -= templong;
		else
			x1 += templong;

		y1 = mulscale16(spr->z-globalposz,siz);
		y1 -= mulscale14(siz,spr->yrepeat*yoff);
		y1 += (globalhoriz<<8)-ysiz;
		if (cstat&128)
		{
			y1 += (ysiz>>1);
			if (yspan&1) y1 += mulscale15(siz,spr->yrepeat);  //Odd yspans
		}

		x2 = x1+xsiz;
		y2 = y1+ysiz;
		if ((y1|255) >= (y2|255)) return;

		lx = (x1>>8)+1; if (lx < 0) lx = 0;
		rx = (x2>>8); if (rx >= xdimen) rx = xdimen-1;

		shade = mulscale27(yp,globalvisibility)+spr->shade+6;
		if ((sec->ceilingstat&1) > 0)
			shade += ((signed short)sec->ceilingshade);
		else
			shade += ((signed short)sec->floorshade);
		if (shade < 0) shade = 0;
		if (shade >= numpalookups) shade = numpalookups-1;
		palookupoffs = FP_OFF(palookup[palnum]) + (((long)shade)<<8);

		if (waloff[tilenum] == 0) loadtile(tilenum);
		setgotpic(tilenum);
		tileoffs = waloff[tilenum];

		yinc = divscale32(yspan,ysiz);

		if ((sec->ceilingstat&1) == 0)
			startum = globalhoriz+mulscale24(siz,sec->ceilingz-globalposz)-1;
		else
			startum = 0;
		if ((sec->floorstat&1) == 0)
			startdm = globalhoriz+mulscale24(siz,sec->floorz-globalposz)+1;
		else
			startdm = 0x7fffffff;
		if ((y1>>8) > startum) startum = (y1>>8);
		if ((y2>>8) < startdm) startdm = (y2>>8);

		if (startum < -32768) startum = -32768;
		if (startdm > 32767) startdm = 32767;
		if (startum >= startdm) return;

		if ((cstat&4) == 0)
		{
			linuminc = divscale20(xspan,xsiz);
			linum = mulscale8((lx<<8)-x1,linuminc);
		}
		else
		{
			linuminc = -divscale20(xspan,xsiz);
			linum = mulscale8((lx<<8)-x2,linuminc);
		}
		if ((cstat&8) > 0)
		{
			yinc = -yinc;
			templong = y1; y1 = y2; y2 = templong;
		}

		seesprite = 0;

		for(x=lx;x<=rx;x++)
		{
			uwall[x] = max(startumost[x+windowx1]-windowy1,(short)startum);
			dwall[x] = min(startdmost[x+windowx1]-windowy1,(short)startdm);
		}
		for(i=0;i<smostwallcnt;i++)
		{
			j = (smostwall[i]&16383);
			dalx2 = xb1[j];
			darx2 = xb2[j];

			if ((dalx2 <= rx) && (darx2 >= lx))
				if ((yp > (yb1[j]<<8)) || (yp > (yb2[j]<<8)))
					if ((spritewallfront((long)spritenum,(long)thewall[j]) == 0) || ((yp > (yb1[j]<<8)) && (yp > (yb2[j]<<8))))
					{
						if (dalx2 < lx) dalx2 = lx;
						if (darx2 > rx) darx2 = rx;

						switch(smostwall[i]&0xc000)
						{
							case 0:
								clearbufbyte((long)&dwall[dalx2],(darx2-dalx2+1)<<1,0+(0<<16));
								break;
							case 16384:
								k = smoststart[i] - xb1[j];
								for(x=dalx2;x<=darx2;x++)
									if (smost[k+x] > uwall[x]) uwall[x] = smost[k+x];
								break;
							case 32768:
								k = smoststart[i] - xb1[j];
								for(x=dalx2;x<=darx2;x++)
									if (smost[k+x] < dwall[x]) dwall[x] = smost[k+x];
								break;
						}
					}
		}

		if (searchit >= 1)
			if ((searchx >= lx) && (searchx <= rx))
				if ((searchy >= uwall[searchx]) && (searchy < dwall[searchx]))
				{
					searchsector = sectnum;
					searchwall = spritenum;
					searchstat = 3;  //sprite
					searchit = 1;
				}

		for(x=lx;x<=rx;x++)
		{
			um = uwall[x];
			dm = dwall[x]-1;

			if (um < dm)
			{
				seesprite = 1;

				bufplc = tileoffs+(linum>>12)*yspan;

				yplc = mulscale8(((um+1)<<8)-y1,yinc);

				if (chainnumpages >= 2)
				{
					p = ylookup[um]+((x+viewoffset)>>2)+chainplace;
					koutp(0x3c5,1<<((x+viewoffset)&3));
					koutpw(0x3ce,4+(((x+viewoffset)&3)<<8));
				}
				else
					p = ylookup[um] + x+frameplace+viewoffset;

				if ((cstat&2) == 0)
					mvlineasm1(yinc,palookupoffs,((long)(dm-um)<<8)+24,yplc,bufplc,p);
				else
					tvlineasm1(yinc,palookupoffs,((long)(dm-um)<<8)+24,yplc,bufplc,p);
			}
			linum += linuminc;
		}

		if (automapping == 1)
			if (seesprite == 1)
				show2dsprite[spritenum>>3] |= (1<<(spritenum&7));

		faketimerhandler();
	}
	else if ((cstat&48) == 16)
	{
		if ((cstat&4) > 0) xoff = -xoff;
		if ((cstat&8) > 0) yoff = -yoff;

		xspan = tilesizx[tilenum];
		yspan = tilesizy[tilenum];
		xv = spr->xrepeat*sintable[(spr->ang+2560+1536)&2047];
		yv = spr->xrepeat*sintable[(spr->ang+2048+1536)&2047];
		xs = spr->x - mulscale16(xv,(xspan>>1)+xoff) - globalposx;
		ys = spr->y - mulscale16(yv,(xspan>>1)+xoff) - globalposy;
		xp1 = doublemulscale14(ys,cosglobalang,-xs,singlobalang);
		yp1 = doublemulscale14(xs,cosglobalang,ys,singlobalang);
		xs += mulscale16(xv,xspan);
		ys += mulscale16(yv,xspan);
		xp2 = doublemulscale14(ys,cosglobalang,-xs,singlobalang);
		yp2 = doublemulscale14(xs,cosglobalang,ys,singlobalang);

		if ((yp1 <= 0) && (yp2 <= 0)) return;

		swapped = 0;
		if (xp1*yp2 > xp2*yp1)     //If wall's NOT facing you
		{
			if ((cstat&64) != 0) return;
			templong = xp1, xp1 = xp2, xp2 = templong;
			templong = yp1, yp1 = yp2, yp2 = templong;
			swapped = 1;
		}

		if (xp1 >= -yp1)
		{
			if (xp1 > yp1) return;

			if (yp1 == 0) return;
			xb1[MAXWALLSB-1] = halfxdimen + scale(xp1,halfxdimen,yp1);
			if (xp1 >= 0) xb1[MAXWALLSB-1]++;   //Fix for SIGNED divide
			if (xb1[MAXWALLSB-1] >= xdimen) xb1[MAXWALLSB-1] = xdimen-1;
			yb1[MAXWALLSB-1] = yp1;
		}
		else
		{
			if (xp2 < -yp2) return;
			xb1[MAXWALLSB-1] = 0;
			templong1 = yp1-yp2+xp1-xp2;
			if (templong1 == 0) return;
			yb1[MAXWALLSB-1] = yp1 + scale(yp2-yp1,xp1+yp1,templong1);
		}
		if (xp2 <= yp2)
		{
			if (xp2 < -yp2) return;

			if (yp2 == 0) return;
			xb2[MAXWALLSB-1] = halfxdimen + scale(xp2,halfxdimen,yp2) - 1;
			if (xp2 >= 0) xb2[MAXWALLSB-1]++;   //Fix for SIGNED divide
			if (xb2[MAXWALLSB-1] >= xdimen) xb2[MAXWALLSB-1] = xdimen-1;
			yb2[MAXWALLSB-1] = yp2;
		}
		else
		{
			if (xp1 > yp1) return;

			xb2[MAXWALLSB-1] = xdimen-1;
			templong1 = xp2-xp1+yp1-yp2;
			if (templong1 == 0) return;
			yb2[MAXWALLSB-1] = yp1 + scale(yp2-yp1,yp1-xp1,templong1);
		}

		if ((yb1[MAXWALLSB-1] <= 0) || (yb2[MAXWALLSB-1] <= 0) || (xb1[MAXWALLSB-1] > xb2[MAXWALLSB-1]))
			return;

		topinc = -((yp1*xspan)>>3);
		top = (((mulscale2(xp1,xdimen) - mulscale1(xb1[MAXWALLSB-1]-halfxdimen,yp1))*xspan)>>3);
		botinc = ((yp2-yp1)>>1);
		bot = mulscale3(xp1-xp2,xdimen) + mulscale1(xb1[MAXWALLSB-1]-halfxdimen,botinc);
		for(x=xb1[MAXWALLSB-1];x<=xb2[MAXWALLSB-1]+1;x+=2)
		{
			if (bot != 0) lwall[x] = divscale8(top,bot);
			top += topinc, bot += botinc;
		}
		for(x=xb1[MAXWALLSB-1]+1;x<=xb2[MAXWALLSB-1];x+=2)
			lwall[x] = ((lwall[x-1]+lwall[x+1])>>1);

		if (lwall[xb1[MAXWALLSB-1]] < 0) lwall[xb1[MAXWALLSB-1]] = 0;
		if (lwall[xb2[MAXWALLSB-1]] >= (xspan<<6)) lwall[xb2[MAXWALLSB-1]] = (xspan<<6)-1;

		if ((swapped^((cstat&4)>0)) > 0)
		{
			j = (xspan<<6)-1;
			for(x=xb1[MAXWALLSB-1];x<=xb2[MAXWALLSB-1];x++)
				lwall[x] = j-lwall[x];
		}

		rx1[MAXWALLSB-1] = xp1; ry1[MAXWALLSB-1] = yp1;
		rx2[MAXWALLSB-1] = xp2; ry2[MAXWALLSB-1] = yp2;

		y1 = (2097152*64)/yb1[MAXWALLSB-1];
		y2 = (2097152*64)/yb2[MAXWALLSB-1];
		hplc = y1;
		hinc = (y2-y1)/(xb2[MAXWALLSB-1]-xb1[MAXWALLSB-1]+1);
		if (xdimen != 320)
		{
			hplc = mulscale16(hplc,xdimenscale);
			hinc = mulscale16(hinc,xdimenscale);
		}

		z2 = spr->z - ((yoff*spr->yrepeat)<<2);
		if (cstat&128)
		{
			z2 += ((yspan*spr->yrepeat)<<1);
			if (yspan&1) z2 += (spr->yrepeat<<1);        //Odd yspans
		}
		z1 = z2 - ((yspan*spr->yrepeat)<<2);

		globalpal = palnum;
		globalorientation = 0;
		globalpicnum = tilenum;
		if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
		globalxpanning = 0L;
		globalypanning = 0L;
		globalshade = (long)spr->shade+6;
		if ((sec->ceilingstat&1) > 0)
			globalshade += ((long)sec->ceilingshade);
		else
			globalshade += ((long)sec->floorshade);
		globalshiftval = (picsiz[globalpicnum]>>4);
		if ((1<<globalshiftval) != tilesizy[globalpicnum]) globalshiftval++;
		globalshiftval = 32-globalshiftval;
		globalyscale = divscale(512,spr->yrepeat,globalshiftval-19);
		globalzd = (((globalposz-z1)*globalyscale)<<8);
		if ((cstat&8) > 0)
		{
			globalyscale = -globalyscale;
			globalzd = (((globalposz-z2)*globalyscale)<<8);
		}

		if ((sec->ceilingstat&1) == 0)
			if (z1 < sec->ceilingz) z1 = sec->ceilingz;
		if ((sec->floorstat&1) == 0)
			if (z2 > sec->floorz) z2 = sec->floorz;

		wallmost(uwall,(long)(MAXWALLSB-1),z1-globalposz);
		wallmost(dwall,(long)(MAXWALLSB-1),z2-globalposz);
		qinterpolate((long)(&swall[xb1[MAXWALLSB-1]]),xb2[MAXWALLSB-1]-xb1[MAXWALLSB-1],hplc,hinc);

		for(i=0;i<smostwallcnt;i++)
		{
			j = (smostwall[i]&16383);
			dalx2 = xb1[j];
			darx2 = xb2[j];

			if ((dalx2 <= xb2[MAXWALLSB-1]) && (darx2 >= xb1[MAXWALLSB-1]))
				if ((yp > (yb1[j]<<8)) || (yp > (yb2[j]<<8)))
				{
						//if (spritewallfront(spritenum,thewall[j]) == 0)
					x = thewall[j]; xp1 = wall[x].x; yp1 = wall[x].y;
					x = wall[x].point2; xp2 = wall[x].x; yp2 = wall[x].y;
					x = (xp2-xp1)*(spr->y-yp1)-(spr->x-xp1)*(yp2-yp1);
					if ((x < 0) || ((x == 0) && (wall[thewall[j]].nextsector == spr->sectnum)))
					{
						if (dalx2 < xb1[MAXWALLSB-1]) dalx2 = xb1[MAXWALLSB-1];
						if (darx2 > xb2[MAXWALLSB-1]) darx2 = xb2[MAXWALLSB-1];

						switch(smostwall[i]&0xc000)
						{
							case 0:
								for(x=dalx2;x<=darx2;x++)
								  dwall[x] = -1;
								break;
							case 16384:
								k = smoststart[i] - xb1[j];
								for(x=dalx2;x<=darx2;x++)
									if (smost[k+x] > uwall[x]) uwall[x] = smost[k+x];
								break;
							case 32768:
								k = smoststart[i] - xb1[j];
								for(x=dalx2;x<=darx2;x++)
									if (smost[k+x] < dwall[x]) dwall[x] = smost[k+x];
								break;
						}
					}
				}
		}

		if (searchit >= 1)
			if ((searchx >= xb1[MAXWALLSB-1]) && (searchx <= xb2[MAXWALLSB-1]))
				if ((searchy >= uwall[searchx]) && (searchy <= dwall[searchx]))
				{
					searchsector = sectnum;
					searchwall = spritenum;
					searchstat = 3;  //sprite
					searchit = 1;
				}

		if ((cstat&2) == 0)
			maskwallscan(xb1[MAXWALLSB-1],xb2[MAXWALLSB-1],uwall,dwall,swall,lwall);
		else
			transmaskwallscan(xb1[MAXWALLSB-1],xb2[MAXWALLSB-1]);
	}
	else if ((cstat&48) == 32)
	{
		if ((cstat&64) != 0)
			if ((globalposz > spr->z) == ((cstat&8)==0))
				return;

		if ((cstat&4) > 0) xoff = -xoff;
		if ((cstat&8) > 0) yoff = -yoff;
		xspan = tilesizx[tilenum];
		yspan = tilesizy[tilenum];

			//Rotate center point
		dax = spr->x-globalposx;
		day = spr->y-globalposy;
		rzi[0] = doublemulscale10(cosglobalang,dax,singlobalang,day);
		rxi[0] = doublemulscale10(cosglobalang,day,-singlobalang,dax);

			//Get top-left corner
		i = ((spr->ang+2048-globalang)&2047);
		cosang = sintable[(i+512)&2047]; sinang = sintable[i];
		dax = ((xspan>>1)+xoff)*spr->xrepeat;
		day = ((yspan>>1)+yoff)*spr->yrepeat;
		rzi[0] += doublemulscale12(sinang,dax,cosang,day);
		rxi[0] += doublemulscale12(sinang,day,-cosang,dax);

			//Get other 3 corners
		dax = xspan*spr->xrepeat;
		day = yspan*spr->yrepeat;
		rzi[1] = rzi[0]-mulscale12(sinang,dax);
		rxi[1] = rxi[0]+mulscale12(cosang,dax);
		dax = -mulscale12(cosang,day);
		day = -mulscale12(sinang,day);
		rzi[2] = rzi[1]+dax; rxi[2] = rxi[1]+day;
		rzi[3] = rzi[0]+dax; rxi[3] = rxi[0]+day;

			//Put all points on same z
		ryi[0] = divscale(spr->z-globalposz,320,8);
		if (ryi[0] == 0) return;
		ryi[1] = ryi[0]; ryi[2] = ryi[0]; ryi[3] = ryi[0];

		if ((cstat&4) == 0)
			{ z = 0; z1 = 1; z2 = 3; }
		else
			{ z = 1; z1 = 0; z2 = 2; }

			//Calculate globals for hline texture mapping function
		globalxpanning = (rxi[z]<<12);
		globalypanning = (rzi[z]<<12);
		globalzd = (ryi[z]<<12);

		dax = rzi[z1]-rzi[z]; day = rxi[z1]-rxi[z];
		bot = doublemulscale8(dax,dax,day,day);
		if (((klabs(dax)>>14) >= bot) || ((klabs(day)>>14) >= bot)) return;
		globalx1 = divscale18(dax,bot);
		globalx2 = divscale18(day,bot);

		dax = rzi[z2]-rzi[z]; day = rxi[z2]-rxi[z];
		bot = doublemulscale8(dax,dax,day,day);
		if (((klabs(dax)>>14) >= bot) || ((klabs(day)>>14) >= bot)) return;
		globaly1 = divscale18(dax,bot);
		globaly2 = divscale18(day,bot);

		if (ryi[0] < 0)   //If ceilsprite is above you, reverse order of points
		{
			templong = rxi[1]; rxi[1] = rxi[3]; rxi[3] = templong;
			templong = rzi[1]; rzi[1] = rzi[3]; rzi[3] = templong;
		}

			//Clip polygon in 3-space
		npoints = 4;

			//Clip edge 1
		npoints2 = 0;
		zzsgn = rxi[0]+rzi[0];
		for(z=0;z<npoints;z++)
		{
			zz = z+1; if (zz == npoints) zz = 0;
			zsgn = zzsgn; zzsgn = rxi[zz]+rzi[zz];
			if (zsgn >= 0)
			{
				rxi2[npoints2] = rxi[z]; ryi2[npoints2] = ryi[z]; rzi2[npoints2] = rzi[z];
				npoints2++;
			}
			if ((zsgn^zzsgn) < 0)
			{
				t = divscale16(zsgn,zsgn-zzsgn);
				rxi2[npoints2] = rxi[z] + mulscale16(t,rxi[zz]-rxi[z]);
				ryi2[npoints2] = ryi[z] + mulscale16(t,ryi[zz]-ryi[z]);
				rzi2[npoints2] = rzi[z] + mulscale16(t,rzi[zz]-rzi[z]);
				npoints2++;
			}
		}
		if (npoints2 <= 2) return;

			//Clip edge 2
		npoints = 0;
		zzsgn = rxi2[0]-rzi2[0];
		for(z=0;z<npoints2;z++)
		{
			zz = z+1; if (zz == npoints2) zz = 0;
			zsgn = zzsgn; zzsgn = rxi2[zz]-rzi2[zz];
			if (zsgn <= 0)
			{
				rxi[npoints] = rxi2[z]; ryi[npoints] = ryi2[z]; rzi[npoints] = rzi2[z];
				npoints++;
			}
			if ((zsgn^zzsgn) < 0)
			{
				t = divscale16(zsgn,zsgn-zzsgn);
				rxi[npoints] = rxi2[z] + mulscale16(t,rxi2[zz]-rxi2[z]);
				ryi[npoints] = ryi2[z] + mulscale16(t,ryi2[zz]-ryi2[z]);
				rzi[npoints] = rzi2[z] + mulscale16(t,rzi2[zz]-rzi2[z]);
				npoints++;
			}
		}
		if (npoints <= 2) return;

			//Clip edge 3
		npoints2 = 0;
		zzsgn = ryi[0]*(xdimen>>1) + (rzi[0]*(globalhoriz-0));
		for(z=0;z<npoints;z++)
		{
			zz = z+1; if (zz == npoints) zz = 0;
			zsgn = zzsgn; zzsgn = ryi[zz]*(xdimen>>1) + (rzi[zz]*(globalhoriz-0));
			if (zsgn >= 0)
			{
				rxi2[npoints2] = rxi[z];
				ryi2[npoints2] = ryi[z];
				rzi2[npoints2] = rzi[z];
				npoints2++;
			}
			if ((zsgn^zzsgn) < 0)
			{
				t = divscale16(zsgn,zsgn-zzsgn);
				rxi2[npoints2] = rxi[z] + mulscale16(t,rxi[zz]-rxi[z]);
				ryi2[npoints2] = ryi[z] + mulscale16(t,ryi[zz]-ryi[z]);
				rzi2[npoints2] = rzi[z] + mulscale16(t,rzi[zz]-rzi[z]);
				npoints2++;
			}
		}
		if (npoints2 <= 2) return;

			//Clip edge 4
		npoints = 0;
		zzsgn = ryi2[0]*(xdimen>>1) + (rzi2[0]*(globalhoriz-ydimen));
		for(z=0;z<npoints2;z++)
		{
			zz = z+1; if (zz == npoints2) zz = 0;
			zsgn = zzsgn; zzsgn = ryi2[zz]*(xdimen>>1) + (rzi2[zz]*(globalhoriz-ydimen));
			if (zsgn <= 0)
			{
				rxi[npoints] = rxi2[z];
				ryi[npoints] = ryi2[z];
				rzi[npoints] = rzi2[z];
				npoints++;
			}
			if ((zsgn^zzsgn) < 0)
			{
				t = divscale16(zsgn,zsgn-zzsgn);
				rxi[npoints] = rxi2[z] + mulscale16(t,rxi2[zz]-rxi2[z]);
				ryi[npoints] = ryi2[z] + mulscale16(t,ryi2[zz]-ryi2[z]);
				rzi[npoints] = rzi2[z] + mulscale16(t,rzi2[zz]-rzi2[z]);
				npoints++;
			}
		}
		if (npoints <= 2) return;

			//Project onto screen
		lpoint = -1; lmax = 0x7fffffff;
		rpoint = -1; rmax = 0x80000000;
		for(z=0;z<npoints;z++)
		{
			xsi[z] = scale(rxi[z],xdimen<<15,rzi[z]) + (xdimen<<15);
			ysi[z] = scale(ryi[z],xdimen<<15,rzi[z]) + (globalhoriz<<16);
			if (xsi[z] < 0) xsi[z] = 0;
			if (xsi[z] > (xdimen<<16)) xsi[z] = (xdimen<<16);
			if (ysi[z] < ((long)0<<16)) ysi[z] = ((long)0<<16);
			if (ysi[z] > ((long)ydimen<<16)) ysi[z] = ((long)ydimen<<16);
			if (xsi[z] < lmax) lmax = xsi[z], lpoint = z;
			if (xsi[z] > rmax) rmax = xsi[z], rpoint = z;
		}

			//Get umost arrays
		z = lpoint;
		while (z != rpoint)
		{
			zz = z+1; if (zz == npoints) zz = 0;

			dax1 = ((xsi[z]+65535)>>16);
			dax2 = ((xsi[zz]+65535)>>16);
			if (dax2 > dax1)
			{
				yinc = divscale16(ysi[zz]-ysi[z],xsi[zz]-xsi[z]);
				y = ysi[z] + mulscale16((dax1<<16)-xsi[z],yinc);
				for(x=dax1;x<dax2;x++)
				{
					umost[x] = (y>>16)-1;
					y += yinc;
				}
			}

			z = zz;
		}

			//Get dmost arrays
		while (z != lpoint)
		{
			zz = z+1; if (zz == npoints) zz = 0;

			dax1 = ((xsi[zz]+65535)>>16);
			dax2 = ((xsi[z]+65535)>>16);
			if (dax2 > dax1)
			{
				yinc = divscale16(ysi[zz]-ysi[z],xsi[zz]-xsi[z]);
				y = ysi[zz] + mulscale16((dax1<<16)-xsi[zz],yinc);
				for(x=dax1;x<dax2;x++)
				{
					dmost[x] = (y>>16);
					y += yinc;
				}
			}

			z = zz;
		}


		lx = ((lmax+65535)>>16);
		rx = ((rmax+65535)>>16);

		for(x=lx;x<=rx;x++)
		{
			umost[x] = max(umost[x],startumost[x+windowx1]-windowy1-1);
			dmost[x] = min(dmost[x],startdmost[x+windowx1]-windowy1);
		}

			//Additional umost/dmost clipping goes here
		for(i=0;i<smostwallcnt;i++)
		{
			j = (smostwall[i]&16383);
			dalx2 = xb1[j];
			darx2 = xb2[j];

			if ((dalx2 <= rx) && (darx2 >= lx))
				if ((yp > (yb1[j]<<8)) || (yp > (yb2[j]<<8)))
				{
						//if (spritewallfront(spritenum,thewall[j]) == 0)
					x = thewall[j]; xp1 = wall[x].x; yp1 = wall[x].y;
					x = wall[x].point2; xp2 = wall[x].x; yp2 = wall[x].y;
					x = (xp2-xp1)*(spr->y-yp1)-(spr->x-xp1)*(yp2-yp1);
					if ((x < 0) || ((x == 0) && (wall[thewall[j]].nextsector == spr->sectnum)))
					{
						if (dalx2 < lx) dalx2 = lx;
						if (darx2 > rx) darx2 = rx;

						switch(smostwall[i]&0xc000)
						{
							case 0:
								for(x=dalx2;x<=darx2;x++) dmost[x] = 0;
								break;
							case 16384:
								k = smoststart[i] - xb1[j];
								for(x=dalx2;x<=darx2;x++)
									if (smost[k+x]-1 > umost[x]) umost[x] = smost[k+x]-1;
								break;
							case 32768:
								k = smoststart[i] - xb1[j];
								for(x=dalx2;x<=darx2;x++)
									if (smost[k+x] < dmost[x]) dmost[x] = smost[k+x];
								break;
						}
					}
				}
		}

		if (searchit >= 1)
			if ((searchx >= lx) && (searchx <= rx))
				if ((searchy >= umost[searchx]) && (searchy <= dmost[searchx]))
				{
					searchsector = sectnum;
					searchwall = spritenum;
					searchstat = 3;  //sprite
					searchit = 1;
				}

		globalorientation = cstat;
		globalpicnum = tilenum;
		if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
		//if ((picanm[globalpicnum]&192) != 0)
		//   globalpicnum += animateoffs((short)globalpicnum,spritenum+32768);

		if (waloff[globalpicnum] == 0) loadtile(globalpicnum);
		setgotpic(globalpicnum);
		globalbufplc = waloff[globalpicnum];

		globalpal = palnum;
		globalshade = spr->shade+6;
		if ((sec->ceilingstat&1) > 0)
			globalshade += ((long)sec->ceilingshade);
		else
			globalshade += ((long)sec->floorshade);

		x = picsiz[globalpicnum]; y = ((x>>4)&15); x &= 15;
		if ((1<<x) != xspan)
		{
			x++;
			globalx1 = mulscale(globalx1,xspan,x);
			globalx2 = mulscale(globalx2,xspan,x);
		}

		dax = globalxpanning; day = globalypanning;
		globalxpanning = -doublemulscale6(globalx1,day,globalx2,dax);
		globalypanning = -doublemulscale6(globaly1,day,globaly2,dax);
		globalx1 = (globalx1-globalx2)*halfxdimen;
		globaly1 = (globaly1-globaly2)*halfxdimen;

		if ((cstat&2) == 0)
			msethlineshift(x,y);
		else
			tsethlineshift(x,y);

			//Draw it!
		ceilspritescan(lx,rx);
	}
}

ceilspritescan (long lx, long rx)
{
	long x, y1, y2, twall, bwall;

	y1 = umost[lx]; y2 = umost[lx];
	if (y1 < -1) y1 = -1;
	if (y1 > ydimen-1) y1 = ydimen-1;
	if (y2 < 0) y2 = 0;
	if (y2 > ydimen) y2 = ydimen;
	for(x=lx;x<rx;x++)
	{
		twall = umost[x];
		bwall = dmost[x];
		if (twall < bwall-1)
		{
			if (twall < -1) twall = -1;
			if (twall > ydimen-1) twall = ydimen-1;
			if (bwall < 0) bwall = 0;
			if (bwall > ydimen) bwall = ydimen;

			if (twall >= y2)
			{
				while (y1 < y2-1) { y1++; ceilspritehline(lastx[y1],x-1,y1); }
				y1 = twall;
			}
			else
			{
				while (y1 < twall) { y1++; ceilspritehline(lastx[y1],x-1,y1); }
				while (y1 > twall) { lastx[y1] = x; y1--; }
			}

			while (y2 > bwall) { y2--; ceilspritehline(lastx[y2],x-1,y2); }
			while (y2 < bwall) { lastx[y2] = x; y2++; }
		}
		else
		{
			while (y1 < y2-1) { y1++; ceilspritehline(lastx[y1],x-1,y1); }
			y1 = umost[x+1]; y2 = y1;
			if (y1 < -1) y1 = -1;
			if (y1 > ydimen-1) y1 = ydimen-1;
			if (y2 < 0) y2 = 0;
			if (y2 > ydimen) y2 = ydimen;
		}
	}
	while (y1 < y2-1) { y1++; ceilspritehline(lastx[y1],rx-1,y1); }
	faketimerhandler();
}

ceilspritehline (long x1, long x2, long y)
{
	long v, bx, by, x, xend, bxinc, byinc, p;

	//x = x1 + (x2-x1)t + (y1-y2)u    x = 160v
	//y = y1 + (y2-y1)t + (x2-x1)u    y = (scrx-160)v
	//z = z1 = z2                     z = posz + (scry-horiz)v

	if (x2 < x1) return;

	v = mulscale20(globalzd,horizlookup[y-globalhoriz+MAXYDIM]);
	bx = mulscale14(globalx2*x1+globalx1,v) + globalxpanning;
	by = mulscale14(globaly2*x1+globaly1,v) + globalypanning;
	asm1 = mulscale14(globalx2,v);
	asm2 = mulscale14(globaly2,v);

	asm3 = mulscale32(klabs(v)>>4,globalvisibility)+globalshade;
	if (asm3 < 0) asm3 = 0;
	if (asm3 >= numpalookups) asm3 = numpalookups-1;
	asm3 = FP_OFF(palookup[globalpal]) + (asm3<<8);

	if (chainnumpages >= 2)
	{
		bxinc = asm1; asm1 <<= 2;
		byinc = asm2; asm2 <<= 2;
		x1 += viewoffset; x2 += viewoffset;
		p = ylookup[y]+chainplace;

		xend = x1+3; if (x2 < xend) xend = x2;

		if ((globalorientation&2) == 0)
		{
			x = x1;
			if (x <= xend)             //First one does self-modifying code
			{
				outp(0x3c5,1<<(x&3));
				mhline(globalbufplc,bx,((x2-x)>>2)<<16,0L,by,p+(x>>2));
				bx += bxinc; by += byinc;
				x++;
			}
			while (x <= xend)          //Rest can skip self-modifying code
			{
				outp(0x3c5,1<<(x&3));
				mhlineskipmodify(globalbufplc,bx,((x2-x)>>2)<<16,0L,by,p+(x>>2));
				bx += bxinc; by += byinc;
				x++;
			}
		}
		else
		{
			koutp(0x3ce,0x4);

			x = x1;
			if (x <= xend)             //First one does self-modifying code
			{
				outp(0x3c5,1<<(x&3)); koutp(0x3cf,x&3);
				thline(globalbufplc,bx,((x2-x)>>2)<<16,0L,by,p+(x>>2));
				bx += bxinc; by += byinc;
				x++;
			}
			while (x <= xend)          //Rest can skip self-modifying code
			{
				outp(0x3c5,1<<(x&3)); koutp(0x3cf,x&3);
				thlineskipmodify(globalbufplc,bx,((x2-x)>>2)<<16,0L,by,p+(x>>2));
				bx += bxinc; by += byinc;
				x++;
			}
		}
	}
	else
	{
		p = ylookup[y]+x1+frameplace+viewoffset;

		if ((globalorientation&2) == 0)
			mhline(globalbufplc,bx,(x2-x1)<<16,0L,by,p);
		else
			thline(globalbufplc,bx,(x2-x1)<<16,0L,by,p);
	}
}

overwritesprite (long thex, long they, short tilenum, signed char shade, char orientation, char dapalnum)
{
	char *ptr;
	unsigned char dat;
	long xsiz, ysiz, i, x, y, x1, y1, x2, y2, p, pinc, tileoffs, bufplc;
	long lm, rm, um, dm, palookupoffs, yplce, yince;

	xsiz = tilesizx[tilenum]; ysiz = tilesizy[tilenum];
	setgotpic(tilenum);
	if ((xsiz <= 0) || (ysiz <= 0)) return;

	pinc = ylookup[1];

	if (shade < 0) shade = 0;
	if (shade >= numpalookups) shade = numpalookups-1;
	palookupoffs = FP_OFF(palookup[dapalnum]) + (((long)shade)<<8);

	if (waloff[tilenum] == 0) loadtile(tilenum);
	tileoffs = waloff[tilenum];

	if ((stereofps != 0) && (stereopage == 0)) thex += stereopixelwidth;

	x1 = thex; y1 = they;
	if ((orientation&1) > 0)
	{
		x1 -= (xsiz>>1); y1 -= (ysiz>>1);
		if ((orientation&8) == 0)
			x1 -= ((signed char)((picanm[tilenum]>>8)&255));
		else
			x1 += ((signed char)((picanm[tilenum]>>8)&255));
		y1 -= ((signed char)((picanm[tilenum]>>16)&255));
	}
	if ((orientation&2) > 0)
	{
		x1 = ((windowx1+windowx2+1)>>1)+mulscale16(x1-(320>>1),xdimenscale);
		x2 = x1 + mulscale16(xsiz,xdimenscale);
		y1 = ((windowy1+windowy2+1)>>1)+mulscale16(y1-(200>>1),xdimenscale);
		y2 = y1 + mulscale16(ysiz,xdimenscale);
	}
	else
	{
		x2 = x1 + xsiz;
		y2 = y1 + ysiz;
	}

	lm = x1; rm = x2-1;
	if ((orientation&2) > 0)
	{
		if (lm < windowx1) lm = windowx1;
		if (rm > windowx2) rm = windowx2;
		if ((lm > rm) || (rm < windowx1) || (lm > windowx2)) return;
		yince = (xdimscale<<8);
	}
	else
	{
		if (lm < 0) lm = 0;
		if (rm >= xdim) rm = xdim-1;
		if ((lm > rm) || (rm < 0) || (lm > xdim)) return;
		yince = 16777216;
	}

	if ((orientation&16) > 0) yince = -yince;  //Y-flip

	for(x=lm;x<=rm;x++)
	{
		yplce = 0;
		if ((orientation&16) > 0) yplce = (y1-y2)*yince-1;  //Y-flip
		if ((orientation&2) > 0)
		{
			if ((orientation&8) == 0)
				i = mulscale16(x-x1,xdimscale);
			else
				i = mulscale16(x2-1-x,xdimscale);
			if (i >= xsiz) return;
			ptr = (char *)(tileoffs+(i*ysiz));

			um = y1;
			i = startumost[x]-um;
			if (i > 0) { yplce += yince*i; um += i; }
			dm = y2;
			if (dm > startdmost[x]) dm = startdmost[x];
		}
		else
		{
			if ((orientation&8) == 0)
				ptr = (char *)(tileoffs+((x-x1)*ysiz));
			else
				ptr = (char *)(tileoffs+((x2-1-x)*ysiz));
			um = y1; if (um < 0) { yplce += yince*(0-um); um = 0; }
			dm = y2; if (dm > ydim) dm = ydim;
		}

		if (dm > um)
		{
			if (chainnumpages >= 2)
			{
				p = ylookup[um]+(x>>2)+chainplace;
				koutpw(0x3c4,2+(256<<(x&3)));
				koutpw(0x3ce,4+((x&3)<<8));
			}
			else
				p = ylookup[um] + x+frameplace;

			if ((orientation&4) > 0)
				tvlineasm1(yince,palookupoffs,(((long)(dm-um-1))<<8)+24,yplce,(long)ptr,p);
			else
				mvlineasm1(yince,palookupoffs,(((long)(dm-um-1))<<8)+24,yplce,(long)ptr,p);
		}
	}
	faketimerhandler();
}

permanentwritesprite (long thex, long they, short tilenum, signed char shade,
							 long cx1, long cy1, long cx2, long cy2, char dapalnum)
{
	long xsiz, ysiz, x, y, x1, y1, x2, y2, p, tileoffs, bufplc;
	long lm, rm, um, dm, z, vplce[4], vince[4], palookupoffse[4], bufplce[4];
	long dapage, danumpages, palookupoffs, plane, dachainplace;

	xsiz = tilesizx[tilenum]; ysiz = tilesizy[tilenum];
	setgotpic(tilenum);
	if ((xsiz <= 0) || (ysiz <= 0)) return;

	if (shade < 0) shade = 0;
	if (shade >= numpalookups) shade = numpalookups-1;
	palookupoffs = FP_OFF(palookup[dapalnum]) + (((long)shade)<<8);

	if (waloff[tilenum] == 0) loadtile(tilenum);
	tileoffs = waloff[tilenum];

	x1 = thex; x2 = x1 + xsiz;
	y1 = they; y2 = y1 + ysiz;

	lm = max(max(x1,0),cx1); rm = min(min(x2,xdim),cx2+1);
	if ((rm < 0) || (lm >= xdim) || (rm <= lm)) return;
	um = max(max(y1,0),cy1); dm = min(min(y2,ydim),cy2+1);
	if ((dm < 0) || (um >= ydim) || (dm <= um)) return;

	for(z=3;z>=0;z--)
		{ palookupoffse[z] = palookupoffs; vince[z] = 16777216; }

	danumpages = 1;
	if (chainnumpages >= 2) danumpages = chainnumpages, dachainplace = 0xa0000;
	if (vidoption >= 2) danumpages = 4;

	for (dapage=0;dapage<danumpages;dapage++)
	{
		if (chainnumpages >= 2)
		{
			for(plane=0;plane<4;plane++)
			{
				x = lm+plane;

				koutpw(0x3c4,2+(256<<(x&3)));
				p = ylookup[um]+(x>>2)+dachainplace;
				bufplc = tileoffs + (x-x1)*ysiz + (um-y1);

				while (x < rm-12)
				{
					bufplce[0] = bufplc;
					bufplce[1] = bufplce[0]+(ysiz<<2);
					bufplce[2] = bufplce[1]+(ysiz<<2);
					bufplce[3] = bufplce[2]+(ysiz<<2);
					bufplc = bufplce[3]+(ysiz<<2);
					vplce[0] = 0;
					vplce[1] = 0;
					vplce[2] = 0;
					vplce[3] = 0;
					mvlineasm4((long)(&vplce[0]),(long)(&vince[0]),((dm-um-1)<<8)+24,(long)(&bufplce[0]),(long)(&palookupoffse[0]),p);
					p += 4; x += 16;
				}
				while (x < rm)
				{
					mvlineasm1(16777216L,palookupoffs,(((long)(dm-um-1))<<8)+24,0L,bufplc,p);
					bufplc += (ysiz<<2);
					p++; x += 4;
				}
			}
		}
		else
		{
			if (vidoption == 2) koutp(0x3cd,dapage+(dapage<<4));
			if (vidoption == 3) koutpw(0x3ce,0x9+(dapage<<12));
			if (vidoption == 4) koutpw(0x3d4,0x35+(dapage<<8));

			x = lm;
			bufplc = tileoffs + (x-x1)*ysiz + (um-y1);
			p = ylookup[um] + x+frameplace;
			while (x < rm-3)
			{
				bufplce[0] = bufplc;
				bufplce[1] = bufplce[0]+ysiz;
				bufplce[2] = bufplce[1]+ysiz;
				bufplce[3] = bufplce[2]+ysiz;
				bufplc = bufplce[3]+ysiz;
				vplce[0] = 0;
				vplce[1] = 0;
				vplce[2] = 0;
				vplce[3] = 0;
				mvlineasm4((long)(&vplce[0]),(long)(&vince[0]),((dm-um-1)<<8)+24,(long)(&bufplce[0]),(long)(&palookupoffse[0]),p);
				p += 4; x += 4;
			}
			while (x < rm)
			{
				mvlineasm1(16777216L,palookupoffs,(((long)(dm-um-1))<<8)+24,0L,bufplc,p);
				bufplc += ysiz;
				p++; x++;
			}
		}
		if (chainnumpages >= 2) dachainplace += chainsiz;
	}
	if (vidoption == 2) koutp(0x3cd,page+(page<<4));
	if (vidoption == 3) koutpw(0x3ce,0x9+(page<<12));
	if (vidoption == 4) koutpw(0x3d4,0x35+(page<<8));
	faketimerhandler();
}

grouvline (long xscr, long d1, long d2, short sectnum)
{
	char *ptr;
	signed char shade;
	short dir[2], index;
	long dist[2], dinc[2], incr[2], p, pinc, lastdist;
	long grid[2], tempx, tempy, x1, y1, x2, y2, stx, sty, cnt, dend, temp;
	long tilebufoffs, heibufoffs, zoffs, they, um, dm, y, zx, dat, col;

	d1 >>= 6;
	d2 >>= 6;
	if ((d1 <= 0) || (d2 <= 0) || (umost[xscr] >= dmost[xscr])) return;
	d1 = (65536 * 2048) / d1;
	d2 = (65536 * 2048) / d2;
	if (xdimen != 320)
	{
		d1 = mulscale16(d1,xdimenscale);
		d2 = mulscale16(d2,xdimenscale);
	}
	d1++;
	d2--;
	if ((d2 <= d1) || (d1 <= 0) || (d2 <= 0)) return;

	pinc = ylookup[1];
	if (chainnumpages >= 2)
	{
		p = ylookup[dmost[xscr]-1]+((xscr+viewoffset)>>2)+chainplace;
		koutp(0x3c5,1<<((xscr+viewoffset)&3));
	}
	else
		p = ylookup[dmost[xscr]-1]+xscr+frameplace+viewoffset;

	tempx = (d1>>2); tempy = (d1*(xscr-halfxdimen)) / (xdimen<<1);
	x1 = (globalposx<<6) + doublemulscale12(tempx,cosglobalang,-tempy,singlobalang);
	y1 = (globalposy<<6) + doublemulscale12(tempy,cosglobalang,tempx,singlobalang);
	tempx = (d2>>2); tempy = (d2*(xscr-halfxdimen)) / (xdimen<<1);
	incr[0] = doublemulscale12(tempx,cosglobalang,-tempy,singlobalang);
	incr[1] = doublemulscale12(tempy,cosglobalang,tempx,singlobalang);
	x2 = incr[0] + (globalposx<<6);
	y2 = incr[1] + (globalposy<<6);

	dir[0] = ksgn(incr[0]); incr[0] = klabs(incr[0]);
	dir[1] = ksgn(incr[1]); incr[1] = klabs(incr[1]);

	stx = (x1&0xfffffc00); if (dir[0] == 1) stx += 1024;
	sty = (y1&0xfffffc00); if (dir[1] == 1) sty += 1024;
	cnt = doublemulscale10(klabs(stx-x1),incr[1],-klabs(sty-y1),incr[0]);
	grid[0] = ((x1>>10)&63);
	grid[1] = ((y1>>10)&63);

	if ((klabs(d2)>>16) < klabs(x2-(globalposx<<6)))
	{
		dinc[0] = divscale16(d2,klabs(x2-(globalposx<<6)));
		if (xdimen != 320) dinc[0] = mulscale16(dinc[0],xdimscale);
		dist[0] = mulscale10(dinc[0],klabs(stx-(globalposx<<6)));
	}
	if ((klabs(d2)>>16) < klabs(y2-(globalposy<<6)))
	{
		dinc[1] = divscale16(d2,klabs(y2-(globalposy<<6)));
		if (xdimen != 320) dinc[1] = mulscale16(dinc[1],xdimscale);
		dist[1] = mulscale10(dinc[1],klabs(sty-(globalposy<<6)));
	}
	if (dinc[0] < 8) dinc[0] = 8;
	if (dinc[1] < 8) dinc[1] = 8;
	if (dist[0] < 8) dist[0] = 8;
	if (dist[1] < 8) dist[1] = 8;

	shade = mulscale24(d1,globalvisibility)+sector[sectnum].floorshade;
	if (shade < 0) shade = 0;
	if (shade >= numpalookups) shade = numpalookups-1;

	dend = (d2<<6);
	if (xdimen != 320) dend = mulscale16(dend,xdimscale);

	um = umost[xscr] - globalhoriz;
	dm = dmost[xscr] - globalhoriz;
	temp = incr[0]; incr[0] = incr[1]; incr[1] = temp;
	incr[1] = -incr[1];

	if (waloff[sector[sectnum].floorpicnum] == 0) loadtile(sector[sectnum].floorpicnum);
	if (waloff[sector[sectnum].floorheinum] == 0) loadtile(sector[sectnum].floorheinum);
	setgotpic(sector[sectnum].floorpicnum);
	setgotpic(sector[sectnum].floorheinum);

	tilebufoffs = waloff[sector[sectnum].floorpicnum];
	heibufoffs = waloff[sector[sectnum].floorheinum];
	zoffs = sector[sectnum].floorz - globalposz;

	index = (cnt >= 0);
	lastdist = dist[index];
	while (dist[index] < dend)
	{
		dat = groudat(grid[0],grid[1],heibufoffs);
		y = divscale15(zoffs-(dat<<8),dist[index]);
		if (y < 0) goto restisabove;
		if (y <= dm)
		{
			ptr = (char *)(FP_OFF(palookup[globalpal])+(shade<<8)+groudat(grid[0],grid[1],tilebufoffs));
			col = *ptr;
			if (y <= um) goto finishgroudraw;
			p = drawslab(p,dm-y+1,col,pinc);
			dm = y-1;
		}
		grid[index] = ((grid[index]+dir[index])&63);
		lastdist = dist[index];
		dist[index] += dinc[index];
		cnt += incr[index];
		index = (cnt >= 0);
	}

	goto endgroudraw;

	while (dist[index] < dend)
	{
		dat = groudat(grid[0],grid[1],heibufoffs);
restisabove:
		y = divscale15(zoffs-(dat<<8),lastdist);
		if (y <= dm)
		{
			ptr = (char *)(FP_OFF(palookup[globalpal])+(shade<<8)+groudat(grid[0],grid[1],tilebufoffs));
			col = *ptr;
			if (y <= um) goto finishgroudraw;
			p = drawslab(p,dm-y+1,col,pinc);
			dm = y-1;
		}
		grid[index] = ((grid[index]+dir[index])&63);
		lastdist = dist[index];
		dist[index] += dinc[index];
		cnt += incr[index];
		index = (cnt >= 0);
	}
	goto endgroudraw;

finishgroudraw:
	if (um < dm)
	{
		p = drawslab(p,dm-um,col,pinc);
		dm = um-1;
	}

endgroudraw:
	dmost[xscr] = dm + globalhoriz;

	faketimerhandler();
}

setsprite(short spritenum, long newx, long newy, long newz)
{
	short bad, j, tempsectnum;

	sprite[spritenum].x = newx;
	sprite[spritenum].y = newy;
	sprite[spritenum].z = newz;

	tempsectnum = sprite[spritenum].sectnum;
	updatesector(newx,newy,&tempsectnum);
	if (tempsectnum < 0)
		return(-1);
	if (tempsectnum != sprite[spritenum].sectnum)
		changespritesect(spritenum,tempsectnum);

	return(0);
}

animateoffs(short tilenum, short fakevar)
{
	long i, k, offs;

	offs = 0;
	i = (totalclocklock>>((picanm[tilenum]>>24)&15));
	if ((picanm[tilenum]&63) > 0)
	{
		switch(picanm[tilenum]&192)
		{
			case 64:
				k = (i%((picanm[tilenum]&63)<<1));
				if (k < (picanm[tilenum]&63))
					offs = k;
				else
					offs = (((picanm[tilenum]&63)<<1)-k);
				break;
			case 128:
				offs = (i%((picanm[tilenum]&63)+1));
					break;
			case 192:
				offs = -(i%((picanm[tilenum]&63)+1));
		}
	}
	return(offs);
}

initspritelists()
{
	long i;

	for (i=0;i<MAXSECTORS;i++)     //Init doubly-linked sprite sector lists
		headspritesect[i] = -1;
	headspritesect[MAXSECTORS] = 0;
	for(i=0;i<MAXSPRITES;i++)
	{
		prevspritesect[i] = i-1;
		nextspritesect[i] = i+1;
		sprite[i].sectnum = MAXSECTORS;
	}
	prevspritesect[0] = -1;
	nextspritesect[MAXSPRITES-1] = -1;


	for(i=0;i<MAXSTATUS;i++)      //Init doubly-linked sprite status lists
		headspritestat[i] = -1;
	headspritestat[MAXSTATUS] = 0;
	for(i=0;i<MAXSPRITES;i++)
	{
		prevspritestat[i] = i-1;
		nextspritestat[i] = i+1;
		sprite[i].statnum = MAXSTATUS;
	}
	prevspritestat[0] = -1;
	nextspritestat[MAXSPRITES-1] = -1;
}

insertsprite(short sectnum, short statnum)
{
	insertspritestat(statnum);
	return(insertspritesect(sectnum));
}

insertspritesect(short sectnum)
{
	short blanktouse;

	if ((sectnum >= MAXSECTORS) || (headspritesect[MAXSECTORS] == -1))
		return(-1);  //list full

	blanktouse = headspritesect[MAXSECTORS];

	headspritesect[MAXSECTORS] = nextspritesect[blanktouse];
	if (headspritesect[MAXSECTORS] >= 0)
		prevspritesect[headspritesect[MAXSECTORS]] = -1;

	prevspritesect[blanktouse] = -1;
	nextspritesect[blanktouse] = headspritesect[sectnum];
	if (headspritesect[sectnum] >= 0)
		prevspritesect[headspritesect[sectnum]] = blanktouse;
	headspritesect[sectnum] = blanktouse;

	sprite[blanktouse].sectnum = sectnum;

	return(blanktouse);
}

insertspritestat(short statnum)
{
	short blanktouse;

	if ((statnum >= MAXSTATUS) || (headspritestat[MAXSTATUS] == -1))
		return(-1);  //list full

	blanktouse = headspritestat[MAXSTATUS];

	headspritestat[MAXSTATUS] = nextspritestat[blanktouse];
	if (headspritestat[MAXSTATUS] >= 0)
		prevspritestat[headspritestat[MAXSTATUS]] = -1;

	prevspritestat[blanktouse] = -1;
	nextspritestat[blanktouse] = headspritestat[statnum];
	if (headspritestat[statnum] >= 0)
		prevspritestat[headspritestat[statnum]] = blanktouse;
	headspritestat[statnum] = blanktouse;

	sprite[blanktouse].statnum = statnum;

	return(blanktouse);
}

deletesprite(short spritenum)
{
	deletespritestat(spritenum);
	return(deletespritesect(spritenum));
}

deletespritesect(short deleteme)
{
	if (sprite[deleteme].sectnum == MAXSECTORS)
		return(-1);

	if (headspritesect[sprite[deleteme].sectnum] == deleteme)
		headspritesect[sprite[deleteme].sectnum] = nextspritesect[deleteme];

	if (prevspritesect[deleteme] >= 0) nextspritesect[prevspritesect[deleteme]] = nextspritesect[deleteme];
	if (nextspritesect[deleteme] >= 0) prevspritesect[nextspritesect[deleteme]] = prevspritesect[deleteme];

	if (headspritesect[MAXSECTORS] >= 0) prevspritesect[headspritesect[MAXSECTORS]] = deleteme;
	prevspritesect[deleteme] = -1;
	nextspritesect[deleteme] = headspritesect[MAXSECTORS];
	headspritesect[MAXSECTORS] = deleteme;

	sprite[deleteme].sectnum = MAXSECTORS;
	return(0);
}

deletespritestat (short deleteme)
{
	if (sprite[deleteme].statnum == MAXSTATUS)
		return(-1);

	if (headspritestat[sprite[deleteme].statnum] == deleteme)
		headspritestat[sprite[deleteme].statnum] = nextspritestat[deleteme];

	if (prevspritestat[deleteme] >= 0) nextspritestat[prevspritestat[deleteme]] = nextspritestat[deleteme];
	if (nextspritestat[deleteme] >= 0) prevspritestat[nextspritestat[deleteme]] = prevspritestat[deleteme];

	if (headspritestat[MAXSTATUS] >= 0) prevspritestat[headspritestat[MAXSTATUS]] = deleteme;
	prevspritestat[deleteme] = -1;
	nextspritestat[deleteme] = headspritestat[MAXSTATUS];
	headspritestat[MAXSTATUS] = deleteme;

	sprite[deleteme].statnum = MAXSTATUS;
	return(0);
}

changespritesect(short spritenum, short newsectnum)
{
	if ((newsectnum < 0) || (newsectnum > MAXSECTORS)) return(-1);
	if (sprite[spritenum].sectnum == newsectnum) return(-1);
	if (sprite[spritenum].sectnum == MAXSECTORS) return(-1);
	if (deletespritesect(spritenum) < 0) return(-1);
	insertspritesect(newsectnum);
	return(0);
}

changespritestat(short spritenum, short newstatnum)
{
	if ((newstatnum < 0) || (newstatnum > MAXSTATUS)) return(-1);
	if (sprite[spritenum].statnum == newstatnum) return(-1);
	if (sprite[spritenum].statnum == MAXSTATUS) return(-1);
	if (deletespritestat(spritenum) < 0) return(-1);
	insertspritestat(newstatnum);
	return(0);
}

nextsectorneighborz(short sectnum, long thez, short topbottom, short direction)
{
	long i, testz, nextz;
	short sectortouse;
	struct walltype *wal;

	if (direction == 1) nextz = 0x7fffffff; else nextz = 0x80000000;

	sectortouse = -1;

	wal = &wall[sector[sectnum].wallptr];
	for(i=sector[sectnum].wallnum;i>0;i--)
	{
		if (wal->nextsector >= 0)
		{
			if (topbottom == 1)
			{
				testz = sector[wal->nextsector].floorz;
				if (direction == 1)
				{
					if ((testz > thez) && (testz < nextz))
					{
						nextz = testz;
						sectortouse = wal->nextsector;
					}
				}
				else
				{
					if ((testz < thez) && (testz > nextz))
					{
						nextz = testz;
						sectortouse = wal->nextsector;
					}
				}
			}
			else
			{
				testz = sector[wal->nextsector].ceilingz;
				if (direction == 1)
				{
					if ((testz > thez) && (testz < nextz))
					{
						nextz = testz;
						sectortouse = wal->nextsector;
					}
				}
				else
				{
					if ((testz < thez) && (testz > nextz))
					{
						nextz = testz;
						sectortouse = wal->nextsector;
					}
				}
			}
		}
		wal++;
	}

	return(sectortouse);
}

cansee(long xs, long ys, long zs, short sectnums, long xe, long ye, long ze, short sectnume)
{
	long x1, y1, x2, y2, intx, inty, intz, tempshortcnt, tempshortnum;
	short w, i, nextsector;
	struct walltype *wal, *wal2;
	struct sectortype *sec;

	if ((xs == xe) && (ys == ye)) return(1);

	clipsectorlist[0] = sectnums; clipsectorlist[1] = sectnume;
	for(tempshortcnt=0,tempshortnum=2;tempshortcnt<tempshortnum;tempshortcnt++)
	{
		sec = &sector[clipsectorlist[tempshortcnt]];

		wal = &wall[sec->wallptr];
		for(w=sec->wallnum;w>0;w--,wal++)
		{
			wal2 = &wall[wal->point2];
			x1 = wal->x; y1 = wal->y; x2 = wal2->x; y2 = wal2->y;
			if (lintersect(xs,ys,zs,xe,ye,ze,x1,y1,x2,y2,&intx,&inty,&intz) != 0)
			{
				nextsector = wal->nextsector; if (nextsector < 0) return(0);

				if (intz <= sec->ceilingz) return(0);
				if (intz >= sec->floorz) return(0);
				if (intz <= sector[nextsector].ceilingz) return(0);
				if (intz >= sector[nextsector].floorz) return(0);

				for(i=tempshortnum-1;i>=0;i--)
					if (clipsectorlist[i] == nextsector) break;
				if (i < 0) clipsectorlist[tempshortnum++] = nextsector;
			}
		}
	}
	return(1);
}

hitscan(long xs, long ys, long zs, short sectnum, long vx, long vy, long vz,
	short *hitsect, short *hitwall, short *hitsprite, long *hitx, long *hity, long *hitz)
{
	long z, zz, x1, y1, z1, x2, y2, z2, x3, y3, x4, y4, intx, inty, intz;
	long topt, topu, bot, daxsiz, daysiz, dist, offx, offy;
	long i, j, k, l, tilenum, xoff, yoff, dax, day, daz;
	long ang, cosang, sinang, xspan, yspan, xrepeat, yrepeat;
	short tempshortcnt, tempshortnum, dasector, startwall, endwall;
	short nextsector, cstat;
	char clipyou;
	struct sectortype *sec;
	struct walltype *wal, *wal2;
	struct spritetype *spr;

	*hitsect = -1;
	if (sectnum < 0) return(-1);

	*hitx = (1<<29)-1; *hity = (1<<29)-1;
	clipsectorlist[0] = sectnum;
	tempshortcnt = 0; tempshortnum = 1;
	do
	{
		dasector = clipsectorlist[tempshortcnt];

		sec = &sector[dasector];
		startwall = sec->wallptr; endwall = startwall + sec->wallnum;
		for(z=startwall,wal=&wall[startwall];z<endwall;z++,wal++)
		{
			wal2 = &wall[wal->point2];
			x1 = wal->x; y1 = wal->y; x2 = wal2->x; y2 = wal2->y;

			if ((x1-xs)*(y2-ys) < (x2-xs)*(y1-ys)) continue;
			if (rintersect(xs,ys,zs,vx,vy,vz,x1,y1,x2,y2,&intx,&inty,&intz) == 0) continue;

			if (vz != 0)
				if ((intz <= sec->ceilingz) || (intz >= sec->floorz))
					if (klabs(intx-xs)+klabs(inty-ys) < klabs(*hitx-xs)+klabs(*hity-ys))
					{
							//x1,y1,z1 are temp variables
						if (vz > 0) z1 = sec->floorz; else z1 = sec->ceilingz;
						x1 = xs + scale(z1-zs,vx,vz);
						y1 = ys + scale(z1-zs,vy,vz);
						if (inside(x1,y1,dasector) != 0)
						{
							*hitsect = dasector; *hitwall = -1; *hitsprite = -1;
							*hitx = x1; *hity = y1; *hitz = z1;
							continue;
						}
					}

			nextsector = wal->nextsector;
			if ((nextsector < 0) || ((wal->cstat&64) != 0))
			{
				if (klabs(intx-xs)+klabs(inty-ys) < klabs(*hitx-xs)+klabs(*hity-ys))
				{
					*hitsect = dasector; *hitwall = z; *hitsprite = -1;
					*hitx = intx; *hity = inty; *hitz = intz;
				}
				continue;
			}
			if ((intz <= sector[nextsector].ceilingz) || (intz >= sector[nextsector].floorz))
				if (klabs(intx-xs)+klabs(inty-ys) < klabs(*hitx-xs)+klabs(*hity-ys))
				{
					*hitsect = dasector; *hitwall = z; *hitsprite = -1;
					*hitx = intx; *hity = inty; *hitz = intz;
					continue;
				}

			for(zz=tempshortnum-1;zz>=0;zz--)
				if (clipsectorlist[zz] == nextsector) break;
			if (zz < 0) clipsectorlist[tempshortnum++] = nextsector;
		}

		for(z=headspritesect[dasector];z>=0;z=nextspritesect[z])
		{
			spr = &sprite[z];
			cstat = spr->cstat;
			if ((cstat&256) == 0) continue;

			x1 = spr->x; y1 = spr->y; z1 = spr->z;
			switch(cstat&48)
			{
				case 0:
					topt = vx*(x1-xs) + vy*(y1-ys); if (topt <= 0) continue;
					bot = vx*vx + vy*vy; if (bot == 0) continue;

					intz = zs+scale(vz,topt,bot);
					daysiz = (tilesizy[spr->picnum]*spr->yrepeat<<2);
					if (cstat&128) z1 += (daysiz>>1);
					if ((intz > z1) || (intz < z1-daysiz)) continue;
					topu = vx*(y1-ys) - vy*(x1-xs);

					offx = scale(vx,topu,bot);
					offy = scale(vy,topu,bot);
					dist = offx*offx + offy*offy;
					daxsiz = tilesizx[spr->picnum]*spr->xrepeat; daxsiz *= daxsiz;
					if (dist > (daxsiz>>7)) continue;
					intx = xs + scale(vx,topt,bot);
					inty = ys + scale(vy,topt,bot);

					if (klabs(intx-xs)+klabs(inty-ys) > klabs(*hitx-xs)+klabs(*hity-ys)) continue;

					*hitsect = dasector; *hitwall = -1; *hitsprite = z;
					*hitx = intx; *hity = inty; *hitz = intz;
					break;
				case 16:
						//These lines get the 2 points of the rotated sprite
						//Given: (x1, y1) starts out as the center point
					tilenum = spr->picnum;
					xoff = (long)((signed char)((picanm[tilenum]>>8)&255))+((long)spr->xoffset);
					if ((cstat&4) > 0) xoff = -xoff;
					k = spr->ang; l = spr->xrepeat;
					dax = sintable[k&2047]*l; day = sintable[(k+1536)&2047]*l;
					l = tilesizx[tilenum]; k = (l>>1)+xoff;
					x1 -= mulscale16(dax,k); x2 = x1+mulscale16(dax,l);
					y1 -= mulscale16(day,k); y2 = y1+mulscale16(day,l);

					if ((cstat&64) != 0)   //back side of 1-way sprite
						if ((x1-xs)*(y2-ys) < (x2-xs)*(y1-ys)) continue;

					if (rintersect(xs,ys,zs,vx,vy,vz,x1,y1,x2,y2,&intx,&inty,&intz) == 0) continue;

					if (klabs(intx-xs)+klabs(inty-ys) > klabs(*hitx-xs)+klabs(*hity-ys)) continue;

					k = ((tilesizy[spr->picnum]*spr->yrepeat)<<2);
					if (cstat&128) daz = spr->z+(k>>1); else daz = spr->z;
					if ((intz < daz) && (intz > daz-k))
					{
						*hitsect = dasector; *hitwall = -1; *hitsprite = z;
						*hitx = intx; *hity = inty; *hitz = intz;
					}
					break;
				case 32:
					if (vz == 0) continue;
					intz = z1;
					if (((intz-zs)^vz) < 0) continue;
					if ((cstat&64) != 0)
						if ((zs > intz) == ((cstat&8)==0)) continue;

					intx = xs+scale(intz-zs,vx,vz);
					inty = ys+scale(intz-zs,vy,vz);

					if (klabs(intx-xs)+klabs(inty-ys) > klabs(*hitx-xs)+klabs(*hity-ys)) continue;

					tilenum = spr->picnum;
					xoff = (long)((signed char)((picanm[tilenum]>>8)&255))+((long)spr->xoffset);
					yoff = (long)((signed char)((picanm[tilenum]>>16)&255))+((long)spr->yoffset);
					if ((cstat&4) > 0) xoff = -xoff;
					if ((cstat&8) > 0) yoff = -yoff;

					ang = spr->ang;
					cosang = sintable[(ang+512)&2047]; sinang = sintable[ang];
					xspan = tilesizx[tilenum]; xrepeat = spr->xrepeat;
					yspan = tilesizy[tilenum]; yrepeat = spr->yrepeat;

					dax = ((xspan>>1)+xoff)*xrepeat; day = ((yspan>>1)+yoff)*yrepeat;
					x1 += doublemulscale16(sinang,dax,cosang,day)-intx;
					y1 += doublemulscale16(sinang,day,-cosang,dax)-inty;
					l = xspan*xrepeat;
					x2 = x1 - mulscale16(sinang,l);
					y2 = y1 + mulscale16(cosang,l);
					l = yspan*yrepeat;
					k = -mulscale16(cosang,l); x3 = x2+k; x4 = x1+k;
					k = -mulscale16(sinang,l); y3 = y2+k; y4 = y1+k;

					clipyou = 0;
					if ((y1^y2) < 0)
					{
						if ((x1^x2) < 0) clipyou ^= (x1*y2<x2*y1)^(y1<y2);
						else if (x1 >= 0) clipyou ^= 1;
					}
					if ((y2^y3) < 0)
					{
						if ((x2^x3) < 0) clipyou ^= (x2*y3<x3*y2)^(y2<y3);
						else if (x2 >= 0) clipyou ^= 1;
					}
					if ((y3^y4) < 0)
					{
						if ((x3^x4) < 0) clipyou ^= (x3*y4<x4*y3)^(y3<y4);
						else if (x3 >= 0) clipyou ^= 1;
					}
					if ((y4^y1) < 0)
					{
						if ((x4^x1) < 0) clipyou ^= (x4*y1<x1*y4)^(y4<y1);
						else if (x4 >= 0) clipyou ^= 1;
					}

					if (clipyou != 0)
					{
						*hitsect = dasector; *hitwall = -1; *hitsprite = z;
						*hitx = intx; *hity = inty; *hitz = intz;
					}
					break;
			}
		}
		tempshortcnt++;
	} while (tempshortcnt < tempshortnum);
	return(0);
}

neartag (long xs, long ys, long zs, short sectnum, short ange, short *neartagsector, short *neartagwall, short *neartagsprite, long *neartaghitdist, long neartagrange)
{
	long z, zz, xe, ye, ze, x1, y1, z1, x2, y2, z2, intx, inty, intz;
	long topt, topu, bot, daxsiz, daysiz, dist, offx, offy, vx, vy, vz;
	short tempshortcnt, tempshortnum, dasector, startwall, endwall;
	short nextsector, good;
	struct walltype *wal, *wal2;
	struct spritetype *spr;

	*neartagsector = -1; *neartagwall = -1; *neartagsprite = -1;
	*neartaghitdist = 0;

	if (sectnum < 0) return(0);

	vx = mulscale14(sintable[(ange+2560)&2047],neartagrange); xe = xs+vx;
	vy = mulscale14(sintable[(ange+2048)&2047],neartagrange); ye = ys+vy;
	vz = 0; ze = 0;

	clipsectorlist[0] = sectnum;
	tempshortcnt = 0; tempshortnum = 1;

	do
	{
		dasector = clipsectorlist[tempshortcnt];

		startwall = sector[dasector].wallptr;
		endwall = startwall + sector[dasector].wallnum - 1;
		for(z=startwall,wal=&wall[startwall];z<=endwall;z++,wal++)
		{
			wal2 = &wall[wal->point2];
			x1 = wal->x; y1 = wal->y; x2 = wal2->x; y2 = wal2->y;

			nextsector = wal->nextsector;

			good = 0;
			if (nextsector >= 0)
				if ((sector[nextsector].lotag|sector[nextsector].hitag) != 0)
					good |= 1;
			if ((wal->lotag|wal->hitag) != 0) good |= 2;

			if ((good == 0) && (nextsector < 0)) continue;
			if ((x1-xs)*(y2-ys) < (x2-xs)*(y1-ys)) continue;

			if (lintersect(xs,ys,zs,xe,ye,ze,x1,y1,x2,y2,&intx,&inty,&intz) == 1)
			{
				if (good != 0)
				{
					if (good&1) *neartagsector = nextsector;
					if (good&2) *neartagwall = z;
					*neartaghitdist = doublemulscale14(intx-xs,sintable[(ange+2560)&2047],inty-ys,sintable[(ange+2048)&2047]);
					xe = intx; ye = inty; ze = intz;
				}
				if (nextsector >= 0)
				{
					for(zz=tempshortnum-1;zz>=0;zz--)
						if (clipsectorlist[zz] == nextsector) break;
					if (zz < 0) clipsectorlist[tempshortnum++] = nextsector;
				}
			}
		}

		for(z=headspritesect[dasector];z>=0;z=nextspritesect[z])
		{
			spr = &sprite[z];
			if ((spr->lotag|spr->hitag) != 0)
			{
				x1 = spr->x; y1 = spr->y; z1 = spr->z;

				topt = vx*(x1-xs) + vy*(y1-ys);
				if (topt > 0)
				{
					bot = vx*vx + vy*vy;
					if (bot != 0)
					{
						intz = zs+scale(vz,topt,bot);
						daysiz = tilesizy[sprite[z].picnum]*spr->yrepeat;
						if (spr->cstat&128) z1 += (daysiz<<1);
						if ((intz <= z1) && (intz >= z1-(daysiz<<2)))
						{
							topu = vx*(y1-ys) - vy*(x1-xs);

							offx = scale(vx,topu,bot);
							offy = scale(vy,topu,bot);
							dist = offx*offx + offy*offy;
							daxsiz = (tilesizx[spr->picnum]*spr->xrepeat);
							daxsiz *= daxsiz;
							if (dist <= (daxsiz>>7))
							{
								intx = xs + scale(vx,topt,bot);
								inty = ys + scale(vy,topt,bot);
								if (klabs(intx-xs)+klabs(inty-ys) < klabs(xe-xs)+klabs(ye-ys))
								{
									*neartagsprite = z;
									*neartaghitdist = doublemulscale14(intx-xs,sintable[(ange+2560)&2047],inty-ys,sintable[(ange+2048)&2047]);
									xe = intx;
									ye = inty;
									ze = intz;
								}
							}
						}
					}
				}
			}
		}

		tempshortcnt++;
	} while (tempshortcnt < tempshortnum);
	return(0);
}

lintersect(long x1, long y1, long z1, long x2, long y2, long z2, long x3,
			  long y3, long x4, long y4, long *intx, long *inty, long *intz)
{     //p1 to p2 is a line segment
	long x21, y21, x34, y34, x31, y31, bot, topt, topu, t;

	x21 = x2-x1; x34 = x3-x4;
	y21 = y2-y1; y34 = y3-y4;
	bot = x21*y34 - y21*x34;
	if (bot >= 0)
	{
		if (bot == 0) return(0);
		x31 = x3-x1; y31 = y3-y1;
		topt = x31*y34 - y31*x34; if ((topt < 0) || (topt >= bot)) return(0);
		topu = x21*y31 - y21*x31; if ((topu < 0) || (topu >= bot)) return(0);
	}
	else
	{
		x31 = x3-x1; y31 = y3-y1;
		topt = x31*y34 - y31*x34; if ((topt > 0) || (topt <= bot)) return(0);
		topu = x21*y31 - y21*x31; if ((topu > 0) || (topu <= bot)) return(0);
	}
	t = divscale24(topt,bot);
	*intx = x1 + mulscale24(x21,t);
	*inty = y1 + mulscale24(y21,t);
	*intz = z1 + mulscale24(z2-z1,t);
	return(1);
}

rintersect(long x1, long y1, long z1, long vx, long vy, long vz, long x3,
			  long y3, long x4, long y4, long *intx, long *inty, long *intz)
{     //p1 towards p2 is a ray
	long x34, y34, x31, y31, bot, topt, topu, t;

	x34 = x3-x4; y34 = y3-y4;
	bot = vx*y34 - vy*x34;
	if (bot >= 0)
	{
		if (bot == 0) return(0);
		x31 = x3-x1; y31 = y3-y1;
		topt = x31*y34 - y31*x34; if (topt < 0) return(0);
		topu = vx*y31 - vy*x31; if ((topu < 0) || (topu >= bot)) return(0);
	}
	else
	{
		x31 = x3-x1; y31 = y3-y1;
		topt = x31*y34 - y31*x34; if (topt > 0) return(0);
		topu = vx*y31 - vy*x31; if ((topu > 0) || (topu <= bot)) return(0);
	}
	t = divscale16(topt,bot);
	*intx = x1 + mulscale16(vx,t);
	*inty = y1 + mulscale16(vy,t);
	*intz = z1 + mulscale16(vz,t);
	return(1);
}

dragpoint(short pointhighlight, long dax, long day)
{
	short cnt, tempshort;

	wall[pointhighlight].x = dax;
	wall[pointhighlight].y = day;

	cnt = MAXWALLS;
	tempshort = pointhighlight;    //search points CCW
	do
	{
		if (wall[tempshort].nextwall >= 0)
		{
			tempshort = wall[wall[tempshort].nextwall].point2;
			wall[tempshort].x = dax;
			wall[tempshort].y = day;
		}
		else
		{
			tempshort = pointhighlight;    //search points CW if not searched all the way around
			do
			{
				if (wall[lastwall(tempshort)].nextwall >= 0)
				{
					tempshort = wall[lastwall(tempshort)].nextwall;
					wall[tempshort].x = dax;
					wall[tempshort].y = day;
				}
				else
				{
					break;
				}
				cnt--;
			}
			while ((tempshort != pointhighlight) && (cnt > 0));
			break;
		}
		cnt--;
	}
	while ((tempshort != pointhighlight) && (cnt > 0));
}

lastwall(short point)
{
	long i, j, cnt;

	if ((point > 0) && (wall[point-1].point2 == point)) return(point-1);
	i = point;
	cnt = MAXWALLS;
	do
	{
		j = wall[i].point2;
		if (j == point) return(i);
		i = j;
		cnt--;
	} while (cnt > 0);
	return(point);
}

clipmove (long *x, long *y, long *z, short *sectnum,
			 long xvect, long yvect,
			 long walldist, long ceildist, long flordist, char cliptype)
{
	short hitwall, cnt, bad;
	long i, j, templong1, templong2;
	long oxvect, oyvect, goalx, goaly, intx, inty, lx, ly, retval;

	if ((xvect|yvect) == 0) return(0);
	retval = 0;

	oxvect = xvect;
	oyvect = yvect;

	goalx = *x + (xvect>>14);
	goaly = *y + (yvect>>14);

	getcliplines(*x, *y, *z, goalx, goaly, *sectnum, walldist, ceildist, flordist, cliptype);

	hitwall = 0;
	cnt = 3;
	do
	{
		intx = goalx; inty = goaly;
		if ((hitwall = raytrace(*x, *y, &intx, &inty)) >= 0)
		{
			lx = clipx2[hitwall]-clipx1[hitwall];
			ly = clipy2[hitwall]-clipy1[hitwall];
			templong2 = lx*lx + ly*ly;
			if (templong2 > 0)
			{
				templong1 = (goalx-intx)*lx + (goaly-inty)*ly;
				i = divscale20(templong1,templong2);
				goalx = mulscale20(lx,i)+intx;
				goaly = mulscale20(ly,i)+inty;
			}

			templong1 = lx*(oxvect>>6)+ly*(oyvect>>6);
			for(i=cnt+1;i<=3;i++)
			{
				j = hitwalls[i];
				templong2 = (clipx2[j]-clipx1[j])*(oxvect>>6);
				templong2 += (clipy2[j]-clipy1[j])*(oyvect>>6);
				if ((templong1^templong2) < 0) return(retval);
			}

			keepaway(&goalx, &goaly, hitwall);
			xvect = ((goalx-intx)<<14);
			yvect = ((goaly-inty)<<14);

			if (cnt == 3) retval = clipobjectval[hitwall];
			hitwalls[cnt] = hitwall;
		}
		cnt--;

		*x = intx;
		*y = inty;
	} while (((xvect|yvect) != 0) && (hitwall >= 0) && (cnt > 0));

	for(j=0;j<clipsectnum;j++)
		if (inside(*x,*y,clipsectorlist[j]) == 1)
		{
			*sectnum = clipsectorlist[j];
			return(retval);
		}

	*sectnum = -1; templong1 = 0x7fffffff;
	for(j=numsectors-1;j>=0;j--)
		if (inside(*x,*y,j) == 1)
		{
			templong2 = (sector[j].ceilingz-(*z));
			if (templong2 > 0)
			{
				if (templong2 < templong1)
					{ *sectnum = j; templong1 = templong2; }
			}
			else
			{
				templong2 = ((*z)-sector[j].floorz);
				if (templong2 <= 0)
				{
					*sectnum = j;
					return(retval);
				}
				if (templong2 < templong1)
					{ *sectnum = j; templong1 = templong2; }
			}
		}

	return(retval);
}

getcliplines(long x, long y, long z, long goalx, long goaly, short sectnum, long walldist, long ceildist, long flordist, char cliptype)
{
	char cstat, clipyou, bad;
	long i, j, k, l, clipsectcnt, startwall, endwall;
	long x1, y1, x2, y2, cx, cy, rad, xmin, ymin, xmax, ymax, daz, daz2;
	long bsz, dax, day, xoff, yoff, xspan, yspan, cosang, sinang, tilenum;
	long xrepeat, yrepeat, gx, gy, dx, dy;
	struct walltype *wal, *wal2;
	struct spritetype *spr;
	struct sectortype *sec;

	clipnum = 0;

	cx = ((x+goalx)>>1);
	cy = ((y+goaly)>>1);
		//Extra walldist for sprites on sector lines
	gx = goalx-x; gy = goaly-y;
	rad = ksqrtasm(gx*gx + gy*gy) + MAXCLIPDIST+walldist + 8;
	xmin = cx-rad; ymin = cy-rad;
	xmax = cx+rad; ymax = cy+rad;

	clipsectorlist[0] = sectnum;
	clipsectcnt = 0; clipsectnum = 1;

	while (clipsectcnt < clipsectnum)
	{
		sec = &sector[clipsectorlist[clipsectcnt]];
		startwall = sec->wallptr; endwall = startwall + sec->wallnum;
		for(j=startwall,wal=&wall[startwall];j<endwall;j++,wal++)
		{
			wal2 = &wall[wal->point2];
			x1 = wal->x; y1 = wal->y; x2 = wal2->x; y2 = wal2->y;

			if ((x1 < xmin) && (x2 < xmin)) continue;
			if ((x1 > xmax) && (x2 > xmax)) continue;
			if ((y1 < ymin) && (y2 < ymin)) continue;
			if ((y1 > ymax) && (y2 > ymax)) continue;

			dx = x2-x1; dy = y2-y1;
			if (dx*(y-y1) >= (x-x1)*dy) //If wall's facing you
			{
				if (dx > 0) dax = dx*(ymin-y1); else dax = dx*(ymax-y1);
				if (dy > 0) day = dy*(xmax-x1); else day = dy*(xmin-x1);
				if (dax >= day) continue;

				clipyou = 0;
				if (wal->nextsector < 0) clipyou = 1;
				if ((cliptype != 1) && ((wal->cstat&1) > 0)) clipyou = 1;
				if ((cliptype == 1) && ((wal->cstat&64) != 0)) clipyou = 1;
				sec = &sector[wal->nextsector];
				if (editstatus == 0)
				{
					if ((sec->ceilingstat&1) == 0)
						if (z <= sec->ceilingz+(ceildist-1)) clipyou = 1;
					if ((sec->floorstat&1) == 0)
					{
						if (z >= sec->floorz-(flordist-1)) clipyou = 1;
						if ((cliptype == 2) && (z+scaredfallz < sec->floorz)) clipyou = 1;
					}
				}

				if (clipyou != 0)
				{
						//Add 2 boxes at endpoints
					bsz = walldist; if (gx < 0) bsz = -bsz;
					addclipline(x1-bsz,y1-bsz,x1-bsz,y1+bsz,(short)j+32768);
					addclipline(x2-bsz,y2-bsz,x2-bsz,y2+bsz,(short)k+32768);
					bsz = walldist; if (gy < 0) bsz = -bsz;
					addclipline(x1+bsz,y1-bsz,x1-bsz,y1-bsz,(short)j+32768);
					addclipline(x2+bsz,y2-bsz,x2-bsz,y2-bsz,(short)k+32768);

					dax = walldist; if (dy > 0) dax = -dax;
					day = walldist; if (dx < 0) day = -day;
					addclipline(x1+dax,y1+day,x2+dax,y2+day,(short)j+32768);
				}
				else
				{
					bad = 0;
					for(i=clipsectnum-1;i>=0;i--)
						if (wal->nextsector == clipsectorlist[i]) { bad = 1; break; }
					if (bad == 0) clipsectorlist[clipsectnum++] = wal->nextsector;
				}
			}
		}
		clipsectcnt++;
	}

	for(i=0;i<clipsectnum;i++)
	{
		for(j=headspritesect[clipsectorlist[i]];j>=0;j=nextspritesect[j])
		{
			spr = &sprite[j];
			cstat = spr->cstat;
			if ((cstat&1) > 0)
			{
				x1 = spr->x; y1 = spr->y;

				switch(cstat&48)
				{
					case 0:
						if ((x1 >= xmin) && (x1 <= xmax) && (y1 >= ymin) && (y1 <= ymax))
						{
							k = ((tilesizy[spr->picnum]*spr->yrepeat)<<2);
							if (cstat&128) daz = spr->z+(k>>1); else daz = spr->z;
							daz2 = daz-k;
							daz += ceildist; daz2 -= flordist;
							if ((z < daz) && (z > daz2))
							{
								bsz = (spr->clipdist<<2)+walldist; if (gx < 0) bsz = -bsz;
								addclipline(x1-bsz,y1-bsz,x1-bsz,y1+bsz,(short)j+49152);
								bsz = (spr->clipdist<<2)+walldist; if (gy < 0) bsz = -bsz;
								addclipline(x1+bsz,y1-bsz,x1-bsz,y1-bsz,(short)j+49152);
							}
						}
						break;
					case 16:
						k = ((tilesizy[spr->picnum]*spr->yrepeat)<<2);
						if (cstat&128) daz = spr->z+(k>>1); else daz = spr->z;
						daz2 = daz-k;
						daz += ceildist; daz2 -= flordist;
						if ((z < daz) && (z > daz2))
						{
								//These lines get the 2 points of the rotated sprite
								//Given: (x1, y1) starts out as the center point
							tilenum = spr->picnum;
							xoff = (long)((signed char)((picanm[tilenum]>>8)&255))+((long)spr->xoffset);
							if ((cstat&4) > 0) xoff = -xoff;
							k = spr->ang; l = spr->xrepeat;
							dax = sintable[k&2047]*l; day = sintable[(k+1536)&2047]*l;
							l = tilesizx[tilenum]; k = (l>>1)+xoff;
							x1 -= mulscale16(dax,k); x2 = x1+mulscale16(dax,l);
							y1 -= mulscale16(day,k); y2 = y1+mulscale16(day,l);
							if (clipinsideboxline(cx,cy,x1,y1,x2,y2,rad) > 0)
							{
								dax = mulscale14(sintable[(spr->ang+256+512)&2047],walldist);
								day = mulscale14(sintable[(spr->ang+256)&2047],walldist);

								if ((x1-x)*(y2-y) >= (x2-x)*(y1-y))   //Front
									addclipline(x1+dax,y1+day,x2+day,y2-dax,(short)j+49152);
								else
								{
									if ((cstat&64) != 0) continue;
									addclipline(x2-dax,y2-day,x1-day,y1+dax,(short)j+49152);
								}

									//Side blocker
								if ((x2-x1)*(x-x1) + (y2-y1)*(y-y1) < 0)
									addclipline(x1-day,y1+dax,x1+dax,y1+day,(short)j+49152);
								else if ((x1-x2)*(x-x2) + (y1-y2)*(y-y2) < 0)
									addclipline(x2+day,y2-dax,x2-dax,y2-day,(short)j+49152);
							}
						}
						break;
					case 32:
						daz = spr->z+ceildist;
						daz2 = spr->z-flordist;
						if ((z < daz) && (z > daz2))
						{
							if ((cstat&64) != 0)
								if ((z > spr->z) == ((cstat&8)==0)) continue;

							tilenum = spr->picnum;
							xoff = (long)((signed char)((picanm[tilenum]>>8)&255))+((long)spr->xoffset);
							yoff = (long)((signed char)((picanm[tilenum]>>16)&255))+((long)spr->yoffset);
							if ((cstat&4) > 0) xoff = -xoff;
							if ((cstat&8) > 0) yoff = -yoff;

							k = spr->ang;
							cosang = sintable[(k+512)&2047]; sinang = sintable[k];
							xspan = tilesizx[tilenum]; xrepeat = spr->xrepeat;
							yspan = tilesizy[tilenum]; yrepeat = spr->yrepeat;

							dax = ((xspan>>1)+xoff)*xrepeat; day = ((yspan>>1)+yoff)*yrepeat;
							rxi[0] = x1 + doublemulscale16(sinang,dax,cosang,day);
							ryi[0] = y1 + doublemulscale16(sinang,day,-cosang,dax);
							l = xspan*xrepeat;
							rxi[1] = rxi[0] - mulscale16(sinang,l);
							ryi[1] = ryi[0] + mulscale16(cosang,l);
							l = yspan*yrepeat;
							k = -mulscale16(cosang,l); rxi[2] = rxi[1]+k; rxi[3] = rxi[0]+k;
							k = -mulscale16(sinang,l); ryi[2] = ryi[1]+k; ryi[3] = ryi[0]+k;

							dax = mulscale14(sintable[(spr->ang-256+512)&2047],walldist);
							day = mulscale14(sintable[(spr->ang-256)&2047],walldist);

							if ((rxi[0]-x)*(ryi[1]-y) < (rxi[1]-x)*(ryi[0]-y))
							{
								if (clipinsideboxline(cx,cy,rxi[1],ryi[1],rxi[0],ryi[0],rad) > 0)
									addclipline(rxi[1]-day,ryi[1]+dax,rxi[0]+dax,ryi[0]+day,(short)j+49152);
							}
							else if ((rxi[2]-x)*(ryi[3]-y) < (rxi[3]-x)*(ryi[2]-y))
							{
								if (clipinsideboxline(cx,cy,rxi[3],ryi[3],rxi[2],ryi[2],rad) > 0)
									addclipline(rxi[3]+day,ryi[3]-dax,rxi[2]-dax,ryi[2]-day,(short)j+49152);
							}

							if ((rxi[1]-x)*(ryi[2]-y) < (rxi[2]-x)*(ryi[1]-y))
							{
								if (clipinsideboxline(cx,cy,rxi[2],ryi[2],rxi[1],ryi[1],rad) > 0)
									addclipline(rxi[2]-dax,ryi[2]-day,rxi[1]-day,ryi[1]+dax,(short)j+49152);
							}
							else if ((rxi[3]-x)*(ryi[0]-y) < (rxi[0]-x)*(ryi[3]-y))
							{
								if (clipinsideboxline(cx,cy,rxi[0],ryi[0],rxi[3],ryi[3],rad) > 0)
									addclipline(rxi[0]+dax,ryi[0]+day,rxi[3]+day,ryi[3]-dax,(short)j+49152);
							}
						}
						break;
				}
			}
		}
	}
}

addclipline(long x1, long y1, long x2, long y2, short oval)
{
	clipx1[clipnum] = x1; clipy1[clipnum] = y1;
	clipx2[clipnum] = x2; clipy2[clipnum] = y2;
	clipobjectval[clipnum] = oval;  //Add 32768-walls, 49152-sprites
	clipnum++;
}

keepaway (long *x, long *y, short w)
{
	char first;
	long dx, dy, ox, oy, x1, y1;

	x1 = clipx1[w]; dx = clipx2[w]-x1;
	y1 = clipy1[w]; dy = clipy2[w]-y1;
	ox = ksgn(-dy); oy = ksgn(dx);
	first = (klabs(dx) <= klabs(dy));
	while (1)
	{
		if (dx*(*y-y1) > (*x-x1)*dy) return;
		if (first == 0) *x += ox; else *y += oy;
		first ^= 1;
	}
}

raytrace (long x3, long y3, long *x4, long *y4)
{
	long x1, y1, x2, y2, t, bot, topu, nintx, ninty, cnt, z, hitwall;
	long x21, y21, x43, y43;

	hitwall = -1;
	for(z=clipnum-1;z>=0;z--)
	{
		x1 = clipx1[z]; x2 = clipx2[z]; x21 = x2-x1;
		y1 = clipy1[z]; y2 = clipy2[z]; y21 = y2-y1;

		topu = x21*(y3-y1) - (x3-x1)*y21; if (topu < 0) continue;
		if (x21*(*y4-y1) >= (*x4-x1)*y21) continue;
		x43 = *x4-x3; y43 = *y4-y3;
		if (x43*(y1-y3) > (x1-x3)*y43) continue;
		if (x43*(y2-y3) <= (x2-x3)*y43) continue;
		bot = x43*y21 - x21*y43; if (bot == 0) continue;

		cnt = 256;
		do
		{
			cnt--; if (cnt < 0) { *x4 = x3; *y4 = y3; return(z); }
			nintx = x3 + scale(x43,topu,bot);
			ninty = y3 + scale(y43,topu,bot);
			topu--;
		} while (x21*(ninty-y1) <= (nintx-x1)*y21);

		if (klabs(x3-nintx)+klabs(y3-ninty) < klabs(x3-*x4)+klabs(y3-*y4))
			{ *x4 = nintx; *y4 = ninty; hitwall = z; }
	}
	return(hitwall);
}

updatesector(long x, long y, short *sectnum)
{
	long i, j;
	struct walltype *wal;

	if (inside(x,y,*sectnum) == 1) return;

	if ((*sectnum >= 0) && (*sectnum < numsectors))
	{
		wal = &wall[sector[*sectnum].wallptr];
		for(j=sector[*sectnum].wallnum;j>0;j--,wal++)
		{
			i = wal->nextsector;
			if (i >= 0)
				if (inside(x,y,(short)i) == 1)
				{
					*sectnum = i;
					return;
				}
		}
	}

	for(i=numsectors-1;i>=0;i--)
		if (inside(x,y,(short)i) == 1)
		{
			*sectnum = i;
			return;
		}

	*sectnum = -1;
}

rotatepoint(long xpivot, long ypivot, long x, long y, short daang, long *x2, long *y2)
{
	long dacos, dasin;

	dacos = sintable[(daang+2560)&2047];
	dasin = sintable[(daang+2048)&2047];
	x -= xpivot;
	y -= ypivot;
	*x2 = doublemulscale14(x,dacos,-y,dasin) + xpivot;
	*y2 = doublemulscale14(y,dacos,x,dasin) + ypivot;
}

initmouse()
{
	return(moustat = setupmouse());
}

getmousevalues(short *mousx, short *mousy, short *bstatus)
{
	if (moustat == 0) { *mousx = 0; *mousy = 0; *bstatus = 0; return; }
	readmousexy(mousx,mousy);
	readmousebstatus(bstatus);
}

printscreeninterrupt()
{
	int5();
}

drawline256 (long x1, long y1, long x2, long y2, char col)
{
	long dx, dy, i, j, p, inc, plc, daend;

	col = palookup[0][col];

	dx = x2-x1; dy = y2-y1;
	if (dx >= 0)
	{
		if ((x1 >= wx2) || (x2 < wx1)) return;
		if (x1 < wx1) y1 += scale(wx1-x1,dy,dx), x1 = wx1;
		if (x2 > wx2) y2 += scale(wx2-x2,dy,dx), x2 = wx2;
	}
	else
	{
		if ((x2 >= wx2) || (x1 < wx1)) return;
		if (x2 < wx1) y2 += scale(wx1-x2,dy,dx), x2 = wx1;
		if (x1 > wx2) y1 += scale(wx2-x1,dy,dx), x1 = wx2;
	}
	if (dy >= 0)
	{
		if ((y1 >= wy2) || (y2 < wy1)) return;
		if (y1 < wy1) x1 += scale(wy1-y1,dx,dy), y1 = wy1;
		if (y2 > wy2) x2 += scale(wy2-y2,dx,dy), y2 = wy2;
	}
	else
	{
		if ((y2 >= wy2) || (y1 < wy1)) return;
		if (y2 < wy1) x2 += scale(wy1-y2,dx,dy), y2 = wy1;
		if (y1 > wy2) x1 += scale(wy2-y1,dx,dy), y1 = wy2;
	}

	if (klabs(dx) >= klabs(dy))
	{
		if (dx == 0) return;
		if (dx < 0)
		{
			i = x1; x1 = x2; x2 = i;
			i = y1; y1 = y2; y2 = i;
		}

		inc = divscale12(dy,dx);
		plc = y1+mulscale12((2047-x1)&4095,inc);
		i = ((x1+2048)>>12); daend = ((x2+2048)>>12);
		if (chainnumpages >= 2)
		{
			outp(0x3c4,2);
			for(;i<daend;i++)
			{
				outp(0x3c5,1<<(i&3));
				drawpixel(ylookup[plc>>12]+(i>>2)+chainplace,col);
				plc += inc;
			}
		}
		else
		{
			for(;i<daend;i++)
			{
				drawpixel(ylookup[plc>>12]+i+frameplace,col);
				plc += inc;
			}
		}
	}
	else
	{
		if (dy < 0)
		{
			i = x1; x1 = x2; x2 = i;
			i = y1; y1 = y2; y2 = i;
		}

		inc = divscale12(dx,dy);
		plc = x1+mulscale12((2047-y1)&4095,inc);
		i = ((y1+2048)>>12); daend = ((y2+2048)>>12);
		if (chainnumpages >= 2)
		{
			outp(0x3c4,2);
			p = ylookup[i]+chainplace;
			for(;i<daend;i++)
			{
				j = (plc>>12);
				outp(0x3c5,1<<(j&3)); drawpixel((j>>2)+p,col);
				plc += inc; p += ylookup[1];
			}
		}
		else
		{
			p = ylookup[i]+frameplace;
			for(;i<daend;i++)
			{
				drawpixel((plc>>12)+p,col);
				plc += inc; p += xdim;
			}
		}
	}
}

drawline16(long x1, long y1, long x2, long y2, char col)
{
	long i, dx, dy, p, pinc, d;
	char lmask, rmask;

	dx = x2-x1; dy = y2-y1;
	if (dx >= 0)
	{
		if ((x1 > 639) || (x2 < 0)) return;
		if (x1 < 0) { if (dy) y1 += scale(0-x1,dy,dx); x1 = 0; }
		if (x2 > 639) { if (dy) y2 += scale(639-x2,dy,dx); x2 = 639; }
	}
	else
	{
		if ((x2 > 639) || (x1 < 0)) return;
		if (x2 < 0) { if (dy) y2 += scale(0-x2,dy,dx); x2 = 0; }
		if (x1 > 639) { if (dy) y1 += scale(639-x1,dy,dx); x1 = 639; }
	}
	if (dy >= 0)
	{
		if ((y1 >= ydim16) || (y2 < 0)) return;
		if (y1 < 0) { if (dx) x1 += scale(0-y1,dx,dy); y1 = 0; }
		if (y2 >= ydim16) { if (dx) x2 += scale(ydim16-1-y2,dx,dy); y2 = ydim16-1; }
	}
	else
	{
		if ((y2 >= ydim16) || (y1 < 0)) return;
		if (y2 < 0) { if (dx) x2 += scale(0-y2,dx,dy); y2 = 0; }
		if (y1 >= ydim16) { if (dx) x1 += scale(ydim16-1-y1,dx,dy); y1 = ydim16-1; }
	}

	setcolor16((long)col);
	if (x1 == x2)
	{
		if (y2 < y1) i = y1, y1 = y2, y2 = i;
		koutpw(0x3ce,0x8+(256<<(x1&7^7)));  //bit mask
		vlin16(((mul640(y1)+x1+pageoffset)>>3)+0xa0000,y2-y1+1);
		return;
	}
	if (y1 == y2)
	{
		if (x2 < x1) i = x1, x1 = x2, x2 = i;
		lmask = (0x00ff>>(x1&7));
		rmask = (0xff80>>(x2&7));

		p = ((mul640(y1)+x1+pageoffset)>>3)+0xa0000;

		dx = (x2>>3)-(x1>>3);
		if (dx == 0)
		{
			koutpw(0x3ce,0x8+((lmask&rmask)<<8)); drawpixel(p,readpixel(p));
			return;
		}

		dx--;

		koutpw(0x3ce,0x8+(lmask<<8)); drawpixel(p,readpixel(p)); p++;
		if (dx > 0) { koutp(0x3cf,0xff); clearbufbyte(p,dx,0L); p += dx; }
		koutp(0x3cf,rmask); drawpixel(p,readpixel(p));
		return;
	}

	dx = klabs(x2-x1)+1; dy = klabs(y2-y1)+1;
	if (dx >= dy)
	{
		if (x2 < x1)
		{
			i = x1; x1 = x2; x2 = i;
			i = y1; y1 = y2; y2 = i;
		}
		p = mul640(y1)+x1+pageoffset;
		d = 0;
		if (y2 > y1) pinc = 640; else pinc = -640;
		for(i=dx;i>0;i--)
		{
			drawpixel16(p);
			d += dy;
			if (d >= dx) { d -= dx; p += pinc; }
			p++;
		}
		return;
	}

	if (y2 < y1)
	{
		i = x1; x1 = x2; x2 = i;
		i = y1; y1 = y2; y2 = i;
	}
	p = mul640(y1)+x1+pageoffset;
	d = 0;
	if (x2 > x1) pinc = 1; else pinc = -1;
	for(i=dy;i>0;i--)
	{
		drawpixel16(p);
		d += dx;
		if (d >= dy) { d -= dy; p += pinc; }
		p += 640;
	}
}

qsetmode640350()
{
	if (qsetmode != 350)
	{
		if (stereofps != 0) stereofps = 1;

		setvmode(0x10);

		pageoffset = 0;
		ydim16 = 350;
		koutpw(0x3d4,0xc+((pageoffset>>11)<<8));

		koutpw(0x3ce,0x0f00);  //set/reset
		koutpw(0x3ce,0x0f01);  //enable set/reset
		fillscreen16(0L,0L,640L*350L);
	}
	qsetmode = 350;
}

qsetmode640480()
{
	short i;

	if (qsetmode != 480)
	{
		if (stereofps != 0) stereofps = 1;

		setvmode(0x12);

		i = 479-144;
		koutpw(0x3d4,0x18+((i&255)<<8));             //line compare
		koutp(0x3d4,0x7); koutp(0x3d5,(kinp(0x3d5)&239)|((i&256)>>4));
		koutp(0x3d4,0x9); koutp(0x3d5,(kinp(0x3d5)&191)|((i&512)>>3));

		pageoffset = 92160;
		koutpw(0x3d4,0xc+((pageoffset>>11)<<8));

		koutpw(0x3ce,0x0f00);  //set/reset
		koutpw(0x3ce,0x0f01);  //enable set/reset
		fillscreen16(0L,8L,640L*144L);
		fillscreen16((640L*144L)>>3,0L,640L*336L);
		pageoffset = 92160; ydim16 = 336;
	}

	qsetmode = 480;
}

clear2dscreen()
{
	if (qsetmode == 350)
	{
		fillscreen16(pageoffset>>3,0L,640L*350L);
	}
	else if (qsetmode == 480)
	{
		if (ydim16 <= 336)
			fillscreen16(pageoffset>>3,0L,640L*336L);
		else
			fillscreen16(pageoffset>>3,0L,640L*480L);
	}
}

draw2dgrid(long posxe, long posye, short ange, long zoome, short gride)
{
	long i, xp1, yp1, xp2, yp2, tempy, templong;
	char mask;

	if (gride > 0)
	{
		yp1 = 200-mulscale14(posye+65536,zoome);
		if (yp1 < 0) yp1 = 0;
		yp2 = 200-mulscale14(posye-65536,zoome);
		if (yp2 >= ydim16) yp2 = ydim16-1;

		if ((yp1 < ydim16) && (yp2 >= 0) && (yp2 >= yp1))
		{
			setcolor16(8);
			koutp(0x3ce,0x8);

			templong = ((yp1*640+pageoffset)>>3)+0xa0000;
			tempy = yp2-yp1+1;
			mask = 0;
			xp1 = 320-mulscale14(posxe+65536,zoome);

			for(i=-65536;i<=65536;i+=(2048>>gride))
			{
				xp2 = xp1;
				xp1 = 320-mulscale14(posxe-i,zoome);

				if (xp1 >= 640) break;
				if (xp1 >= 0)
				{
					if ((xp1|7) != (xp2|7))
					{
						koutp(0x3cf,mask);
						if (((xp2>>3) >= 0) && ((xp2>>3) < 80))
							vlin16first(templong+(xp2>>3),tempy);
						mask = 0;
					}
					mask |= (1<<(xp1&7^7));
				}
			}
			if ((i >= 65536) && (xp1 < 640))
				xp2 = xp1;
			if ((mask != 0) && ((xp2>>3) >= 0) && ((xp2>>3) < 80))
			{
				koutp(0x3cf,mask);
				vlin16first(templong+(xp2>>3),tempy);
			}
		}

		xp1 = mulscale14(posxe+65536,zoome);
		xp2 = mulscale14(posxe-65536,zoome);
		tempy = 0x80000000;
		for(i=-65536;i<=65536;i+=(2048>>gride))
		{
			yp1 = (((posye-i)*zoome)>>14);
			if (yp1 != tempy)
			{
				if ((yp1 > -200) && (yp1 <= 200))
				{
					drawline16(320-xp1,200-yp1,320-xp2,200-yp1,8);
					tempy = yp1;
				}
			}
		}
	}
}

draw2dscreen(long posxe, long posye, short ange, long zoome, short gride)
{
	long i, j, k, xp1, yp1, xp2, yp2, tempy, templong;
	char col, mask;
	struct walltype *wal;

	if (qsetmode == 200) return;

	if (editstatus == 0)
	{
		faketimerhandler();
		clear2dscreen();

		faketimerhandler();
		draw2dgrid(posxe,posye,ange,zoome,gride);
	}

	faketimerhandler();
	for(i=numwalls-1,wal=&wall[i];i>=0;i--,wal--)
	{
		if (editstatus == 0)
		{
			if ((show2dwall[i>>3]&(1<<(i&7))) == 0) continue;
			j = wal->nextwall;
			if ((j >= 0) && (i > j))
				if ((show2dwall[j>>3]&(1<<(j&7))) > 0) continue;
		}
		else
		{
			j = wal->nextwall;
			if ((j >= 0) && (i > j)) continue;
		}

		if (j < 0)
		{
			col = 7;
			if (i == linehighlight) col += ((numframes&2)<<2);
		}
		else
		{
			col = 4;
			if ((wal->cstat&1) != 0) col = 5;
			if ((i == linehighlight) || ((linehighlight >= 0) && (i == wall[linehighlight].nextwall)))
				col += ((numframes&2)<<2);
		}

		xp1 = mulscale14(wal->x-posxe,zoome);
		yp1 = mulscale14(wal->y-posye,zoome);
		xp2 = mulscale14(wall[wal->point2].x-posxe,zoome);
		yp2 = mulscale14(wall[wal->point2].y-posye,zoome);

		if ((wal->cstat&64) > 0)
		{
			if (klabs(xp2-xp1) >= klabs(yp2-yp1))
			{
				drawline16(320+xp1,200+yp1+1,320+xp2,200+yp2+1,col);
				drawline16(320+xp1,200+yp1-1,320+xp2,200+yp2-1,col);
			}
			else
			{
				drawline16(320+xp1+1,200+yp1,320+xp2+1,200+yp2,col);
				drawline16(320+xp1-1,200+yp1,320+xp2-1,200+yp2,col);
			}
			col += 8;
		}
		drawline16(320+xp1,200+yp1,320+xp2,200+yp2,col);

		if ((zoome >= 256) && (editstatus == 1))
			if (((320+xp1) >= 2) && ((320+xp1) <= 637))
				if (((200+yp1) >= 2) && ((200+yp1) <= ydim16-3))
				{
					col = 2;
					if (i == pointhighlight) col += ((numframes&2)<<2);
					else if ((highlightcnt > 0) && (editstatus == 1))
					{
						if ((show2dwall[i>>3]&(1<<(i&7))) > 0)
							col += ((numframes&2)<<2);
					}

					templong = mul640(200+yp1)+(320+xp1)+pageoffset;
					setcolor16((long)col);
					drawpixel16(templong-2-1280);
					drawpixel16(templong-1-1280);
					drawpixel16(templong+0-1280);
					drawpixel16(templong+1-1280);
					drawpixel16(templong+2-1280);

					drawpixel16(templong-2+1280);
					drawpixel16(templong-1+1280);
					drawpixel16(templong+0+1280);
					drawpixel16(templong+1+1280);
					drawpixel16(templong+2+1280);

					drawpixel16(templong-2-640);
					drawpixel16(templong-2+0);
					drawpixel16(templong-2+640);

					drawpixel16(templong+2-640);
					drawpixel16(templong+2+0);
					drawpixel16(templong+2+640);
				}
	}
	faketimerhandler();

	if ((zoome >= 256) || (editstatus == 0))
		for(i=0;i<numsectors;i++)
			for(j=headspritesect[i];j>=0;j=nextspritesect[j])
				if ((editstatus == 1) || ((show2dsprite[j>>3]&(1<<(j&7))) > 0))
				{
					col = 3;
					if ((sprite[j].cstat&1) > 0) col = 5;
					if (editstatus == 1)
					{
						if (j+16384 == pointhighlight)
							col += ((numframes&2)<<2);
						else if ((highlightcnt > 0) && (editstatus == 1))
						{
							if ((show2dsprite[j>>3]&(1<<(j&7))) > 0)
								col += ((numframes&2)<<2);
						}
					}

					xp1 = mulscale14(sprite[j].x-posxe,zoome);
					yp1 = mulscale14(sprite[j].y-posye,zoome);
					if (((320+xp1) >= 2) && ((320+xp1) <= 637))
						if (((200+yp1) >= 2) && ((200+yp1) <= ydim16-3))
						{
							templong = mul640(200+yp1)+(320+xp1)+pageoffset;
							setcolor16((long)col);
							drawpixel16(templong-1-1280);
							drawpixel16(templong+0-1280);
							drawpixel16(templong+1-1280);

							drawpixel16(templong-1+1280);
							drawpixel16(templong+0+1280);
							drawpixel16(templong+1+1280);

							drawpixel16(templong-2-640);
							drawpixel16(templong-2+0);
							drawpixel16(templong-2+640);

							drawpixel16(templong+2-640);
							drawpixel16(templong+2+0);
							drawpixel16(templong+2+640);

							drawpixel16(templong+1+640);
							drawpixel16(templong-1+640);
							drawpixel16(templong+1-640);
							drawpixel16(templong-1-640);

							xp2 = mulscale11(sintable[(sprite[j].ang+2560)&2047],zoome) / 768;
							yp2 = mulscale11(sintable[(sprite[j].ang+2048)&2047],zoome) / 768;

							if ((sprite[j].cstat&256) > 0)
							{
								if (((sprite[j].ang+256)&512) == 0)
								{
									drawline16(320+xp1,200+yp1-1,320+xp1+xp2,200+yp1+yp2-1,col);
									drawline16(320+xp1,200+yp1+1,320+xp1+xp2,200+yp1+yp2+1,col);
								}
								else
								{
									drawline16(320+xp1-1,200+yp1,320+xp1+xp2-1,200+yp1+yp2,col);
									drawline16(320+xp1+1,200+yp1,320+xp1+xp2+1,200+yp1+yp2,col);
								}
								col += 8;
							}
							drawline16(320+xp1,200+yp1,320+xp1+xp2,200+yp1+yp2,col);
						}
				}

	faketimerhandler();
	xp1 = mulscale11(sintable[(ange+2560)&2047],zoome) / 768; //Draw white arrow
	yp1 = mulscale11(sintable[(ange+2048)&2047],zoome) / 768;
	drawline16(320+xp1,200+yp1,320-xp1,200-yp1,15);
	drawline16(320+xp1,200+yp1,320+yp1,200-xp1,15);
	drawline16(320+xp1,200+yp1,320-yp1,200+xp1,15);
}

printext16(long xpos, long ypos, short col, short backcol, char name[82], char fontsize)
{
	char ch, dat, *fontptr;
	short mask;
	long p, z, zz, charxsiz, daxpos;

	daxpos = xpos;

	koutp(0x3ce,0x5); koutp(0x3cf,(kinp(0x3cf)&(255-3))+2);
	koutp(0x3ce,0x8);

	if (fontsize == 1)
	{
		fontptr = smalltextfont;
		charxsiz = 4;
	}
	else
	{
		fontptr = textfont;
		charxsiz = 8;
	}

	z = 0;
	while (name[z] != 0)
	{
		ch = name[z];
		z++;

		mask = (1<<(8-(daxpos&7)))-1;
		p = ypos*80 + (daxpos>>3)+0xa0000;   //Do not make ylookup!

		if ((daxpos&7) == 0)
		{
			for(zz=0;zz<8;zz++)
			{
				if (backcol >= 0)
				{
					koutp(0x3cf,0xff);
					if (charxsiz == 4) koutp(0x3cf,0x7c);
					readpixel(p), drawpixel(p,(long)backcol);
				}
				koutp(0x3cf,fontptr[(((long)ch)<<3)+zz]);
				if (charxsiz == 4) koutp(0x3cf,0x7c&fontptr[(((long)ch)<<3)+zz]);
				readpixel(p), drawpixel(p,col);
				p += 80;
			}
		}
		else
		{
			for(zz=0;zz<8;zz++)
			{
				if (backcol >= 0)
				{
					if (charxsiz == 8)
					{
						koutp(0x3cf,mask);
						readpixel(p), drawpixel(p,backcol);
						koutp(0x3cf,0xff-mask);
						readpixel(p+1), drawpixel(p+1,backcol);
					}
					else
					{
						koutp(0x3cf,0x7c>>(daxpos&7));
						readpixel(p), drawpixel(p,backcol);
						koutp(0x3cf,0x7c<<(8-(daxpos&7)));
						readpixel(p+1), drawpixel(p+1,backcol);
					}
				}
				dat = fontptr[(((long)ch)<<3)+zz];
				if (charxsiz == 8)
				{
					koutp(0x3cf,mask&(dat>>(daxpos&7)));
					readpixel(p), drawpixel(p,col);
					koutp(0x3cf,(255-mask)&(dat<<(8-(daxpos&7))));
					readpixel(p+1), drawpixel(p+1,col);
				}
				else
				{
					koutp(0x3cf,(0x7c&dat)>>(daxpos&7));
					readpixel(p), drawpixel(p,col);
					koutp(0x3cf,(0x7c&dat)<<(8-(daxpos&7)));
					readpixel(p+1), drawpixel(p+1,col);
				}
				p += 80;    //Do not make ylookup[1]!
			}
		}

		daxpos += charxsiz;
	}
	koutp(0x3ce,0x5); koutp(0x3cf,(kinp(0x3cf)&(255-3))+0);
}

getspritescreencoord(short spritesortnum, long *scrx, long *scry)
{
	long i, siz;

	siz = divscale32(8L,spritey[spritesortnum]);

	*scrx = (spritex[spritesortnum]>>8);
	i = thesprite[spritesortnum];
	*scry = sprite[i].z - globalposz;
	if ((sprite[i].cstat&128) == 0) *scry -= ((tilesizy[spritepicnum[spritesortnum]]*sprite[i].yrepeat)<<1);
	*scry = globalhoriz + mulscale24(siz,*scry);
}

printext256(long xpos, long ypos, short col, short backcol, char name[82], char fontsize)
{
	char *fontptr;
	short dat, dacol;
	long stx, zx, stupidbitoffset, x, y, charxsiz;

	stx = xpos;

	if (fontsize == 1)
	{
		fontptr = smalltextfont;
		charxsiz = 4;
		stupidbitoffset = 1;
	}
	else
	{
		fontptr = textfont;
		charxsiz = 8;
		stupidbitoffset = 0;
	}

	for(zx=0;zx<strlen(name);zx++)
	{
		dat = name[zx];

		for(y=0;y<8;y++)
			for(x=0;x<charxsiz;x++)
			{
				if ((fontptr[(dat<<3)+y]&(1<<(7-stupidbitoffset-x))) > 0)
					dacol = (short)col;
				else if (backcol >= 0)
					dacol = (short)backcol;
				else
					dacol = -1;

				if (dacol >= 0)
				{
					if (chainnumpages >= 2)
					{
						koutpw(0x3c4,2+(256<<((x+stx-stupidbitoffset)&3)));
						drawpixel(ylookup[y+ypos]+((x+stx-stupidbitoffset)>>2)+chainplace,(long)dacol);
					}
					else
						drawpixel(ylookup[y+ypos]+(x+stx-stupidbitoffset)+frameplace,(long)dacol);
				}
			}

		stx += charxsiz;
	}
}

krand()
{
	randomseed = ((randomseed*21+1)&65535);
	return(randomseed);
}

getzrange(long x, long y, long z, short sectnum,
			 long *ceilz, long *ceilhit, long *florz, long *florhit,
			 long walldist, char cliptype)
{
	char bad, clipyou;
	long clipsectcnt, startwall, endwall, tilenum, xoff, yoff, dax, day;
	long xmin, ymin, xmax, ymax, i, j, k, l, daz, daz2, dx, dy;
	long x1, y1, x2, y2, x3, y3, x4, y4, ang, cosang, sinang;
	long xspan, yspan, xrepeat, yrepeat;
	short cstat;
	struct sectortype *sec;
	struct walltype *wal, *wal2;
	struct spritetype *spr;

		//Extra walldist for sprites on sector lines
	i = walldist+MAXCLIPDIST+1;
	xmin = x-i; ymin = y-i;
	xmax = x+i; ymax = y+i;

	*ceilz = sector[sectnum].ceilingz; *ceilhit = sectnum+16384;
	*florz = sector[sectnum].floorz;   *florhit = sectnum+16384;
	return;

	clipsectorlist[0] = sectnum;
	clipsectcnt = 0; clipsectnum = 1;

	do  //Collect sectors inside your square first
	{
		sec = &sector[clipsectorlist[clipsectcnt]];
		startwall = sec->wallptr; endwall = startwall + sec->wallnum;
		for(j=startwall,wal=&wall[startwall];j<endwall;j++,wal++)
		{
			k = wal->nextsector;
			if (k >= 0)
			{
				wal2 = &wall[wal->point2];
				x1 = wal->x; x2 = wal2->x;
				if ((x1 < xmin) && (x2 < xmin)) continue;
				if ((x1 > xmax) && (x2 > xmax)) continue;
				y1 = wal->y; y2 = wal2->y;
				if ((y1 < ymin) && (y2 < ymin)) continue;
				if ((y1 > ymax) && (y2 > ymax)) continue;

				dx = x2-x1; dy = y2-y1;
				if (dx*(y-y1) < (x-x1)*dy) continue; //back
				if (dx > 0) dax = dx*(ymin-y1); else dax = dx*(ymax-y1);
				if (dy > 0) day = dy*(xmax-x1); else day = dy*(xmin-x1);
				if (dax >= day) continue;

				if (cliptype == 1) { if ((wal->cstat&64) != 0) continue; }
				else { if ((wal->cstat&1) != 0) continue; }
				sec = &sector[k];
				if (editstatus == 0)
				{
					if ((sec->ceilingstat&1) == 0)
						if (z <= sec->ceilingz+(3<<8)) continue;
					if ((sec->floorstat&1) == 0)
					{
						if (z >= sec->floorz-(3<<8)) continue;
						if ((cliptype == 2) && (z+scaredfallz < sec->floorz)) continue;
					}
				}

				bad = 0;
				for(i=clipsectnum-1;i>=0;i--)
					if (clipsectorlist[i] == k) { bad = 1; break; }
				if (bad != 0) continue;
				clipsectorlist[clipsectnum++] = k;

				if ((x1 < xmin+MAXCLIPDIST) && (x2 < xmin+MAXCLIPDIST)) continue;
				if ((x1 > xmax-MAXCLIPDIST) && (x2 > xmax-MAXCLIPDIST)) continue;
				if ((y1 < ymin+MAXCLIPDIST) && (y2 < ymin+MAXCLIPDIST)) continue;
				if ((y1 > ymax-MAXCLIPDIST) && (y2 > ymax-MAXCLIPDIST)) continue;
				if (dx > 0) dax += dx*MAXCLIPDIST; else dax -= dx*MAXCLIPDIST;
				if (dy > 0) day -= dy*MAXCLIPDIST; else day += dy*MAXCLIPDIST;
				if (dax >= day) continue;

					//It actually got here, through all the continue's!!!
				if (sec->ceilingz > *ceilz)
					{ *ceilz = sec->ceilingz; *ceilhit = k+16384; }
				if (sec->floorz < *florz)
					{ *florz = sec->floorz; *florhit = k+16384; }
			}
		}
		clipsectcnt++;
	} while (clipsectcnt < clipsectnum);

	for(i=0;i<clipsectnum;i++)
	{
		for(j=headspritesect[clipsectorlist[i]];j>=0;j=nextspritesect[j])
		{
			spr = &sprite[j];
			cstat = spr->cstat;
			if ((cstat&1) > 0)
			{
				x1 = spr->x; y1 = spr->y;

				clipyou = 0;
				switch(cstat&48)
				{
					case 0:
						k = walldist+(spr->clipdist<<2)+1;
						if ((klabs(x1-x) <= k) && (klabs(y1-y) <= k))
						{
							daz = spr->z;
							if (cstat&128) daz += ((tilesizy[spr->picnum]*spr->yrepeat)<<1);
							daz2 = daz - ((tilesizy[spr->picnum]*spr->yrepeat)<<2);
							clipyou = 1;
						}
						break;
					case 16:
						tilenum = spr->picnum;
						xoff = (long)((signed char)((picanm[tilenum]>>8)&255))+((long)spr->xoffset);
						if ((cstat&4) > 0) xoff = -xoff;
						k = spr->ang; l = spr->xrepeat;
						dax = sintable[k&2047]*l; day = sintable[(k+1536)&2047]*l;
						l = tilesizx[tilenum]; k = (l>>1)+xoff;
						x1 -= mulscale16(dax,k); x2 = x1+mulscale16(dax,l);
						y1 -= mulscale16(day,k); y2 = y1+mulscale16(day,l);
						if (clipinsideboxline(x,y,x1,y1,x2,y2,walldist+1) > 0)
						{
							daz = spr->z; k = ((tilesizy[spr->picnum]*spr->yrepeat)<<1);
							if (cstat&128) daz += k;
							daz2 = daz-(k<<1);
							clipyou = 1;
						}
						break;
					case 32:
						daz = spr->z; daz2 = daz;

						if ((cstat&64) != 0)
							if ((z > daz) == ((cstat&8)==0)) continue;

						tilenum = spr->picnum;
						xoff = (long)((signed char)((picanm[tilenum]>>8)&255))+((long)spr->xoffset);
						yoff = (long)((signed char)((picanm[tilenum]>>16)&255))+((long)spr->yoffset);
						if ((cstat&4) > 0) xoff = -xoff;
						if ((cstat&8) > 0) yoff = -yoff;

						ang = spr->ang;
						cosang = sintable[(ang+512)&2047]; sinang = sintable[ang];
						xspan = tilesizx[tilenum]; xrepeat = spr->xrepeat;
						yspan = tilesizy[tilenum]; yrepeat = spr->yrepeat;

						dax = ((xspan>>1)+xoff)*xrepeat; day = ((yspan>>1)+yoff)*yrepeat;
						x1 += doublemulscale16(sinang,dax,cosang,day)-x;
						y1 += doublemulscale16(sinang,day,-cosang,dax)-y;
						l = xspan*xrepeat;
						x2 = x1 - mulscale16(sinang,l);
						y2 = y1 + mulscale16(cosang,l);
						l = yspan*yrepeat;
						k = -mulscale16(cosang,l); x3 = x2+k; x4 = x1+k;
						k = -mulscale16(sinang,l); y3 = y2+k; y4 = y1+k;

						dax = mulscale14(sintable[(spr->ang-256+512)&2047],walldist+4);
						day = mulscale14(sintable[(spr->ang-256)&2047],walldist+4);
						x1 += dax; x2 -= day; x3 -= dax; x4 += day;
						y1 += day; y2 += dax; y3 -= day; y4 -= dax;

						if ((y1^y2) < 0)
						{
							if ((x1^x2) < 0) clipyou ^= (x1*y2<x2*y1)^(y1<y2);
							else if (x1 >= 0) clipyou ^= 1;
						}
						if ((y2^y3) < 0)
						{
							if ((x2^x3) < 0) clipyou ^= (x2*y3<x3*y2)^(y2<y3);
							else if (x2 >= 0) clipyou ^= 1;
						}
						if ((y3^y4) < 0)
						{
							if ((x3^x4) < 0) clipyou ^= (x3*y4<x4*y3)^(y3<y4);
							else if (x3 >= 0) clipyou ^= 1;
						}
						if ((y4^y1) < 0)
						{
							if ((x4^x1) < 0) clipyou ^= (x4*y1<x1*y4)^(y4<y1);
							else if (x4 >= 0) clipyou ^= 1;
						}
						break;
				}

				if (clipyou != 0)
				{
					if ((z > daz) && (daz > *ceilz))
						{ *ceilz = daz; *ceilhit = j+49152; }
					if ((z < daz2) && (daz2 < *florz))
						{ *florz = daz2; *florhit = j+49152; }
				}
			}
		}
	}
}

makeradarang(long xdime)
{
	long i, j, k, x;

	x = 0;
	for(i=0;i<xdime;i++)
	{
		j = (x&65535); k = (x>>16); x += xdimscale;
		if (j != 0) j = mulscale16(radarang[k+1]-radarang[k],j);
		radarang2[i] = ((radarang[k]+j)>>6);
	}
}

setview(long x1, long y1, long x2, long y2)
{
	long i, j, bakxdimen;

	windowx1 = x1; wx1 = (x1<<12);
	windowy1 = y1; wy1 = (y1<<12);
	windowx2 = x2; wx2 = ((x2+1)<<12);
	windowy2 = y2; wy2 = ((y2+1)<<12);

	bakxdimen = xdimen;
	xdimen = (x2-x1)+1; halfxdimen = (xdimen>>1);
	ydimen = (y2-y1)+1;
	xdimenscale = divscale16(xdimen,320);
	xdimscale = divscale16(320,xdimen);
	xdimenoffs = x1;

	if (xdimen != bakxdimen) makeradarang(xdimen);

	for(i=0;i<windowx1;i++) { startumost[i] = 1, startdmost[i] = 0; }
	for(i=windowx1;i<=windowx2;i++)
		{ startumost[i] = windowy1, startdmost[i] = windowy2+1; }
	for(i=windowx2+1;i<xdim;i++) { startumost[i] = 1, startdmost[i] = 0; }

	viewoffset = windowy1*xdim + windowx1;
}

precache()
{
	long i;
	short j;

	for(i=0;i<numsectors;i++)
	{
		j = sector[i].ceilingpicnum;
		if (waloff[j] == 0) loadtile(j);
		j = sector[i].floorpicnum;
		if (waloff[j] == 0) loadtile(j);
	}
	for(i=0;i<numwalls;i++)
	{
		j = wall[i].picnum;
		if (waloff[j] == 0) loadtile(j);
	}
	for(i=0;i<MAXSPRITES;i++)
		if (sprite[i].statnum < MAXSTATUS)
		{
			j = sprite[i].picnum;
			if (waloff[j] == 0) loadtile(j);
		}
}

wallmost(short *mostbuf, long w, long z)
{
	long bad, x, intx, inty, xcross, y, yy, yinc;

	z <<= 3;
	bad = (z < globaluclip*yb1[w]);
	bad += ((z < globaluclip*yb2[w])<<1);
	bad += ((z > globaldclip*yb1[w])<<2);
	bad += ((z > globaldclip*yb2[w])<<3);

	if ((bad&3) == 3)
	{
		for(x=xb1[w];x<=xb2[w];x++) mostbuf[x] = 0;
		return(bad);
	}

	if ((bad&0xc) == 0xc)
	{
		for(x=xb1[w];x<=xb2[w];x++) mostbuf[x] = ydimen;
		return(bad);
	}

	if ((bad&3) > 0)
	{
		inty = z / globaluclip;
		intx = rx1[w]+scale(inty-ry1[w],rx2[w]-rx1[w],ry2[w]-ry1[w]);
		xcross = ((intx*halfxdimen)/inty)+halfxdimen;
		if (intx > 0) xcross--;

		if ((bad&3) == 2)
		{
			if (xb1[w] <= xcross)
			{
				y = divscale16(z,yb1[w]);
				yy = divscale16(z,inty);
				if (xdimen != 320)
				{
					y = mulscale16(y,xdimenscale);
					yy = mulscale16(yy,xdimenscale);
				}
				yinc = (yy-y) / (xcross-xb1[w]+1);
				y += (globalhoriz<<16);
				qinterpolatedown16short((long)(&mostbuf[xb1[w]]),xcross-xb1[w],y,yinc);
			}
			for(x=xcross+1;x<=xb2[w];x++) mostbuf[x] = 0;
		}
		else
		{
			if (xcross <= xb2[w])
			{
				y = divscale16(z,inty);
				yy = divscale16(z,yb2[w]);
				if (xdimen != 320)
				{
					y = mulscale16(y,xdimenscale);
					yy = mulscale16(yy,xdimenscale);
				}
				yinc = (yy-y) / (xb2[w]-xcross+1);
				y += (globalhoriz<<16);
				qinterpolatedown16short((long)(&mostbuf[xcross]),xb2[w]-xcross,y,yinc);
			}
			for(x=xb1[w];x<xcross;x++) mostbuf[x] = 0;
		}
		if (mostbuf[xcross] < 0) mostbuf[xcross] = 0;
		return(bad);
	}

	if ((bad&0xc) > 0)
	{
		inty = z / globaldclip;
		intx = rx1[w]+scale(inty-ry1[w],rx2[w]-rx1[w],ry2[w]-ry1[w]);
		xcross = ((intx*halfxdimen)/inty)+halfxdimen;
		if (intx > 0) xcross--;

		if ((bad&0xc) == 8)
		{
			if (xb1[w] <= xcross)
			{
				y = divscale16(z,yb1[w]);
				yy = divscale16(z,inty);
				if (xdimen != 320)
				{
					y = mulscale16(y,xdimenscale);
					yy = mulscale16(yy,xdimenscale);
				}
				yinc = (yy-y) / (xcross-xb1[w]+1);
				y += (globalhoriz<<16);
				qinterpolatedown16short((long)(&mostbuf[xb1[w]]),xcross-xb1[w],y,yinc);
			}
			for(x=xcross+1;x<=xb2[w];x++) mostbuf[x] = ydimen;
		}
		else
		{
			if (xcross <= xb2[w])
			{
				y = divscale16(z,inty);
				yy = divscale16(z,yb2[w]);
				if (xdimen != 320)
				{
					y = mulscale16(y,xdimenscale);
					yy = mulscale16(yy,xdimenscale);
				}
				yinc = (yy-y) / (xb2[w]-xcross+1);
				y += (globalhoriz<<16);
				qinterpolatedown16short((long)(&mostbuf[xcross]),xb2[w]-xcross,y,yinc);
			}
			for(x=xb1[w];x<xcross;x++) mostbuf[x] = ydimen;
		}
		if (mostbuf[xcross] > ydimen) mostbuf[xcross] = ydimen;
		return(bad);
	}

	//(x2-x1)*t - (xb1-halfxdimen)*u = -x1
	//(y2-y1)*t - halfxdimen*u = -y1
	//bot = (rx2[w]-rx1[w])*halfxdimen - (xb1[w]-halfxdimen)*(ry2[w]-ry1[w]);
	//topu = (rx1[w])*(ry2[w]-ry1[w]) - (rx2[w]-rx1[w])*ry1[w];
	//yb = topu*halfxdimen / bot

	if (xdimen == 320)
	{
		y = divscale16(z,yb1[w]);
		yy = divscale16(z,yb2[w]);
	}
	else
	{
		y = scale(z,xdimenscale,yb1[w]);
		yy = scale(z,xdimenscale,yb2[w]);
	}
	yinc = (yy-y) / (xb2[w]-xb1[w]+1);
	qinterpolatedown16short((long)(&mostbuf[xb1[w]]),xb2[w]-xb1[w],y+(globalhoriz<<16),yinc);

	return(bad);
}

rotatesprite (long sx, long sy, long z, short a, short picnum, signed char dashade, char dapalnum, char dastat)
{
	long cosang, sinang, xinc, yinc, zrecip, v, nextv, dax1, dax2, oy, bx, by;
	long i, x, y, x1, y1, x2, y2, x3, y3, p, pinc, bufplc, palookupoffs;
	long xsiz, ysiz, npoints, xv, yv, gx1, gy1, dax, xoff, yoff, yplc, lx, rx;

	if (z <= 16) return;

	if ((picanm[picnum]&192) != 0) picnum += animateoffs(picnum,49152);

	xsiz = tilesizx[picnum]; if (xsiz <= 0) return;
	ysiz = tilesizy[picnum]; if (ysiz <= 0) return;
	xoff = (long)((signed char)((picanm[picnum]>>8)&255))+(xsiz>>1);
	yoff = (long)((signed char)((picanm[picnum]>>16)&255))+(ysiz>>1);

	cosang = sintable[(a+512)&2047]; sinang = sintable[a&2047];

	if ((dastat&2) > 0)  //Auto window size scaling
	{
		sx = ((windowx1+windowx2+1)<<15)+mulscale16(sx-(320<<15),xdimenscale);
		sy = ((windowy1+windowy2+1)<<15)+mulscale16(sy-(200<<15),xdimenscale);
		z = mulscale16(z,xdimenscale);
	}

	zrecip = divscale32(1L,z);
	xv = mulscale14(cosang,zrecip);
	yv = mulscale14(sinang,zrecip);
	cosang = mulscale14(cosang,z);
	sinang = mulscale14(sinang,z);

	ry1[0] = sy - (sinang*xoff + cosang*yoff);
	ry1[1] = ry1[0] + sinang*xsiz;
	ry1[3] = ry1[0] + cosang*ysiz;
	ry1[2] = ry1[1]+ry1[3]-ry1[0];
	i = (windowy1<<16); if ((ry1[0]<i) && (ry1[1]<i) && (ry1[2]<i) && (ry1[3]<i)) return;
	i = (windowy2<<16); if ((ry1[0]>i) && (ry1[1]>i) && (ry1[2]>i) && (ry1[3]>i)) return;

	rx1[0] = sx - (cosang*xoff - sinang*yoff);
	rx1[1] = rx1[0] + cosang*xsiz;
	rx1[3] = rx1[0] - sinang*ysiz;
	rx1[2] = rx1[1]+rx1[3]-rx1[0];
	i = (windowx1<<16); if ((rx1[0]<i) && (rx1[1]<i) && (rx1[2]<i) && (rx1[3]<i)) return;
	i = (windowx2<<16); if ((rx1[0]>i) && (rx1[1]>i) && (rx1[2]>i) && (rx1[3]>i)) return;

	gx1 = rx1[0]; gy1 = ry1[0];   //back up these before clipping
	if ((npoints = clippoly4()) < 3) return;

	lx = rx1[0]; rx = rx1[0];

	nextv = 0;
	for(v=npoints-1;v>=0;v--)
	{
		x1 = rx1[v]; x2 = rx1[nextv];
		dax1 = (x1>>16); lx = min(lx,x1);
		dax2 = (x2>>16); rx = max(rx,x1);
		if (dax1 != dax2)
		{
			y1 = ry1[v]; y2 = ry1[nextv];
			yinc = divscale16(y2-y1,x2-x1);
			if (dax2 > dax1)
			{
				yplc = y1 + mulscale16((dax1<<16)+65535-x1,yinc);
				qinterpolatedown16short((long)(&uplc[dax1]),dax2-dax1-1,yplc,yinc);
			}
			else
			{
				yplc = y2 + mulscale16((dax2<<16)+65535-x2,yinc);
				qinterpolatedown16short((long)(&dplc[dax2]),dax1-dax2-1,yplc,yinc);
			}
		}
		nextv = v;
	}

	if (waloff[picnum] == 0) loadtile(picnum);
	setgotpic(picnum);
	bufplc = waloff[picnum];

	dashade = max(min(dashade,numpalookups-1),0);
	palookupoffs = FP_OFF(palookup[dapalnum]) + (((long)dashade)<<8);

	if ((dastat&1) == 0)
		setupspritevline(palookupoffs,(yv>>16)*ysiz,yv<<16,ysiz,xv,0L);
	else
		tsetupspritevline(palookupoffs,(yv>>16)*ysiz,yv<<16,ysiz,xv,0L);

	x1 = (lx>>16); x2 = (rx>>16);

	oy = uplc[x1];
	x3 = (x1<<16)+65535-gx1; y3 = (oy<<16)+65535-gy1;
	bx = doublemulscale16(y3,yv,x3,xv);
	by = doublemulscale16(y3,xv,-x3,yv);
	for(x=x1;x<x2;x++)
	{
		y1 = max(uplc[x],startumost[x]);
		y2 = min(dplc[x],startdmost[x]);

		if (y2 > y1)
		{
			if (oy != y1) i = y1-oy, oy = y1, bx += yv*i, by += xv*i;

			if (chainnumpages >= 2)
			{
				koutpw(0x3c4,(256<<(x&3))+2);
				if ((dastat&1) != 0) koutpw(0x3ce,4+((x&3)<<8));
				p = ylookup[y1] + (x>>2) + chainplace;
			}
			else
				p = ylookup[y1] + x+frameplace;

			if ((dastat&1) == 0)
				spritevline(0L,by<<16,y2-y1+1,bx<<16,(bx>>16)*ysiz+(by>>16)+bufplc,p);
			else
				tspritevline(0L,by<<16,y2-y1+1,bx<<16,(bx>>16)*ysiz+(by>>16)+bufplc,p);

		}
		bx += xv; by -= yv;
	}

	faketimerhandler();
}

clippoly4()   //Assume npoints=4 with polygon on &rx1,&ry1
{
	long n, nn, z, zz, x, x1, x2, y, y1, y2, t;
	long cx1, cy1, cx2, cy2;

	cx1 = windowx1;
	cy1 = windowy1;
	cx2 = windowx2;
	cy2 = windowy2+1;
	cx1 <<= 16; cy1 <<= 16; cx2 <<= 16; cy2 <<= 16;

	nn = 0; z = 0;
	do
	{
		zz = ((z+1)&3);
		x1 = rx1[z]; x2 = rx1[zz]-x1;

		if ((cx1 <= x1) && (x1 <= cx2))
			rx2[nn] = x1, ry2[nn] = ry1[z], nn++;

		if (x2 <= 0) x = cx2; else x = cx1;
		t = x-x1;
		if (((t-x2)^t) < 0)
			rx2[nn] = x, ry2[nn] = ry1[z]+scale(t,ry1[zz]-ry1[z],x2), nn++;

		if (x2 <= 0) x = cx1; else x = cx2;
		t = x-x1;
		if (((t-x2)^t) < 0)
			rx2[nn] = x, ry2[nn] = ry1[z]+scale(t,ry1[zz]-ry1[z],x2), nn++;

		z = zz;
	} while (z != 0);
	if (nn < 3) return(0);

	n = 0; z = 0;
	do
	{
		zz = z+1; if (zz == nn) zz = 0;
		y1 = ry2[z]; y2 = ry2[zz]-y1;

		if ((cy1 <= y1) && (y1 <= cy2))
			ry1[n] = y1, rx1[n] = rx2[z], n++;

		if (y2 <= 0) y = cy2; else y = cy1;
		t = y-y1;
		if (((t-y2)^t) < 0)
			ry1[n] = y, rx1[n] = rx2[z]+scale(t,rx2[zz]-rx2[z],y2), n++;

		if (y2 <= 0) y = cy1; else y = cy2;
		t = y-y1;
		if (((t-y2)^t) < 0)
			ry1[n] = y, rx1[n] = rx2[z]+scale(t,rx2[zz]-rx2[z],y2), n++;

		z = zz;
	} while (z != 0);
	return(n);
}

makepalookup(long palnum, char *remapbuf, signed char r, signed char g, signed char b, char dastat)
{
	char col, *ptr, *ptr2, ravg, gavg, bavg;
	long i, j, k, dist, mindist, palscale;

	if (paletteloaded == 0) return;

	if (palookup[palnum] == NULL)
	{
			//Allocate palookup buffer
		if ((palookup[palnum] = (char *)malloc(numpalookups<<8)) == NULL)
		{
			cachesize -= (numpalookups<<8);
			initcache(FP_OFF(pic),cachesize);
			palookup[palnum] = (char *)(FP_OFF(pic)+cachesize);
		}
	}

	if (dastat == 0) return;
	if ((r|g|b|63) != 63) return;

	if ((r|g|b) == 0)
	{
		for(i=0;i<256;i++)
		{
			ptr = (char *)(FP_OFF(palookup[0])+remapbuf[i]);
			ptr2 = (char *)(FP_OFF(palookup[palnum])+i);
			for(j=0;j<numpalookups;j++)
				{ *ptr2 = *ptr; ptr += 256; ptr2 += 256; }
		}
	}
	else
	{
		ptr2 = (char *)FP_OFF(palookup[palnum]);
		for(i=0;i<numpalookups;i++)
		{
			palscale = divscale16(i,numpalookups);
			for(j=0;j<256;j++)
			{
				ptr = (char *)(FP_OFF(palette)+remapbuf[j]*3);
				ravg = 64 - (ptr[0] + mulscale16(r-ptr[0],palscale));
				gavg = 64 - (ptr[1] + mulscale16(g-ptr[1],palscale));
				bavg = 64 - (ptr[2] + mulscale16(b-ptr[2],palscale));

				mindist = 0x7fffffff;
				ptr = (char *)(FP_OFF(palette)+255*3);
				for(k=255;k>=0;k--,ptr-=3)
				{
					dist = gdist[ptr[1]+gavg]; if (dist >= mindist) continue;
					dist += rdist[ptr[0]+ravg]; if (dist >= mindist) continue;
					dist += bdist[ptr[2]+bavg]; if (dist >= mindist) continue;
					mindist = dist; col = k;
				}
				*ptr2++ = col;
			}
		}
	}
}

setvesamode(short vesamode)
{
	static struct rminfo
	{
		long EDI, ESI, EBP, ESP, EBX, EDX, ECX, EAX;
		short flags, ES, DS, FS, GS, IP, CS, SP, SS;
	} RMI;

	union REGS regs;
	struct SREGS sregs;
	short selector, segment;
	short *ptr, gran;

	memset(&sregs,0,sizeof(sregs));
	regs.w.ax = 0x0100;
	regs.w.bx = (256>>4);             //Number of paragraphs
	int386x(0x31,&regs,&regs,&sregs); // DPMI call 100h allocates DOS memory
	segment = regs.w.ax;
	selector = regs.w.dx;

	memset(&RMI,0,sizeof(RMI));    // Set up real-mode call structure
	RMI.EAX = 0x00004f01;
	RMI.ECX = (long)vesamode;
	RMI.ES = segment;
	RMI.EDI = 0;

	regs.w.ax = 0x0300;            // Use DMPI call 300h to issue the DOS interrupt
	regs.h.bl = 0x10;
	regs.h.bh = 0;
	regs.w.cx = 0;
	sregs.es = FP_SEG(&RMI);
	regs.x.edi = FP_OFF(&RMI);
	int386x(0x31,&regs,&regs,&sregs);

	if ((RMI.EAX&65535) != 0x004f)
		return(-1);

	ptr = (short *)((((long)segment)<<4)+4);
	gran = 64 / (*ptr);
	vesapageshift = 0;
	while (gran > 1)
	{
		vesapageshift++;
		gran >>= 1;
	}

	if (vesasetmode(vesamode) != 0x4f)
		return(-1);

	return(0);
}

stereoinit()
{
	long i;

	setverts(510L,487L,0L,479L,12L,479L);

	outp(0x3d4,0x38); outp(0x3d5,0x48);           //S3 Extensions enable #1
	outp(0x3d4,0x39); outp(0x3d5,0xa5);           //S3 Extensions enable #2
	outp(0x3d4,0x31); outp(0x3d5,inp(0x3d5)|9);   //Init for start address

	outp(0x3d4,0x9); outp(0x3d5,inp(0x3d5)&(255-1));
}

setverts(long vertotal, long startverblank, long endverblank,
			long veretstart, long veretend, long verdispenab)
{
	char oflow;

	outp(0x3d4,0x11); outp(0x3d5,inp(0x3d5)&127);
	outp(0x3d4,0x6); outp(0x3d5,vertotal&255);

	oflow = 0;
	oflow += ((vertotal&256)>>8);
	oflow += ((verdispenab&256)>>7);
	oflow += ((veretstart&256)>>6);
	oflow += ((startverblank&256)>>5);
	oflow += ((vertotal&512)>>4);
	oflow += ((verdispenab&512)>>3);
	oflow += ((veretstart&512)>>2);
	outp(0x3d4,0x7); outp(0x3d5,(inp(0x3d5)&0x10)|oflow);

	outp(0x3d4,0x9); outp(0x3d5,(inp(0x3d5)&(255-32))|((startverblank&512)>>4));
	outp(0x3d4,0x10); outp(0x3d5,veretstart&255);
	outp(0x3d4,0x11); outp(0x3d5,(inp(0x3d5)&0xf0)+(veretend&15));
	outp(0x3d4,0x12); outp(0x3d5,verdispenab&255);
	outp(0x3d4,0x15); outp(0x3d5,startverblank&255);
	outp(0x3d4,0x16); outp(0x3d5,endverblank&255);

	outp(0x3d4,0x9); outp(0x3d5,inp(0x3d5)&(255-1));
}

stereoblit(long dastereopage, char *stereobuf)
{
	if (stereopixelwidth >= 0)
	{
		if (dastereopage == 0)
		{
			outp(0x3d4,0x35); outp(0x3d5,page+0); copybuf(stereobuf+stereopixelwidth,0xa0000,64000>>2);
		}
		else
		{
			outp(0x3d4,0x35); outp(0x3d5,page+1); copybuf(stereobuf,0xa4000,49152>>2);
			outp(0x3d4,0x35); outp(0x3d5,page+2); copybuf(stereobuf+49152,0xa0000,14848>>2);
		}
	}
	else
	{
	}
}

setbrightness(char dabrightness)
{
	char *ptr;
	long i, j, dist, daval;

	curbrightness = (long)dabrightness;
	if (curbrightness < 0) curbrightness = 0;
	if (curbrightness > 15) curbrightness = 15;

	if (ooption0 == 6)
	{
		for(i=0;i<256;i++)
		{
			dist = palette[i*3]+palette[i*3+1]+palette[i*3+2];
			dist >>= 1;
			ptr = (char *)(FP_OFF(palookup[0])+i);
			for(j=0;j<32;j++)
			{
				daval = ((dist*(31-j))>>7);
				if (daval > 15) daval = 15;
				*ptr = daval;
				ptr += 256;
			}
		}

		koutp(0x3c8,0);
		for(j=0;j<16;j++)
			for(i=0;i<16;i++)
			{
				koutp(0x3c9,britable[curbrightness][i<<2]);
				koutp(0x3c9,0);
				koutp(0x3c9,britable[curbrightness][j<<2]);
			}
	}
	else
	{
		koutp(0x3c8,0);
		for(i=0;i<768;i++)
			koutp(0x3c9,britable[curbrightness][palette[i]]);
	}
}

drawmapview (long dax, long day, long zoome, short ang)
{
	long tilenum, xoff, yoff, i, j, k, l, cosang, sinang, xspan, yspan;
	long xrepeat, yrepeat, x, y, x1, y1, x2, y2, x3, y3, x4, y4, bakx1, baky1;
	long xvect, yvect, s, w, ww, ox, oy, startwall, endwall;
	long bakgxvect, bakgyvect, sortnum, gap, npoints;
	struct walltype *wal;
	struct sectortype *sec;
	struct spritetype *spr;

	clearbuf((long)(&gotsector[0]),(long)((numsectors+31)>>5),0L);

	zoome <<= 8;
	bakgxvect = divscale28(sintable[(1536-ang)&2047],zoome);
	bakgyvect = divscale28(sintable[(2048-ang)&2047],zoome);
	xvect = mulscale8(sintable[(2048-ang)&2047],zoome);
	yvect = mulscale8(sintable[(1536-ang)&2047],zoome);

	if (chainnumpages > 0) koutp(0x3c4,2);

	sortnum = 0;
	for(s=0,sec=&sector[s];s<numsectors;s++,sec++)
		if ((show2dsector[s>>3]&(1<<(s&7))) != 0)
		{
			npoints = 0; i = 0;
			startwall = sec->wallptr; endwall = startwall + sec->wallnum;
			for(w=startwall,wal=&wall[startwall];w<endwall;w++,wal++)
			{
				ox = wal->x - dax; oy = wal->y - day;
				x = doublemulscale12(ox,xvect,-oy,yvect) + (xdim<<15);
				y = doublemulscale12(oy,xvect,ox,yvect) + (ydim<<15);
				i |= (1<<(x<0)) | (4<<(x>=(xdim<<16)));
				i |= (16<<(y<0)) | (64<<(y>=(ydim<<16)));
				rx1[npoints] = x;
				ry1[npoints] = y;
				xb1[npoints] = wal->point2 - startwall;
				npoints++;
			}
			if ((i&0x55) == 0) continue;
			bakx1 = rx1[0]; baky1 = ry1[0];
			if ((i&0xaa) != 0)
			{
				npoints = clippoly(npoints,i);
				if (npoints < 3) continue;
			}

				//Collect floor sprites to draw
			for(i=headspritesect[s];i>=0;i=nextspritesect[i])
				if ((sprite[i].cstat&48) == 32)
				{
					if ((sprite[i].cstat&(64+8)) == (64+8)) continue;
					thesprite[sortnum++] = i;
				}

			gotsector[s>>3] |= (1<<(s&7));

			globalorientation = (long)sec->floorstat;
			if ((globalorientation&1) != 0) continue;

			if (palookup[sec->floorpal] != globalpalwritten)
			{
				globalpalwritten = palookup[sec->floorpal];
				setpalookupaddress(globalpalwritten);
			}
			globalpicnum = sec->floorpicnum;
			if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
			setgotpic(globalpicnum);
			if ((tilesizx[globalpicnum] <= 0) || (tilesizy[globalpicnum] <= 0)) continue;
			if ((picanm[globalpicnum]&192) != 0) globalpicnum += animateoffs((short)globalpicnum,s);
			if (waloff[globalpicnum] == 0) loadtile(globalpicnum);
			globalbufplc = waloff[globalpicnum];
			globalshade = max(min(sec->floorshade,numpalookups-1),0);
			globalpolytype = 0;
			if ((globalorientation&64) == 0)
			{
				globalposx = dax; globalx1 = bakgxvect; globaly1 = bakgyvect;
				globalposy = day; globalx2 = bakgxvect; globaly2 = bakgyvect;
			}
			else
			{
				ox = wall[wall[startwall].point2].x - wall[startwall].x;
				oy = wall[wall[startwall].point2].y - wall[startwall].y;
				i = ksqrtasm(ox*ox+oy*oy); if (i == 0) continue;
				i = 1048576/i;
				globalx1 = mulscale10(doublemulscale10(ox,bakgxvect,oy,bakgyvect),i);
				globaly1 = mulscale10(doublemulscale10(ox,bakgyvect,-oy,bakgxvect),i);
				ox = (bakx1>>8)-(xdim<<7); oy = (baky1>>8)-(ydim<<7);
				globalposx = doublemulscale28(-oy,globalx1,-ox,globaly1);
				globalposy = doublemulscale28(-ox,globalx1,oy,globaly1);
				globalx2 = -globalx1;
				globaly2 = -globaly1;
			}
			if ((globalorientation&8) == 0)
			{
				globalxshift = (8-(picsiz[globalpicnum]&15));
				globalyshift = (8-(picsiz[globalpicnum]>>4));
			}
			else if (picsiz[globalpicnum] == 0x66)
				{ globalxshift = 3; globalyshift = 3; }
			else
				{ globalxshift = 2; globalyshift = 2; }

			sethlinesizes(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4,globalbufplc);

			if ((globalorientation&0x4) > 0)
			{
				i = globalposx; globalposx = -globalposy; globalposy = -i;
				i = globalx2; globalx2 = globaly1; globaly1 = i;
				i = globalx1; globalx1 = -globaly2; globaly2 = -i;
			}
			if ((globalorientation&0x10) > 0) globalx1 = -globalx1, globaly1 = -globaly1, globalposx = -globalposx;
			if ((globalorientation&0x20) > 0) globalx2 = -globalx2, globaly2 = -globaly2, globalposy = -globalposy;
			asm1 = (globaly1<<globalxshift);
			asm2 = (globalx2<<globalyshift);
			globalx1 <<= globalxshift;
			globaly2 <<= globalyshift;
			globalposx = (globalposx<<(20+globalxshift))+(((long)sec->floorxpanning)<<24);
			globalposy = (globalposy<<(20+globalyshift))-(((long)sec->floorypanning)<<24);

			fillpolygon(npoints);
		}

	gap = sortnum;  //Sort sprite list
	do
	{
		gap >>= 1;
		for(i=sortnum-gap-1;i>=0;i--)
		{
			j = i;
			while ((sprite[thesprite[j]].z > sprite[thesprite[j+gap]].z) && (j >= 0))
			{
				k = thesprite[j]; thesprite[j] = thesprite[j+gap]; thesprite[j+gap] = k;
				j -= gap;
			}
		}
	}
	while (gap > 1);

	for(s=sortnum-1;s>=0;s--)
	{
		spr = &sprite[thesprite[s]];
		if ((spr->cstat&48) == 32)
		{
			npoints = 0;

			tilenum = spr->picnum;
			xoff = (long)((signed char)((picanm[tilenum]>>8)&255))+((long)spr->xoffset);
			yoff = (long)((signed char)((picanm[tilenum]>>16)&255))+((long)spr->yoffset);
			if ((spr->cstat&4) > 0) xoff = -xoff;
			if ((spr->cstat&8) > 0) yoff = -yoff;

			k = spr->ang;
			cosang = sintable[(k+512)&2047]; sinang = sintable[k];
			xspan = tilesizx[tilenum]; xrepeat = spr->xrepeat;
			yspan = tilesizy[tilenum]; yrepeat = spr->yrepeat;

			ox = ((xspan>>1)+xoff)*xrepeat; oy = ((yspan>>1)+yoff)*yrepeat;
			x1 = spr->x + mulscale(sinang,ox,16) + mulscale(cosang,oy,16);
			y1 = spr->y + mulscale(sinang,oy,16) - mulscale(cosang,ox,16);
			l = xspan*xrepeat;
			x2 = x1 - mulscale(sinang,l,16);
			y2 = y1 + mulscale(cosang,l,16);
			l = yspan*yrepeat;
			k = -mulscale(cosang,l,16); x3 = x2+k; x4 = x1+k;
			k = -mulscale(sinang,l,16); y3 = y2+k; y4 = y1+k;

			xb1[0] = 1; xb1[1] = 2; xb1[2] = 3; xb1[3] = 0;
			npoints = 4;

			i = 0;

			ox = x1 - dax; oy = y1 - day;
			x = doublemulscale12(ox,xvect,-oy,yvect) + (xdim<<15);
			y = doublemulscale12(oy,xvect,ox,yvect) + (ydim<<15);
			i |= (1<<(x<0)) | (4<<(x>=(xdim<<16)));
			i |= (16<<(y<0)) | (64<<(y>=(ydim<<16)));
			rx1[0] = x; ry1[0] = y;

			ox = x2 - dax; oy = y2 - day;
			x = doublemulscale12(ox,xvect,-oy,yvect) + (xdim<<15);
			y = doublemulscale12(oy,xvect,ox,yvect) + (ydim<<15);
			i |= (1<<(x<0)) | (4<<(x>=(xdim<<16)));
			i |= (16<<(y<0)) | (64<<(y>=(ydim<<16)));
			rx1[1] = x; ry1[1] = y;

			ox = x3 - dax; oy = y3 - day;
			x = doublemulscale12(ox,xvect,-oy,yvect) + (xdim<<15);
			y = doublemulscale12(oy,xvect,ox,yvect) + (ydim<<15);
			i |= (1<<(x<0)) | (4<<(x>=(xdim<<16)));
			i |= (16<<(y<0)) | (64<<(y>=(ydim<<16)));
			rx1[2] = x; ry1[2] = y;

			x = rx1[0]+rx1[2]-rx1[1];
			y = ry1[0]+ry1[2]-ry1[1];
			i |= (1<<(x<0)) | (4<<(x>=(xdim<<16)));
			i |= (16<<(y<0)) | (64<<(y>=(ydim<<16)));
			rx1[3] = x; ry1[3] = y;

			if ((i&0x55) == 0) continue;
			bakx1 = rx1[0]; baky1 = ry1[0];
			if ((i&0xaa) != 0)
			{
				npoints = clippoly(npoints,i);
				if (npoints < 3) continue;
			}

			globalpicnum = spr->picnum;
			if ((globalpicnum & ~(MAXTILES-1)) != 0) globalpicnum = 0;
			setgotpic(globalpicnum);
			if ((tilesizx[globalpicnum] <= 0) || (tilesizy[globalpicnum] <= 0)) continue;
			if ((picanm[globalpicnum]&192) != 0) globalpicnum += animateoffs((short)globalpicnum,s);
			if (waloff[globalpicnum] == 0) loadtile(globalpicnum);
			globalbufplc = waloff[globalpicnum];
			if ((sector[spr->sectnum].ceilingstat&1) > 0)
				globalshade = ((long)sector[spr->sectnum].ceilingshade);
			else
				globalshade = ((long)sector[spr->sectnum].floorshade);
			globalshade = max(min(globalshade+spr->shade+6,numpalookups-1),0);
			asm3 = FP_OFF(palookup[spr->pal]+(globalshade<<8));
			globalpolytype = ((spr->cstat&2)>>1)+1;

				//relative alignment stuff
			ox = x2-x1; oy = y2-y1; i = (65536*16384)/(ox*ox+oy*oy);
			globalx1 = mulscale10(doublemulscale10(ox,bakgxvect,oy,bakgyvect),i);
			globaly1 = mulscale10(doublemulscale10(ox,bakgyvect,-oy,bakgxvect),i);
			ox = y1-y4; oy = x4-x1; i = (65536*16384)/(ox*ox+oy*oy);
			globalx2 = mulscale10(doublemulscale10(ox,bakgxvect,oy,bakgyvect),i);
			globaly2 = mulscale10(doublemulscale10(ox,bakgyvect,-oy,bakgxvect),i);

			ox = picsiz[globalpicnum]; oy = ((ox>>4)&15); ox &= 15;
			if ((1<<ox) != xspan)
			{
				ox++;
				globalx1 = mulscale(globalx1,xspan,ox);
				globaly1 = mulscale(globaly1,xspan,ox);
			}

			bakx1 = (bakx1>>8)-(xdim<<7); baky1 = (baky1>>8)-(ydim<<7);
			globalposx = doublemulscale28(-baky1,globalx1,-bakx1,globaly1);
			globalposy = doublemulscale28(bakx1,globalx2,-baky1,globaly2);

			if ((spr->cstat&2) == 0)
				msethlineshift(ox,oy);
			else
				tsethlineshift(ox,oy);

			if ((spr->cstat&0x4) > 0) globalx1 = -globalx1, globaly1 = -globaly1, globalposx = -globalposx;
			asm1 = (globaly1<<2); globalx1 <<= 2; globalposx <<= (20+2);
			asm2 = (globalx2<<2); globaly2 <<= 2; globalposy <<= (20+2);

			fillpolygon(npoints);
		}
	}
}

clippoly (long npoints, long clipstat)
{
	long z, zz, s1, s2, t, npoints2, start2, z1, z2, z3, z4, splitcnt;
	long cx1, cy1, cx2, cy2;

	cx1 = windowx1;
	cy1 = windowy1;
	cx2 = windowx2;
	cy2 = windowy2+1;
	cx1 <<= 16; cy1 <<= 16; cx2 <<= 16; cy2 <<= 16;

	if ((clipstat&0x22) > 0)   //Need to clip top or left
	{
		npoints2 = 0; start2 = 0; z = 0; splitcnt = 0;
		do
		{
			s2 = cx1-rx1[z];
			do
			{
				zz = xb1[z]; xb1[z] = -1;
				s1 = s2; s2 = cx1-rx1[zz];
				if (s1 < 0)
				{
					rx2[npoints2] = rx1[z]; ry2[npoints2] = ry1[z];
					xb2[npoints2] = npoints2+1; npoints2++;
				}
				if ((s1^s2) < 0)
				{
					rx2[npoints2] = rx1[z]+scale(rx1[zz]-rx1[z],s1,s1-s2);
					ry2[npoints2] = ry1[z]+scale(ry1[zz]-ry1[z],s1,s1-s2);
					if (s1 < 0) p2[splitcnt++] = npoints2;
					xb2[npoints2] = npoints2+1;
					npoints2++;
				}
				z = zz;
			} while (xb1[z] >= 0);

			if (npoints2 >= start2+3)
				xb2[npoints2-1] = start2, start2 = npoints2;
			else
				npoints2 = start2;

			z = 1;
			while ((z < npoints) && (xb1[z] < 0)) z++;
		} while (z < npoints);
		if (npoints2 <= 2) return(0);

		for(z=1;z<splitcnt;z++)
			for(zz=0;zz<z;zz++)
			{
				z1 = p2[z]; z2 = xb2[z1]; z3 = p2[zz]; z4 = xb2[z3];
				s1  = klabs(rx2[z1]-rx2[z2])+klabs(ry2[z1]-ry2[z2]);
				s1 += klabs(rx2[z3]-rx2[z4])+klabs(ry2[z3]-ry2[z4]);
				s2  = klabs(rx2[z1]-rx2[z4])+klabs(ry2[z1]-ry2[z4]);
				s2 += klabs(rx2[z3]-rx2[z2])+klabs(ry2[z3]-ry2[z2]);
				if (s2 < s1)
					{ t = xb2[p2[z]]; xb2[p2[z]] = xb2[p2[zz]]; xb2[p2[zz]] = t; }
			}


		npoints = 0; start2 = 0; z = 0; splitcnt = 0;
		do
		{
			s2 = cy1-ry2[z];
			do
			{
				zz = xb2[z]; xb2[z] = -1;
				s1 = s2; s2 = cy1-ry2[zz];
				if (s1 < 0)
				{
					rx1[npoints] = rx2[z]; ry1[npoints] = ry2[z];
					xb1[npoints] = npoints+1; npoints++;
				}
				if ((s1^s2) < 0)
				{
					rx1[npoints] = rx2[z]+scale(rx2[zz]-rx2[z],s1,s1-s2);
					ry1[npoints] = ry2[z]+scale(ry2[zz]-ry2[z],s1,s1-s2);
					if (s1 < 0) p2[splitcnt++] = npoints;
					xb1[npoints] = npoints+1;
					npoints++;
				}
				z = zz;
			} while (xb2[z] >= 0);

			if (npoints >= start2+3)
				xb1[npoints-1] = start2, start2 = npoints;
			else
				npoints = start2;

			z = 1;
			while ((z < npoints2) && (xb2[z] < 0)) z++;
		} while (z < npoints2);
		if (npoints <= 2) return(0);

		for(z=1;z<splitcnt;z++)
			for(zz=0;zz<z;zz++)
			{
				z1 = p2[z]; z2 = xb1[z1]; z3 = p2[zz]; z4 = xb1[z3];
				s1  = klabs(rx1[z1]-rx1[z2])+klabs(ry1[z1]-ry1[z2]);
				s1 += klabs(rx1[z3]-rx1[z4])+klabs(ry1[z3]-ry1[z4]);
				s2  = klabs(rx1[z1]-rx1[z4])+klabs(ry1[z1]-ry1[z4]);
				s2 += klabs(rx1[z3]-rx1[z2])+klabs(ry1[z3]-ry1[z2]);
				if (s2 < s1)
					{ t = xb1[p2[z]]; xb1[p2[z]] = xb1[p2[zz]]; xb1[p2[zz]] = t; }
			}
	}
	if ((clipstat&0x88) > 0)   //Need to clip bottom or right
	{
		npoints2 = 0; start2 = 0; z = 0; splitcnt = 0;
		do
		{
			s2 = rx1[z]-cx2;
			do
			{
				zz = xb1[z]; xb1[z] = -1;
				s1 = s2; s2 = rx1[zz]-cx2;
				if (s1 < 0)
				{
					rx2[npoints2] = rx1[z]; ry2[npoints2] = ry1[z];
					xb2[npoints2] = npoints2+1; npoints2++;
				}
				if ((s1^s2) < 0)
				{
					rx2[npoints2] = rx1[z]+scale(rx1[zz]-rx1[z],s1,s1-s2);
					ry2[npoints2] = ry1[z]+scale(ry1[zz]-ry1[z],s1,s1-s2);
					if (s1 < 0) p2[splitcnt++] = npoints2;
					xb2[npoints2] = npoints2+1;
					npoints2++;
				}
				z = zz;
			} while (xb1[z] >= 0);

			if (npoints2 >= start2+3)
				xb2[npoints2-1] = start2, start2 = npoints2;
			else
				npoints2 = start2;

			z = 1;
			while ((z < npoints) && (xb1[z] < 0)) z++;
		} while (z < npoints);
		if (npoints2 <= 2) return(0);

		for(z=1;z<splitcnt;z++)
			for(zz=0;zz<z;zz++)
			{
				z1 = p2[z]; z2 = xb2[z1]; z3 = p2[zz]; z4 = xb2[z3];
				s1  = klabs(rx2[z1]-rx2[z2])+klabs(ry2[z1]-ry2[z2]);
				s1 += klabs(rx2[z3]-rx2[z4])+klabs(ry2[z3]-ry2[z4]);
				s2  = klabs(rx2[z1]-rx2[z4])+klabs(ry2[z1]-ry2[z4]);
				s2 += klabs(rx2[z3]-rx2[z2])+klabs(ry2[z3]-ry2[z2]);
				if (s2 < s1)
					{ t = xb2[p2[z]]; xb2[p2[z]] = xb2[p2[zz]]; xb2[p2[zz]] = t; }
			}


		npoints = 0; start2 = 0; z = 0; splitcnt = 0;
		do
		{
			s2 = ry2[z]-cy2;
			do
			{
				zz = xb2[z]; xb2[z] = -1;
				s1 = s2; s2 = ry2[zz]-cy2;
				if (s1 < 0)
				{
					rx1[npoints] = rx2[z]; ry1[npoints] = ry2[z];
					xb1[npoints] = npoints+1; npoints++;
				}
				if ((s1^s2) < 0)
				{
					rx1[npoints] = rx2[z]+scale(rx2[zz]-rx2[z],s1,s1-s2);
					ry1[npoints] = ry2[z]+scale(ry2[zz]-ry2[z],s1,s1-s2);
					if (s1 < 0) p2[splitcnt++] = npoints;
					xb1[npoints] = npoints+1;
					npoints++;
				}
				z = zz;
			} while (xb2[z] >= 0);

			if (npoints >= start2+3)
				xb1[npoints-1] = start2, start2 = npoints;
			else
				npoints = start2;

			z = 1;
			while ((z < npoints2) && (xb2[z] < 0)) z++;
		} while (z < npoints2);
		if (npoints <= 2) return(0);

		for(z=1;z<splitcnt;z++)
			for(zz=0;zz<z;zz++)
			{
				z1 = p2[z]; z2 = xb1[z1]; z3 = p2[zz]; z4 = xb1[z3];
				s1  = klabs(rx1[z1]-rx1[z2])+klabs(ry1[z1]-ry1[z2]);
				s1 += klabs(rx1[z3]-rx1[z4])+klabs(ry1[z3]-ry1[z4]);
				s2  = klabs(rx1[z1]-rx1[z4])+klabs(ry1[z1]-ry1[z4]);
				s2 += klabs(rx1[z3]-rx1[z2])+klabs(ry1[z3]-ry1[z2]);
				if (s2 < s1)
					{ t = xb1[p2[z]]; xb1[p2[z]] = xb1[p2[zz]]; xb1[p2[zz]] = t; }
			}
	}
	return(npoints);
}

fillpolygon(long npoints)
{
	long z, zz, zzz, x1, y1, x2, y2, miny, maxy, x, y, xinc, cnt;
	long ox, oy, bx, by, bxinc, byinc, xend, p, r, day1, day2;
	short *ptr;

	miny = 0x7fffffff; maxy = 0x80000000;
	for(z=npoints-1;z>=0;z--)
		{ y = ry1[z]; miny = min(miny,y); maxy = max(maxy,y); }
	miny = (miny>>16); maxy = (maxy>>16);
	if (miny < 0) miny = 0;
	if (maxy >= ydim) maxy = ydim-1;
	for(y=miny;y<=maxy;y++) dotp[y] = (short *)(doti+(y*16));

	for(z=npoints-1;z>=0;z--)
	{
		zz = xb1[z];
		y1 = ry1[z]; day1 = (y1>>16);
		y2 = ry1[zz]; day2 = (y2>>16);
		if (day1 != day2)
		{
			x1 = rx1[z]; x2 = rx1[zz];
			xinc = divscale16(x2-x1,y2-y1);
			if (day2 > day1)
			{
				x1 += mulscale16((day1<<16)+65535-y1,xinc);
				for(y=day1;y<day2;y++) { *dotp[y]++ = (x1>>16); x1 += xinc; }
			}
			else
			{
				x2 += mulscale16((day2<<16)+65535-y2,xinc);
				for(y=day2;y<day1;y++) { *dotp[y]++ = (x2>>16); x2 += xinc; }
			}
		}
	}

	ptr = (short *)(doti+(miny*16));

	oy = miny+1-(ydim>>1);
	globalposx += oy*globalx1;
	globalposy += oy*globaly2;

	for(y=miny;y<=maxy;y++)
	{
		cnt = dotp[y]-ptr;
		if (cnt != 0)
		{
			if (cnt > 2)
				for(z=cnt-1;z>0;z--)
					for(zz=z-1;zz>=0;zz--)
						if (ptr[z] < ptr[zz])
							zzz = ptr[z], ptr[z] = ptr[zz], ptr[zz] = zzz;
			for(zz=cnt-2;zz>=0;zz-=2)
			{
				x1 = ptr[zz]; x2 = ptr[zz+1];
				if (x1 > x2) z = x1, x1 = x2, x2 = z;
				x2--;
				if (x2 >= x1)
				{
						//maphline
					ox = x1+1-(xdim>>1);
					bx = ox*asm1 + globalposx;
					by = ox*asm2 - globalposy;

					if (globalpolytype < 1)
					{
						if (chainnumpages >= 2)
						{
							ox = asm1; asm1 <<= 2;
							oy = asm2; asm2 <<= 2;
							r = min(x2+1,x1+4); p = ylookup[y]+chainplace;
							if (x1 < r)  //First one
							{
								koutp(0x3c5,1<<((x1+viewoffset)&3));
								hlineasm64(((x2-x1)>>2)+1,0L,globalshade,by,bx,p+((x1+viewoffset)>>2));
								bx += ox; by += oy; x1++;
							}
							while (x1 < r)
							{              
								koutp(0x3c5,1<<((x1+viewoffset)&3));
								hlineasm64(((x2-x1)>>2)+1,-1L,globalshade,by,bx,p+((x1+viewoffset)>>2));
								bx += ox; by += oy; x1++;
							}
							asm1 = ox;
							asm2 = oy;
						}
						else
						{
							p = ylookup[y]+x1+frameplace+viewoffset;
							hlineasm64(x2-x1+1,0L,globalshade,by,bx,p);
						}
					}
					else
					{
						if (chainnumpages >= 2)
						{
							bxinc = asm1; asm1 <<= 2;
							byinc = asm2; asm2 <<= 2;
							p = ylookup[y]+chainplace;
 
							xend = x1+3; if (x2 < xend) xend = x2;

							if (globalpolytype == 1)
							{
								x = x1;
								if (x <= xend)             //First one does self-modifying code
								{
									outp(0x3c5,1<<(x&3));
									mhline(globalbufplc,bx,((x2-x)>>2)<<16,0L,by,p+(x>>2));
									bx += bxinc; by += byinc;
									x++;
								}
								while (x <= xend)          //Rest can skip self-modifying code
								{
									outp(0x3c5,1<<(x&3));
									mhlineskipmodify(globalbufplc,bx,((x2-x)>>2)<<16,0L,by,p+(x>>2));
									bx += bxinc; by += byinc;
									x++;
								}
							}
							else
							{
								koutp(0x3ce,0x4);
 
								x = x1;
								if (x <= xend)             //First one does self-modifying code
								{
									koutp(0x3c5,1<<(x&3)); koutp(0x3cf,x&3);
									thline(globalbufplc,bx,((x2-x)>>2)<<16,0L,by,p+(x>>2));
									bx += bxinc; by += byinc;
									x++;
								}
								while (x <= xend)          //Rest can skip self-modifying code
								{
									koutp(0x3c5,1<<(x&3)); koutp(0x3cf,x&3);
									thlineskipmodify(globalbufplc,bx,((x2-x)>>2)<<16,0L,by,p+(x>>2));
									bx += bxinc; by += byinc;
									x++;
								}                 
							}
							asm1 = bxinc;    //Must restore asm1&asm2
							asm2 = byinc;
						}
						else
						{
							p = ylookup[y]+x1+frameplace;
							if (globalpolytype == 1)
								mhline(globalbufplc,bx,(x2-x1)<<16,0L,by,p);
							else
								thline(globalbufplc,bx,(x2-x1)<<16,0L,by,p);
						}
					}
				}
			}
		}
		globalposx += globalx1;
		globalposy += globaly2;

		ptr += 16;
	}
	faketimerhandler();
}

setxmode(long daxdim, long daydim)
{
	long vlinum;

	koutp(0x3d4,0x11); koutp(0x3d5,(kinp(0x3d5)&0x7f));
	koutpw(0x03d4,0x0014);
	koutpw(0x03d4,0xe317);
	koutpw(0x03c4,0x0604);

	switch(xdim)
	{
		case 256:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0xf3)|0x00));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x5f00);
			koutpw(0x03d4,0x8203);
			koutpw(0x03d4,0x4e04);
			koutpw(0x03d4,0x9605);
			break;
		case 320:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0xf3)|0x00));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x5f00);
			koutpw(0x03d4,0x8203);
			koutpw(0x03d4,0x5404);
			koutpw(0x03d4,0x8005);
			break;
		case 360:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0xf3)|0x04));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x6b00);
			koutpw(0x03d4,0x8e03);
			koutpw(0x03d4,0x5e04);
			koutpw(0x03d4,0x8a05);
			break;
		case 400:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0xf3)|0x04));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x7100 + 0x300);   //Add 0x300 for Ken's ViewSonic17
			koutpw(0x03d4,0x9203);
			koutpw(0x03d4,0x6504);
			koutpw(0x03d4,0x6c04);
			koutpw(0x03d4,0x8205 - 0x100);   //Sub 0x100 for Ken's ViewSonic17
			break;
		default: return(-1);
	}
	koutpw(0x03d4,(((xdim>>2)-1)<<8)+0x1);
	koutpw(0x03d4,((xdim>>2)<<8)+0x2);
	koutpw(0x03d4,((xdim>>3)<<8)+0x13);

	switch(ydim)
	{
		case 300:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0x80));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x4606);
			koutpw(0x03d4,0x1f07);
			koutpw(0x03d4,0x4009);
			koutpw(0x03d4,0x3110);
			koutpw(0x03d4,0x8011);
			koutpw(0x03d4,0x2b12);
			koutpw(0x03d4,0x2f15);
			koutpw(0x03d4,0x4416);
			break;
		case 350:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0x80));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x7c06);
			koutpw(0x03d4,0x1f07);
			koutpw(0x03d4,0x4009);
			koutpw(0x03d4,0x6210);
			koutpw(0x03d4,0x8011);
			koutpw(0x03d4,0x5d12);
			koutpw(0x03d4,0x5d15);
			koutpw(0x03d4,0x7a16);
			break;
		case 360:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0x40));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0xbf06);
			koutpw(0x03d4,0x1f07);
			koutpw(0x03d4,0x4009);
			koutpw(0x03d4,0x8810);
			koutpw(0x03d4,0x8511);
			koutpw(0x03d4,0x6712);
			koutpw(0x03d4,0x6d15);
			koutpw(0x03d4,0xba16);
			break;
		case 400: case 200:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0x40));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0xbf06);
			koutpw(0x03d4,0x1f07);
			koutpw(0x03d4,0x4009);
			koutpw(0x03d4,0x9c10);
			koutpw(0x03d4,0x8e11);
			koutpw(0x03d4,0x8f12);
			koutpw(0x03d4,0x9615);
			koutpw(0x03d4,0xb916);
			break;
		case 480: case 240:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0xc0));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x0d06);
			koutpw(0x03d4,0x3e07);
			koutpw(0x03d4,0x4009);
			koutpw(0x03d4,0xea10);
			koutpw(0x03d4,0xac11);
			koutpw(0x03d4,0xdf12);
			koutpw(0x03d4,0xe715);
			koutpw(0x03d4,0x0616);
			break;
		case 512: case 256:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0xc0));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x2306);
			koutpw(0x03d4,0xb207);
			koutpw(0x03d4,0x6009);
			koutpw(0x03d4,0x0a10);
			koutpw(0x03d4,0xac11);
			koutpw(0x03d4,0xff12);
			koutpw(0x03d4,0x0715);
			koutpw(0x03d4,0x1a16);
			break;
		case 540: case 270:
			koutpw(0x03c4,0x0100);
			koutp(0x03c2,((kinp(0x03cc)&0x3f)|0xc0));
			koutpw(0x03c4,0x0300);
			koutpw(0x03d4,0x3006);
			koutpw(0x03d4,0xf007);
			koutpw(0x03d4,0x6009);
			koutpw(0x03d4,0x2010);
			koutpw(0x03d4,0xa911);
			koutpw(0x03d4,0x1b12);
			koutpw(0x03d4,0x1f15);
			koutpw(0x03d4,0x2f16);
			break;
	}
	switch(ydim)
	{
		case 200: case 240: case 256: case 270:
			vlinum = 1; break;
		case 300: case 350: case 360: case 400: case 480: case 512: case 540:
			vlinum = 0; break;
	}
	koutp(0x3d4,0x09); koutp(0x3d5,((kinp(0x3d5)&0x00e0)|(vlinum&0x001f)));
	return(0);
}

clearview(long dacol)
{
	long totbytes, i;

	if (qsetmode != 200) return;

	dacol += (dacol<<8); dacol += (dacol<<16);
	if (stereofps != 0)
		clearbuf(screen,128000L>>2,dacol);
	else
	{
		if (chainnumpages >= 2)
		{
			koutpw(0x3c4,0x0f02);
			clearbuf(chainplace,(xdim*ydim)>>4,dacol);
		}
		else
			clearbuf(frameplace,(xdim*ydim)>>2,dacol);
	}
	faketimerhandler();
}

clearallviews(long dacol)
{
	long i;

	if (qsetmode != 200) return;
	dacol += (dacol<<8); dacol += (dacol<<16);

	if (stereofps != 0)
	{
		if (ooption0 == 5)
		{
			for(i=0;i<4;i++)
				{ koutpw(0x3d4,0x35+(i<<8)); clearbuf(0xa0000,65536>>2,0L); }
		}
		clearbuf(screen,128000L>>2,dacol);
	}
	else
	{
		if (vidoption == 0)
			{ koutpw(0x3c4,0x0f02); clearbuf(0xa0000,(65536L>>2),0L); }
		if (vidoption == 1) clearbuf(frameplace,(xdim*ydim)>>2,0L);
		if (vidoption == 2)
		{
			for(i=0;i<4;i++)
				{ koutp(0x3cd,i); clearbuf(0xa0000,16000L,0L); }
		}
		if (vidoption == 3)
		{
			for(i=0;i<4;i++)
				{ koutpw(0x3ce,0x9+(i<<12)); clearbuf(0xa0000,16000L,0L); }
		}
		if (vidoption == 4)
		{
			for(i=0;i<4;i++)
				{ koutpw(0x3d4,0x35+(i<<8)); clearbuf(0xa0000,16000L,0L); }
		}
	}
	faketimerhandler();
}

plotpixel(long x, long y, char col)
{
	if (chainnumpages >= 2)
	{
		outpw(0x3c4,2+(256<<(x&3)));
		drawpixel(ylookup[y]+(x>>2)+chainplace,(long)col);
	}
	else
	{
		drawpixel(ylookup[y]+x+frameplace,(long)col);
	}
}

char getpixel(long x, long y)
{
	if (chainnumpages >= 2)
	{
		koutpw(0x3ce,4+((x&3)<<8));
		return(readpixel(ylookup[y]+(x>>2)+chainplace));
	}
	else
	{
		return(readpixel(ylookup[y]+x+frameplace));
	}
}
